SystemOrganization addCategory: #'Maui-Customizing'!
SystemOrganization addCategory: #'Maui-Domain'!
SystemOrganization addCategory: #'Maui-Exceptions'!
SystemOrganization addCategory: #'Maui-Info'!
SystemOrganization addCategory: #'Maui-Kernel'!
SystemOrganization addCategory: #'Maui-Messages'!
SystemOrganization addCategory: #'Maui-Morphs'!
SystemOrganization addCategory: #'Maui-SUnit tests'!
SystemOrganization addCategory: #'Maui-Test domains'!
SystemOrganization addCategory: #'Maui-Widgets'!

!MenuMorph methodsFor: '*maui' stamp: 'cmm 8/24/2003 19:16'!
addMauiMessage: aMauiMessage
self maMarked: 'dev'.  "delete me?"
	self
		add: aMauiMessage selector
		target: aMauiMessage receiver
		selector: aMauiMessage selector
		argumentList: aMauiMessage arguments! !

!MenuMorph methodsFor: '*maui' stamp: 'cmm 1/19/2004 23:17'!
canDropIntoMauiMorph

	^false! !

!ByteArray methodsFor: '*maui' stamp: 'cmm 7/8/2004 20:41'!
mauiName

	^ super mauiName "gonna try this.."
"
	^'a ', self size printString, '-byte ByteArray.'"! !

!ProtocolClient class methodsFor: '*maui' stamp: 'cmm 4/9/2004 11:50'!
mauiBasicApi

	^ #(openOnHostNamed: openOnHost:port:)! !

Object subclass: #MauiNotificationHandler
	instanceVariableNames: ''
	classVariableNames: 'DefaultInstance'
	poolDictionaries: ''
	category: 'Maui-Exceptions'!

!MauiNotificationHandler class methodsFor: 'as yet unclassified' stamp: 'cmm 1/2/2005 16:15'!
default

	^DefaultInstance! !

!MauiNotificationHandler class methodsFor: 'as yet unclassified' stamp: 'cmm 1/1/2005 18:33'!
initialize

	DefaultInstance _ self new! !

!MauiNotificationHandler methodsFor: 'as yet unclassified' stamp: 'cmm 1/1/2005 18:32'!
send: aMessage to: anObject

	^[ aMessage sentTo: anObject ]
		on: MaNotification
		do:
			[ : noti | 
			| message |
			Transcript 
				cr; 
				show: noti messageText, ' -- IGNORED!!'.
			noti resume ]! !

!Object methodsFor: '*maui' stamp: 'cmm 7/26/2004 13:20'!
asMauiMorph

	^ MauiMorph newFor: self! !

!Object methodsFor: '*maui' stamp: 'cmm 7/26/2004 12:56'!
asMauiPrototype

	^ MauiPrototype current! !

!Object methodsFor: '*maui' stamp: 'cmm 1/18/2004 15:00'!
isMauiMessageMorph

	^false! !

!Object methodsFor: '*maui' stamp: 'cmm 1/18/2004 14:40'!
isMauiMorph

	^false! !

!Object methodsFor: '*maui' stamp: 'cmm 7/26/2004 13:42'!
isMauiPrototype
	^ false! !

!Object methodsFor: '*maui' stamp: 'cmm 11/2/2003 17:02'!
isMauiValue
	"Answer whether, in Maui, I should always be represented by my own instance of MauiMorph, or whether I should share an instance with another who is my equal."

	^false! !

!Object methodsFor: '*maui' stamp: 'cmm 8/15/2004 22:17'!
maui

	^ MauiWorld maui: self! !

!Object methodsFor: '*maui' stamp: 'cmm 1/20/2004 00:18'!
mauiAdvancedApi
	"Answer an Array of selector Symbols that you wish for instances of this object to have available in the add message menu option."

	| answer |
	^Cursor execute showWhile:
		[ answer _ Set with: #class with: #size with: #printString with: #copy.
		self class withAllSuperclassesDo:
			[ : eachClass |
			(eachClass inheritsFrom: Object) ifTrue:
				[ eachClass selectorsDo:
					[ : eachSelector | 
	(eachSelector = #DoIt or: [ 
					((eachClass organization categoryOfElement: eachSelector) beginsWith: 'private') ])
						ifFalse:
							[ answer add: eachSelector ] ] ] ].
		answer asSortedCollection ]! !

!Object methodsFor: '*maui' stamp: 'cmm 11/1/2003 22:11'!
mauiBasicApi
	"Answer an Array of selector Symbols that you wish for instances of this object to have available in the add message menu option.  This is intended to be just the basic API needed to use this object, not necessarily every single message."

	^#(printString class)! !

!Object methodsFor: '*maui' stamp: 'cmm 12/14/2003 21:45'!
mauiIcon
	"Answers a Form."

	| canvas |
	canvas _ FormCanvas extent: 16@16 depth: Display depth.
	canvas
		fillOval: (0@0 corner: 16@16) 
		color: self mauiIconColor 
		borderWidth: 0 
		borderColor: Color transparent.
	^canvas form! !

!Object methodsFor: '*maui' stamp: 'cmm 12/14/2003 21:47'!
mauiIconColor
	"If using the standard mauiIcon for the iconic view, answer the color of this icon."

	^Color orange! !

!Object methodsFor: '*maui' stamp: 'cmm 1/5/2004 22:13'!
mauiMorphClass

	^MauiRegistry global mauiMorphClassFor: self class! !

!Object methodsFor: '*maui' stamp: 'cmm 1/3/2005 10:58'!
mauiName
	"Answers the name to be displayed when the halos of my MauiMorph are selected."

	^ MauiWorld current nameFor: self name! !

!Object methodsFor: '*maui' stamp: 'cmm 2/11/2003 20:12'!
mauiPreferredHouseGarment

	^MauiHouseGarmentMorph new! !

!Object methodsFor: '*maui' stamp: 'cmm 12/8/2004 22:56'!
mauiReservedViews

	^ { #beDefault.  #beIconic.  #beSmall.  MauiDomainMorph workInProgressView }! !

MenuItemMorph subclass: #MauiMenuItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiMenuItemMorph commentStamp: 'cmm 8/15/2004 15:56' prior: 0!
I was created to allow use of BalloonMorph showing a preview of the Maui view instead of a TextMorph.!

!MauiMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/15/2004 15:00'!
balloonContentsMorph

	^ self valueOfProperty: #balloonContentsMorph! !

!MauiMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/15/2004 15:04'!
balloonContentsMorph: aMorph

	self 
		setProperty: #balloonContentsMorph
		toValue: aMorph! !

!MauiMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/15/2004 15:58'!
mauiBalloonText

	^ self balloonContentsMorph
		ifNil: [ super mauiBalloonText ]
		ifNotNil: [ '' "need a non-nil to satisfy Morph>>wantsBalloon" ]! !

!MauiMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'cmm 1/6/2005 12:29'!
showBalloon: msgString hand: aHand
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."

	| w balloon h |
	self balloonContentsMorph ifNil: [ ^ super showBalloon: msgString hand: aHand ].
	(w _ self world) ifNil: [^ self].
	h _ aHand.
	h ifNil:[ h _ w activeHand].
	balloon _
		MauiBalloonMorph
			contentsMorph: self balloonContentsMorph 
			for: self balloonHelpAligner.
	balloon popUpFor: self hand: h.! !

!MenuItemMorph methodsFor: '*maui' stamp: 'cmm 11/19/2003 22:37'!
isItemForMauiObject

	^target isMauiMessageMorph and: [ selector = #invokeFromUserMenu ]! !

!MenuItemMorph methodsFor: '*maui' stamp: 'cmm 11/19/2003 00:24'!
maCanInvoke

	target ifNil: [ ^false ].
	selector ifNil: [ ^false ].
	^target respondsTo: selector! !

!MenuItemMorph methodsFor: '*maui' stamp: 'cmm 11/19/2003 00:19'!
maIsMenuItemMorph

	^true! !

!MenuItemMorph methodsFor: '*maui' stamp: 'cmm 8/15/2004 15:24'!
mauiBalloonText

	^self isItemForMauiObject
		ifTrue: [ target message receiver class maFirstCommentOrNilAt: target object selector ]
		ifFalse: [ self maCanInvoke ifTrue: [ target class maFirstCommentOrNilAt: selector ] ]! !

TestCase subclass: #MauiTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-SUnit tests'!

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/15/2003 17:20'!
runTestBinaryMessages

	self
		sendBinaryMessages: #(&)
		with: true
		to: false.
	self
		sendBinaryMessages: #(+)
		with: (1 to: 100) asArray
		to: (101 to: 200).
	self
		sendBinaryMessages: #( * + - / )
		with: 2.111
		to: 3.1415926535! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/15/2003 17:21'!
runTestKeywordMessages

	self
		sendKeywordMessages: #(and: eqv: or: xor:) 
		with: true
		to: false.
	self
		sendKeywordMessages: #(detect: count:)
		with: [ : each | each even ]
		to: (1 to: 100) asArray! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/15/2003 17:02'!
runTestUnaryMessages

	self
		sendUnaryMessages: #(not)
		to: false.
	self
		sendUnaryMessages: #(size anyOne)
		to: (101 to: 200).
	self
		sendUnaryMessages: #(abs negated reciprocal)
		to: 3.1415926535.
	self
		sendUnaryMessages: #(asFloat asOop even odd)
		to: 3.
	self
		sendUnaryMessages: #(name scanProcess atEnd)
		to: (MaCollectionContext collection: (1 to: 100) asArray).
	self
		sendUnaryMessages: #(asUppercase asLowercase size)
		to: 'hello'.
	self
		sendUnaryMessages: #(isNil)
		to: nil! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/23/2003 18:23'!
sendBinaryMessages: selectors with: arg to: anObject

	| mauiMorph binaries |
	binaries _ OrderedCollection new.
	mauiMorph _ anObject asMauiMorph openInWorld.
	selectors
		do:
			[ : eachSelector |  | binaryMessage |
			binaryMessage _
				(MauiMessageMorph
					receiver: anObject
					selector: eachSelector)
						invocationStrategy: MauiClickedInvocationStrategy new;
						yourself.
			binaryMessage resultHolderMorph: binaryMessage.
			binaries add: (mauiMorph addMessage: binaryMessage) ].
	mauiMorph world doOneCycleNow.
	binaries
		do:
			[ : eachMessage |
			(eachMessage parameterHolderMorphAt: 1) acceptDroppingMorph: arg asMauiMorph event: nil.
			self shouldnt: [ eachMessage hasResult ].
			eachMessage mouseDown: nil.
			self should: [ eachMessage result object = (eachMessage object sentTo: anObject) ] ].
	mauiMorph delete! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/23/2003 18:23'!
sendKeywordMessages: selectors with: arg to: receiver

	| mauiMorph keywords |
	keywords _ OrderedCollection new.
	mauiMorph _ receiver asMauiMorph openInWorld.
	selectors
		do:
			[ : eachSelector |  | keywordMessage |
			keywordMessage _
				(MauiMessageMorph
					receiver: receiver
					selector: eachSelector)
						invocationStrategy: MauiImmediateInvocationStrategy new;
						yourself.
			keywordMessage resultHolderMorph: keywordMessage.
			keywords add: (mauiMorph addMessage: keywordMessage) ].
	mauiMorph world doOneCycleNow.
	keywords
		do:
			[ : eachMessage |
			(eachMessage parameterHolderMorphAt: 1) acceptDroppingMorph: arg asMauiMorph event: nil.
			self should: [ eachMessage result object = (eachMessage object sentTo: receiver) ] ].
	mauiMorph delete! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 11/12/2003 23:24'!
sendUnaryMessages: selectors to: anObject

	| mauiMorph actions getters |
	"Test these unary's as both actions and getters."
	actions _ OrderedCollection new.
	getters _ OrderedCollection new.
	mauiMorph _ anObject asMauiMorph openInWorld.
	selectors
		do:
			[ : eachSelector | 
			actions add: (mauiMorph addMessage: (mauiMorph newActionMessage: eachSelector receiver: anObject)).
			getters add: (mauiMorph addMessage: (mauiMorph newGetter: eachSelector)) ].
	mauiMorph world doOneCycleNow.
	getters do: [ : each | self should: [ each result object = (each object sentTo: anObject) ] ].
	actions 
		do: 
			[ : each | 
			each mouseDown: nil.
			self should: [ each resultHolderMorph isNil ].
			self shouldnt: [ each hasResult ] ].
	mauiMorph delete! !

!MauiTestCase methodsFor: 'tests' stamp: 'cmm 8/15/2003 16:53'!
testMauiMessages

	self
		runTestUnaryMessages;
		runTestBinaryMessages;
		runTestKeywordMessages! !

ScrollPane subclass: #MauiScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiScrollPane methodsFor: 'as yet unclassified' stamp: 'cmm 1/25/2004 16:14'!
handlesMouseDown: aMouseEvent

	^aMouseEvent yellowButtonPressed
		ifTrue: [ false ]
		ifFalse: [ super handlesMouseDown: aMouseEvent ]! !

!MauiScrollPane methodsFor: '*maui' stamp: 'cmm 1/25/2004 17:12'!
scrollBarWidth: anInteger

	scrollBar width: anInteger! !

!ScrollPane methodsFor: '*maui' stamp: 'cmm 12/11/2004 10:29'!
maFixScrollBar
	"setScrollDeltas just doesn't seem to always work where this does."

	self 
		vResizeScrollBar; 
		resizeScroller; 
		setScrollDeltas! !

!Morph methodsFor: '*maui' stamp: 'cmm 8/25/2003 18:05'!
asMauiMessageUsing: aMauiMorph

	^nil! !

!Morph methodsFor: '*maui' stamp: 'cmm 1/19/2004 23:16'!
canDropIntoMauiMorph

	^true! !

!Morph methodsFor: '*maui' stamp: 'cmm 2/12/2004 00:26'!
isTransferMorph

	^false! !

!Morph methodsFor: '*maui' stamp: 'cmm 12/29/2004 23:53'!
maAllMorphsAlpha: aFloat
	self allMorphsDo:
		[ : each |
		each color: (each color alpha: aFloat) ]! !

!Morph methodsFor: '*maui' stamp: 'cmm 12/30/2004 16:49'!
maBorderColorAlpha: aFloat

	| existingBorderColor |
	existingBorderColor _ self borderColor.
	existingBorderColor isColor ifFalse: [ ^ self ].
	self borderColor: (existingBorderColor alpha: aFloat)! !

!Morph methodsFor: '*maui' stamp: 'cmm 12/30/2004 16:47'!
maColorAlpha: aFloat
	self color: (self color alpha: aFloat)! !

!Morph methodsFor: '*maui' stamp: 'cmm 12/30/2004 16:04'!
maFadeAwayOver: millisecondsDuration

	millisecondsDuration = 0 ifTrue: [ ^ self delete ].
	self
		maSlide: #maTransparency:
		from: self maTransparency
		to: 0.0
		over: millisecondsDuration
		finally: [ self delete ]! !

!Morph methodsFor: '*maui' stamp: 'cmm 9/5/2003 00:14'!
maHasOwner

	^owner notNil! !

!Morph methodsFor: '*maui' stamp: 'cmm 11/19/2003 00:19'!
maIsMenuItemMorph

	^false! !

!Morph methodsFor: '*maui' stamp: 'cmm 12/30/2004 14:51'!
maSlide: selectorSymbol from: startValue to: endValue over: millisecondsDuration finally: aBlock

	| stopwatch |
	millisecondsDuration = 0 maSeconds ifTrue: [ ^ self perform: selectorSymbol with: endValue ].
	stopwatch _ MaStopwatch new start.
	[ [ stopwatch time totalMilliseconds < millisecondsDuration and: [ self isInWorld ] ] whileTrue:
		[ | currentValue |
		currentValue _ ((millisecondsDuration - stopwatch time totalMilliseconds) / millisecondsDuration) asFloat.
		WorldState addDeferredUIMessage:
			[ self
				perform: selectorSymbol
				with: currentValue ].
		(Delay forMilliseconds: 50) wait ].
	WorldState addDeferredUIMessage: [ self perform: selectorSymbol with: endValue ].
	WorldState addDeferredUIMessage: [ aBlock value ] ] fork! !

!Morph methodsFor: '*maui' stamp: 'cmm 12/30/2004 16:04'!
maTransparency
	^ self color alpha! !

!Morph methodsFor: '*maui' stamp: 'cmm 12/30/2004 16:48'!
maTransparency: aFloat
	self
		maColorAlpha: aFloat ";
		
For some reason, Connectors seem to go black with this..
		maBorderColorAlpha: aFloat   "! !

!Morph methodsFor: '*maui' stamp: 'cmm 8/16/2004 16:26'!
mauiDropInto: aMauiMorph event: event at: spacerPosition

	aMauiMorph
		addMorph: self 
		asElementNumber: (spacerPosition max: 1).
	"In case we're custom-layout."
	self position: event hand position! !

!Morph methodsFor: '*maui' stamp: 'cmm 1/3/2005 21:56'!
mauiEnsureOnScreen

	|  worldBounds |
	World doOneCycle.  "Give a headstart on my own extent, so this works."
	((worldBounds _ (self world ifNil: [ World ]) bounds) containsRect: self bounds) ifFalse:
		[self bounds: (self bounds translatedToBeWithin: worldBounds)].! !

!Morph methodsFor: '*maui' stamp: 'cmm 1/10/2005 21:35'!
mauiNoteOutOfWorld
	"I could not use outOfWorld: because it is called more often than I expected, such as when adding a Morph for example (couldn't figure out why).  Therefore, I implement this so I can better control when it happens."

	"I think the only reason we'd ever have dependents is for updating display.  If a Morph is not in the world, it should not leave its dependents hanging around."

	self breakDependents! !

!Morph methodsFor: '*maui' stamp: 'cmm 1/16/2004 00:15'!
nextMauiOwner

	owner ifNil: [ ^ nil ].
	^owner isMauiMorph
		ifTrue: [ owner ]
		ifFalse: [ owner nextMauiOwner ]! !

!Morph methodsFor: '*maui' stamp: 'cmm 7/26/2004 17:36'!
noteInvocationNeeded
	"Normal morphs don't need to be concerned with this, but since MauiMorphs can be contained by regular Morphs, we must respond to it."

	self world ifNil: [ ^ self ].
	self submorphs do: [ : each | each noteInvocationNeeded ]! !

!Morph methodsFor: '*maui-debugging' stamp: 'cmm 7/21/2004 14:32'!
signalWhereInvalid

	self submorphs do:
		[ : each | 
		each == self ifTrue: [ MauiSoftwareError signal ].
		each owner == self ifFalse: [ MauiSoftwareError signal ].
		each signalWhereInvalid ]! !

MaSoftwareError subclass: #MauiSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Exceptions'!

Notification subclass: #MauiSetNotificationHandlerNotification
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Exceptions'!

!MauiSetNotificationHandlerNotification commentStamp: 'cmm 1/3/2004 15:48' prior: 0!
I allow you signal commits to your persistence layer from your domain.  By registering a MaNotificationHandler, all MaNotifications signaled in your software can be handled by the send:to: method you write in your own handler.

To set your handler, you signal me.  I don't inherit from from MaNotification because I will then be handled by the default, do-nothing MaNotificationHandler.!

!MauiSetNotificationHandlerNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 1/2/2004 14:17'!
handler: aMaNotificationHandler  "<-- implement this interface to provide your own handler."

	^self new handler: aMaNotificationHandler! !

!MauiSetNotificationHandlerNotification methodsFor: 'access' stamp: 'cmm 1/2/2004 14:17'!
handler

	^handler! !

!MauiSetNotificationHandlerNotification methodsFor: 'access' stamp: 'cmm 1/2/2004 14:16'!
handler: aMaNotificationHandler

	handler _ aMaNotificationHandler! !

!PasteUpMorph methodsFor: '*maui' stamp: 'cmm 11/17/2004 22:32'!
mauiTransferMorph: aTransferMorph event: anEvent

	| m |
	aTransferMorph dragTransferType = #classList
		ifTrue:
			[ m _ aTransferMorph passenger theNonMetaClass asMauiMorph openInWorld ].
	aTransferMorph dragTransferType = #messageList
		ifTrue:
			[ | message class |
			class _ aTransferMorph passenger key.
			m _ (class isMeta not and: [ (class lookupSelector: aTransferMorph passenger value) notNil ])
				ifTrue:
					[ (self confirm: 'You need a new instance of ', class theNonMetaClass name, ' to use this message.  Shall I create a new instance via #new for you?') ifTrue: [ class new asMauiMorph ] ]
				ifFalse: [ class theNonMetaClass asMauiMorph ].
			m ifNil: [ Cursor normal show.  ^ self ].
			message _ aTransferMorph asMauiMessageUsing: m.
			message
				ifNil: [ ^ self ]
				ifNotNil: [ m addMessage: message ] ].
	m ifNotNil:
		[ m position: anEvent hand position.
		m openInWorld ].
	Cursor normal show! !

!PasteUpMorph methodsFor: '*maui' stamp: 'cmm 1/17/2004 16:19'!
maxMauiExtent

	^(self width*4//5) @ (self height*2//3)! !

!PasteUpMorph methodsFor: '*maui' stamp: 'cmm 1/19/2004 23:08'!
maxMauiExtentFor: aMorph

	| mostParentMauiMorph requiredParentSpace maxExtent |
	mostParentMauiMorph _ aMorph outermostMorphThat: [ : each | each isMauiMorph ].
	requiredParentSpace _ (mostParentMauiMorph isNil or: [ mostParentMauiMorph == aMorph ])
		ifTrue: [ 0@0 ]
		ifFalse:
			[ mostParentMauiMorph listDirection = #leftToRight
				ifTrue: [ (mostParentMauiMorph width-aMorph width)@0 ]
				ifFalse: [ 0@(mostParentMauiMorph height-aMorph height) ] ].
	maxExtent _ (self width*4//5) @ (self height*2//3).
	^(mostParentMauiMorph isNil or: [ mostParentMauiMorph isCustomLayout ])
		ifTrue: [ maxExtent ]
		ifFalse: [ maxExtent - requiredParentSpace ]! !

!Boolean methodsFor: '*maui' stamp: 'cmm 11/2/2003 16:51'!
isMauiValue

	^true! !

!MaStat methodsFor: '*maui' stamp: 'cmm 11/16/2004 21:52'!
mauiBasicApi

	^#(count max mean min sum)! !

!NetNameResolver class methodsFor: '*maui' stamp: 'cmm 4/9/2004 12:09'!
mauiBasicApi

	^ #( localHostAddress localHostName
		addressForName:timeout:
		nameForAddress:timeout: )! !

!Browser methodsFor: '*maui' stamp: 'cmm 1/21/2004 22:54'!
classListMenu: aMenu shifted: shifted
	"Set up the menu to apply to the receiver's class list, honoring the #shifted boolean"

	shifted
		ifTrue:
			[^ self shiftedClassListMenu: aMenu].
self maMarked: 'system override'.  "mauiSelectedClass, below"
	aMenu addList: #(
		-
		('browse full (b)'			browseMethodFull)
		('browse hierarchy (h)'		spawnHierarchy)
		('browse protocol (p)'		browseFullProtocol)
		('maui (m)'					mauiSelectedClass	'visualize this class as a MauiMorph')
		-
		('printOut'					printOutClass)
		('fileOut'					fileOutClass)
		-
		('show hierarchy'			hierarchy)
		('show definition'			editClass)
		('show comment'			editComment)
		-
		('inst var refs...'			browseInstVarRefs)
		('inst var defs...'			browseInstVarDefs)
		-
		('class var refs...'			browseClassVarRefs)
		('class vars'					browseClassVariables)
		('class refs (N)'				browseClassRefs)
		-
		('rename class ...'			renameClass)
		('copy class'				copyClass)
		('remove class (x)'			removeClass)
		-
		('find method...'				findMethod)
		-
		('more...'					offerShiftedClassListMenu)).
	^ aMenu! !

!Browser methodsFor: '*maui' stamp: 'cmm 1/21/2004 22:28'!
mauiSelectedClass

	self selectedClass maui! !

!Symbol methodsFor: '*maui' stamp: 'cmm 2/8/2004 23:41'!
mauiName

	^self asString! !

MaNotification subclass: #MauiNotification
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Exceptions'!

!MauiNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2003 00:47'!
signalResult: anObject
	"Signals the current result of a command executed on a MauiObject."

	^(self result: anObject) signal! !

!MauiNotification methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2003 00:47'!
result

	^result! !

!MauiNotification methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2003 00:48'!
result: anObject

	result _ anObject! !

!CompiledMethod methodsFor: '*maui' stamp: 'cmm 11/21/2003 00:11'!
mauiName

	^String streamContents:
		[ : stream |
		stream 
			nextPutAll: self maMethodClass name;
			nextPutAll: '>>#';
			nextPutAll: self selector ]! !

!Class methodsFor: '*maui' stamp: 'cmm 2/2/2004 22:51'!
mauiBasicApi
	"Answer an Array of selector Symbols that you wish for instances of this object to have available in the add message menu option."

	^#(name instVarNames superclass new methodDictionary subclasses)! !

!MessageSend methodsFor: '*maui-copying' stamp: 'cmm 7/14/2004 13:32'!
maIndependentCopy
	"To make an independentCopy of me, I should have argument independent of the instance I was copied from."

	^ self copy
		arguments: arguments copy ;
		yourself! !

!String methodsFor: '*maui' stamp: 'cmm 7/14/2004 14:37'!
mauiName

	^ self copy "copy because #invoke won't display mauiName message result if result==receiver"! !

!Behavior methodsFor: '*maui' stamp: 'cmm 2/20/2004 17:59'!
maLowestCommonSuperclassWith: aClass

	| startClass other |
	self allSuperclasses size > aClass allSuperclasses size
		ifTrue: [ startClass _ aClass.  other _ self. ]
		ifFalse: [ startClass _ self.  other _ aClass ].
	startClass withAllSuperclassesDo:
		[ : each |
		(other inheritsFrom: each)
			ifTrue:
				[ ^ each ] ].
	MaSoftwareError signal: 'Didn''t expect to not find a common supeclass.'! !

!TransferMorph methodsFor: '*maui' stamp: 'cmm 7/30/2004 11:07'!
asMauiMessageUsing: aMauiMorph
	"Convert myself to a MauiMessageMorph as well as possible.  I calculate the correct class based on the message being dragged."
	| receiver class selector |
	transferType = #messageList ifFalse: [ ^ nil ].
	class _ self passenger key.
	selector _ self passenger value.
	selector isSymbol ifFalse: [ ^nil ].
	receiver _ (aMauiMorph isKindOf: class)
		ifTrue: [ aMauiMorph ]  "a ui message is being dragged"
		ifFalse: [ aMauiMorph object ].  "domain message drag"
	^ (class lookupSelector: selector)
		ifNotNil:
			[ MauiMessageMorph
				receiver: receiver
				selector: selector ]
		ifNil: [ nil ]! !

!TransferMorph methodsFor: '*maui' stamp: 'cmm 2/19/2004 22:35'!
canBeMauiMessageFor: aMauiMorph
	"Convert myself to a MauiMessageMorph as well as possible.  I calculate the correct class based on the message being dragged."
	^ (self mauiReceiverSelectorFor: aMauiMorph) notNil! !

!TransferMorph methodsFor: '*maui' stamp: 'cmm 2/12/2004 00:26'!
isTransferMorph

	^ true! !

!TransferMorph methodsFor: '*maui' stamp: 'cmm 8/13/2004 00:06'!
mauiDropInto: aMauiMorph event: event at: spacerPosition

	| message |
	message _ self asMauiMessageUsing: aMauiMorph.
	aMauiMorph
		addMessage: message 
		at: spacerPosition.
	message position: event hand position - (0@message height)! !

!TransferMorph methodsFor: '*maui' stamp: 'cmm 2/19/2004 22:48'!
mauiReceiverSelectorFor: aMauiMorph

	| receiver class selector |
	self passenger class = Association ifFalse: [ ^nil ].
	class _ self passenger key.
	selector _ self passenger value.
	selector isSymbol ifFalse: [ ^nil ].
	receiver _ (aMauiMorph isKindOf: class)
		ifTrue: [ aMauiMorph ]  "a ui message is being dragged"
		ifFalse:
			[ (aMauiMorph object isKindOf: class)
				ifTrue: [ aMauiMorph object ] ].  "domain message drag"
	^ receiver ifNotNil:
		[ (receiver class lookupSelector: selector) ifNotNil: [ receiver->selector ] ]! !

!HandMorph methodsFor: '*maui-balloon help' stamp: 'cmm 1/3/2005 23:12'!
spawnMauiBalloon: aBalloonMorph for: aMauiMessageMorph

	aBalloonMorph popUpForHand: self! !

RectangleMorph subclass: #MauiMorph
	instanceVariableNames: 'object notificationHandler messageMorphs needsRefreshed priorOwner redButtonMessage spacer label labelBar preferences runningEffects lastRefreshTime'
	classVariableNames: 'CloseBoxImage'
	poolDictionaries: ''
	category: 'Maui-Kernel'!

MauiMorph subclass: #MauiDomainMorph
	instanceVariableNames: 'family view userMessages mauiMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Kernel'!

MauiDomainMorph subclass: #MaProgressorMorph
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MaProgressorMorph methodsFor: 'initializing' stamp: 'cmm 7/26/2004 17:35'!
ensureBar

	(self submorphs includes: bar) ifFalse: [ self addMorph: bar ]! !

!MaProgressorMorph methodsFor: 'initializing' stamp: 'cmm 11/23/2003 23:43'!
ensureNoBar

	bar delete! !

!MaProgressorMorph methodsFor: 'initializing' stamp: 'cmm 1/18/2004 20:27'!
initialize

	super initialize.
	bar _ MaProgressBarMorph new.
	self ensureBar! !

!MaProgressorMorph methodsFor: 'initializing' stamp: 'cmm 11/23/2003 23:45'!
initializeSubmorphs

	super initializeSubmorphs.
	(self hasMessageNamed: #description)
		ifFalse:
			[ self addMessage: ((self newGetter: #description) hideLabels; yourself) ].
	object knowsTaskSize
		ifTrue: [ self ensureBar ]
		ifFalse: [ self ensureNoBar ].
	(self hasMessageNamed: #progressMessage)
		ifFalse:
			[ self addMessage: ((self newGetter: #progressMessage) hideLabels; yourself) ].
	(self hasMessageNamed: #rateMessage)
		ifFalse:
			[ self addMessage: ((self newGetter: #rateMessage) hideLabels; yourself) ]! !

!MaProgressorMorph methodsFor: 'Morphic' stamp: 'cmm 12/6/2004 15:21'!
intoWorld: aWorld

	super intoWorld: aWorld.
	aWorld ifNotNil: [ self startStepping ]! !

!MaProgressorMorph methodsFor: 'accessing' stamp: 'cmm 8/7/2003 16:59'!
progressor

	^object! !

!MaProgressorMorph methodsFor: 'Morphic' stamp: 'cmm 11/12/2003 22:54'!
stepTime

	^150! !

!MaProgressorMorph methodsFor: 'accessing' stamp: 'cmm 11/12/2003 22:40'!
uiBasicApi

	^#(bar), super uiBasicApi! !

!MaProgressorMorph methodsFor: 'copying' stamp: 'cmm 7/21/2004 14:38'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	bar _ bar veryDeepCopyWith: aDeepCopier! !

!MaProgressorMorph methodsFor: 'copying' stamp: 'cmm 7/21/2004 14:52'!
xveryDeepFixupWith: aDeepCopier
self halt.
	super veryDeepFixupWith: aDeepCopier.
	self ensureNoBar! !

MauiDomainMorph subclass: #MauiClientProcessMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiClientProcessMorph methodsFor: 'initialize' stamp: 'cmm 1/4/2005 21:39'!
addControlButtons

	| panel |
	panel _ (self addPanel: self copy beSmall)
		listDirection: #leftToRight ;
		yourself.
	panel
		addMessage: (panel newActionMessage: #suspend receiver: object) ;
		addMessage: (panel newActionMessage: #resume receiver: object) ;
		addMessage: (panel newActionMessage: #pleaseStop receiver: object)! !

!MauiClientProcessMorph methodsFor: 'initialize' stamp: 'cmm 1/4/2005 21:39'!
addProgress

	self addMessage: (self newGetter: #progress) hideLabels; yourself! !

!MauiClientProcessMorph methodsFor: 'initialize' stamp: 'cmm 1/4/2005 21:41'!
initializeSubmorphs

	super initializeSubmorphs.
	self
		listDirection: #topToBottom ;
		wrapDirection: #none.
	self
		addProgress ";
		addControlButtons"! !

MauiDomainMorph subclass: #MauiCollectionMorph
	instanceVariableNames: 'listMorph scrollPane collectionDirty elementsView listEntrySend etcMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 7/26/2004 23:14'!
beIconic

	super beIconic.
	self ensureNoList! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 7/26/2004 22:55'!
beSmall

	super beSmall.
	self ensureNoList! !

!MauiCollectionMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:38'!
buildContextMenu

	| menu |
	menu _ super buildContextMenu.
	self mauiWorld userStrategy
		appendCollectionMenuItemsTo: menu
		for: self.
	^ menu! !

!MauiCollectionMorph methodsFor: 'menu' stamp: 'cmm 1/30/2004 00:24'!
buildElementsViewMenu

	| answer |
	answer _ MenuMorph new.
	self intersectingViews do:
		[ : each | 
		answer
			add: each
			target: self
			selector: #elementsView:
			argument: each ].
	^answer! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 1/5/2005 17:55'!
buildList

	| stopwatch world listObjects x |
	stopwatch _ MaStopwatch new.
	stopwatch start.
	world _ self world.
	world ifNil: [ ^ self ].
	self removeUnwantedMorphs.
	listObjects _ self listObjects.
	x _ 1.
	self collection
		maDo:
			[ : each |  | newListObject |
			(listObjects includes: each) ifFalse:
				[ self
					enterList:
						(newListObject _ family
							newViewNamed: elementsView
							for: each)
					at: x.
				newListObject notificationHandler: self notificationHandler.
				stopwatch time > 500 maMilliseconds 
					ifTrue: 
						[ world doOneCycle. "repaint the screen"
						self fixList.
						world doOneCycle.
						stopwatch restart ] ].
			x _ x + 1 ]
		while: [ self isValidInWorld and: [ self listMorphIsFullyPopulated not ] ].
	self isValidInWorld ifFalse: [ ^ self ].
	self shouldShowEntireList
		ifTrue: [ self ensureNoEtcMorph ]
		ifFalse: [ self ensureEtcMorph ].
	world doOneCycle.
	self 
		fixList ;
		optimizeListSize.
	world doOneCycle! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 8/1/2003 15:25'!
collection

	^self object! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 12/18/2004 18:27'!
collection: aCollection

	self object: aCollection! !

!MauiCollectionMorph methodsFor: 'events and overrides' stamp: 'cmm 1/6/2005 17:34'!
customize: aMauiMessageMorph

	super customize: aMauiMessageMorph.
	"Only do automatic adjustment for the default view, if the user has her own view, she would have laid out aMauiMessageMorph the way she wants."
	(self view = #beDefault
	and: [ self isCustomLayout not ])
		ifTrue:
			[ self listDirection: #topToBottom ]! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 7/25/2004 15:31'!
elementsView: aString

	elementsView = aString ifTrue: [ ^ self ]. "optimization"
	elementsView _ aString.
	self initializeList! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 1/6/2005 18:24'!
ensureEtcMorph

	listMorph submorphs last = etcMorph ifTrue: [ ^ self ]. "optimization"
	etcMorph ifNil: [ etcMorph _ self preferredStringMorph: '... etc ...' ].
	listMorph addMorphBack: etcMorph! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 7/26/2004 23:19'!
ensureList

	scrollPane ifNil:
		[ scrollPane _ ScrollPane new
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			layoutChanged.
		self fixList ].
	(submorphs includes: scrollPane) 
		ifFalse:
			[ self addMorphBack: scrollPane ]! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 7/25/2004 16:19'!
ensureNoEtcMorph

	etcMorph ifNotNil: [ etcMorph delete ]! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 7/26/2004 22:55'!
ensureNoList

	scrollPane ifNotNil: [ scrollPane delete ]! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 12/11/2004 12:40'!
enterList: aMauiMorph at: indexPosition

	listEntrySend ifNotNil:
		[ | sendCopy |
		sendCopy _ listEntrySend receiver setupSend: listEntrySend maIndependentCopy using: aMauiMorph.
		sendCopy value ].
	listMorph 
		addMorph: aMauiMorph
		asElementNumber: indexPosition.
	self world
		ifNotNil:
			[ aMauiMorph noteInvocationNeeded.
			self mauiWorld
				onePlayerFor: aMauiMorph object
				is: aMauiMorph ].
	self optimizeListSize! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 12/11/2004 10:03'!
fixList

	self hasList ifTrue: [ scrollPane maFixScrollBar ]! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 7/26/2004 18:27'!
hasList

	^ scrollPane notNil and: [ scrollPane owner == self ]! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 12/18/2004 18:36'!
initialize

	super initialize.
	self extent: 50@84.
	elementsView _ #beIconic.
	collectionDirty _ true! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 12/18/2004 18:34'!
initializeList

	self world ifNil: [ ^ self ].
	self
		stopStepping ;
		buildList.
	collectionDirty _ false.
	self startStepping! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 7/26/2004 23:13'!
initializeListMorph

	listMorph ifNotNil: [ listMorph delete ].
	listMorph _ self newListMorph.
	self ensureList.  "this is the scroll pane, which we must track too."
	scrollPane scroller addMorphBack: listMorph! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 1/1/2004 12:09'!
initializeSubmorphs

	super initializeSubmorphs.
	self initializeListMorph! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 2/10/2004 00:32'!
intersectingViews

	| uniques |
	uniques _ Set new.
	self listedMauiMorphsDo:
		[ : each |  | eachViews |
		eachViews _ Set new.
		each family
			customViewsFor: each
			do: [ : eachView | eachViews add: eachView ].
		uniques isEmpty
			ifTrue:
				[ uniques _ eachViews ]
			ifFalse:
				[ uniques _ uniques intersection: eachViews ] ].
	uniques addAll: self mauiReservedViews.
	^uniques asSortedCollection! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 12/29/2004 16:33'!
intoWorld: aWorld

	super intoWorld: aWorld.
	"Allow clicks anywhere in the CollectionMorph, not just the outside the scrollPane."
	listMorph
		on: #mouseDown
		send: #mouseDown:
		to: self.
	"Couldn't get this to work, but leaving in to express intent."
	scrollPane
		on: #mouseDown 
		send: #mouseDown: 
		to: self! !

!MauiCollectionMorph methodsFor: 'testing' stamp: 'cmm 1/5/2005 15:53'!
isValidInWorld

	^ self collection isMauiPrototype not
	and: [ self world notNil ]! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 1/5/2005 17:46'!
listCount
	"Answer how many items we have in my list that are part of the underlying collection (e.g., excluding the etcMorph)."

	| count |
	count _ 0.
	self listMorphsDo: [ : each | count _ count + 1 ].
	^ count! !

!MauiCollectionMorph methodsFor: 'testing' stamp: 'cmm 1/5/2005 17:48'!
listMorphIsFullyPopulated

	^ self shouldShowEntireList
		ifTrue: [ self listCount = self collection size ]
		ifFalse: [ self listCount >= (self preferred: #collectionSampleSize) ]! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 12/23/2003 22:48'!
listMorphsDo: aBlock

	listMorph submorphs do: aBlock! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 12/11/2004 11:49'!
listObjects
	| answer |
	answer _ Set new.
	self listedMauiMorphsDo: [ : each | answer add: each object ].
	^ answer! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 12/11/2004 09:36'!
listedMauiMorphsDo: oneArgBlock

	^listMorph submorphs copy
		do:
			[ : each |
			each == etcMorph ifFalse: [ oneArgBlock value: each ] ]! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 12/28/2004 14:03'!
mauiNoteOutOfWorld

	super mauiNoteOutOfWorld.
	self mauiWorld removePlayer: self.
	listMorph eventHandler ifNotNil: [ listMorph eventHandler forgetDispatchesTo: #mouseDown ].
	scrollPane eventHandler ifNotNil: [ scrollPane eventHandler forgetDispatchesTo: #mouseDown ]! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 12/24/2003 13:50'!
newListMorph

	^RectangleMorph new
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 2;
		cellInset: 2;
		borderWidth: 0;
		color: Color transparent;
		cellPositioning: #topLeft;
		yourself! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 7/26/2004 23:00'!
noteNewOwner: aMorph

	super noteNewOwner: aMorph.
	self fixList! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 1/5/2005 16:12'!
object: anObject

	anObject == object ifTrue: [ ^ self ].
	object ifNotNil:
		[ object removeDependent: self.
		anObject addDependent: self ].
	super object: anObject.
	collectionDirty _ true
	! !

!MauiCollectionMorph methodsFor: 'events and overrides' stamp: 'cmm 2/24/2004 23:14'!
onListEntryDo: aMessageSend
	"whenever my list is refreshed and rebuilt, activate aMessageSend to each element in the list that is added."

	listEntrySend _ aMessageSend! !

!MauiCollectionMorph methodsFor: 'list morph' stamp: 'cmm 12/6/2004 17:29'!
optimizeListSize

	| margin world |
	world _ listMorph world ifNil: [ ^ self ].
	margin _ (2*self layoutInset) + (2*self cellInset).
	scrollPane vIsScrollbarShowing ifTrue: [ margin _ margin + scrollPane scrollBarThickness ].
	self extent:
		(((listMorph width @ listMorph height) + margin max: 50@64)
			min: (world maxMauiExtentFor: self))! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 12/30/2004 13:58'!
refreshData

	(self hasList
	and: [ self listMorphIsFullyPopulated not 
	or: [ collectionDirty ] ])
		ifTrue: [ self initializeList ]
		ifFalse: [ self fixList ].
	super refreshData! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 12/29/2004 10:16'!
removeUnwantedMorphs
	"Removes the morphs that are in my that are no longer in my 'collection'."

	self listedMauiMorphsDo:
		[ : each |
		(each view = elementsView
		and: [ self collection includes: each object ]) ifFalse: [ each delete ] ]! !

!MauiCollectionMorph methodsFor: 'testing' stamp: 'cmm 11/19/2003 00:47'!
shouldShowEntireList

	^self collection size <= (self preferred: #collectionSampleSize)! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 12/18/2004 18:32'!
update: anObject

	collectionDirty _ true! !

!MauiCollectionMorph methodsFor: 'copying' stamp: 'cmm 12/18/2004 18:34'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	listMorph _ listMorph veryDeepCopyWith: aDeepCopier.
	listMorph removeAllMorphs.
	scrollPane _ scrollPane veryDeepCopyWith: aDeepCopier.
	collectionDirty _ true.
	listEntrySend _ listEntrySend veryDeepCopyWith: aDeepCopier.
	etcMorph _ etcMorph veryDeepCopyWith: aDeepCopier! !

MauiDomainMorph subclass: #MauiCompositeContextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiCompositeContextMorph methodsFor: 'initializing' stamp: 'cmm 1/4/2005 22:13'!
addInputPanel

	(self addPanel: self copy beSmall)
		listDirection: #leftToRight ;
		addMessage:
			((self newMessageNamed: #keywordsString:)
				labelAt: 1 put: 'Keywords:' ;
				yourself) ;
		addMessageNamed: #refresh! !

!MauiCompositeContextMorph methodsFor: 'initializing' stamp: 'cmm 1/6/2005 23:56'!
addOutputPanel

	| panel message parameterHolder |
	panel _ self addPanel: self copy beSmall.
	message _ panel addMessage:
		((panel newMessageNamed: #subcontextNamed:)
			hideLabels ;
			listDirection: #leftToRight ;
			yourself).
	message invocationStrategy resultView: #showOutputOnly.
	parameterHolder _ (message parameterHolderMorphAt: 1)
		optionalParametersStrategy: MauiListSelectionStrategy new ;
		yourself.
	self context subcontexts do:
		[ : each |
		parameterHolder addOptionalParameter: each name ]! !

!MauiCompositeContextMorph methodsFor: 'accessing' stamp: 'cmm 1/4/2005 22:14'!
context

	^ self object! !

!MauiCompositeContextMorph methodsFor: 'initializing' stamp: 'cmm 1/5/2005 15:31'!
initializeSubmorphs

	super initializeSubmorphs.
	self
		listDirection: #topToBottom ;
		wrapDirection: #none ;
		addInputPanel ;
		addOutputPanel! !

!MauiCompositeContextMorph methodsFor: 'initializing' stamp: 'cmm 1/5/2005 15:12'!
showOutputOnly
	"Show just the output results, not the keyword input fields."

	self
		beSmall ;
		addOutputPanel! !

MauiDomainMorph subclass: #MauiContextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 1/4/2005 21:45'!
addInputPanel

	(self addPanel: self copy beSmall)
		listDirection: #leftToRight ;
		addMessage:
			((self newMessageNamed: #keywordsString:)
				labelAt: 1 put: 'Keywords:' ;
				yourself) ;
		addMessageNamed: #refresh! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 1/8/2005 19:29'!
addOutputPanel

	(self addPanel: self copy beSmall)
		listDirection: #topToBottom ;
		addMessage:
			((self newMessageNamed: #scanProcess)
				labelAt: 1 put: 'progress' ;
				listDirection: #topToBottom ;
				cellPositioning: #leftCenter ;
				invocationStrategy:
					(MauiMouseOverInvocationStrategy new
						resultHolderTarget: 'balloon' ;
						yourself) ;
				resetResultHolderMorph ) ;
		addMessage:
			((self newGetter: #results)
				listDirection: #topToBottom ;
				yourself)! !

!MauiContextMorph methodsFor: 'accessing' stamp: 'cmm 7/13/2003 22:15'!
context

	^self object! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 10/13/2003 22:37'!
initialize

	super initialize.
	self listDirection: #topToBottom! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 1/4/2005 21:28'!
initializeSubmorphs
	self
		addInputPanel ;
		addOutputPanel ;
		listDirection: #topToBottom ;
		wrapDirection: #none! !

!MauiContextMorph methodsFor: 'testing' stamp: 'cmm 8/18/2003 22:14'!
requireChangedNotificationsForAutoRefresh

	^true! !

!MauiContextMorph methodsFor: 'view' stamp: 'cmm 1/5/2005 15:07'!
showOutputOnly
	"Show just the output results, not the keyword input fields."

	self
		beSmall ;
		addOutputPanel! !

MauiDomainMorph subclass: #MauiDateMorph
	instanceVariableNames: 'stringMorph standardColor pointerOverColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiDateMorph methodsFor: 'view' stamp: 'cmm 1/5/2004 21:50'!
beIconic

	stringMorph delete.
	super beIconic! !

!MauiDateMorph methodsFor: 'events and overrides' stamp: 'cmm 1/5/2004 21:50'!
delineate

	stringMorph color: pointerOverColor! !

!MauiDateMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 17:19'!
initialize

	super initialize.
	self useSquareCorners.
	pointerOverColor _ Color lightYellow.
	standardColor _ Color yellow.
	stringMorph _
		StringMorph new 
			color: standardColor ; 
			yourself! !

!MauiDateMorph methodsFor: 'events and overrides' stamp: 'cmm 12/27/2004 17:20'!
initializeSubmorphs

	super initializeSubmorphs.
	(self includesMorphAnywhere: stringMorph) ifFalse: [ self addMorphBack: stringMorph ].
	self
		layoutInset: 0@0 ;
		beInvisible! !

!MauiDateMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 17:09'!
postInitialize

	super postInitialize.
	self resetContents! !

!MauiDateMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 17:16'!
resetContents
	stringMorph contents: object asString! !

!MauiDateMorph methodsFor: 'events and overrides' stamp: 'cmm 1/5/2004 21:50'!
undelineate

	stringMorph color: standardColor! !

MauiDomainMorph subclass: #MauiDocMorph
	instanceVariableNames: 'scriptContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiDocMorph methodsFor: 'accessing' stamp: 'cmm 1/26/2004 16:20'!
document

	^self object! !

!MauiDocMorph methodsFor: 'Morphic' stamp: 'cmm 1/26/2004 23:31'!
handlesMouseOverDragging: evt

	^false! !

!MauiDocMorph methodsFor: 'initializing' stamp: 'cmm 1/6/2005 12:16'!
initialize

	super initialize.
	self
		listDirection: #leftToRight ; 
		wrapDirection: #none ;
		cellPositioning: #leftCenter! !

!MauiDocMorph methodsFor: 'initializing' stamp: 'cmm 1/6/2005 12:20'!
initializeSubmorphs

	self document elementsDo:
		[ : eachObject | 
		self addMorphBack: eachObject asMauiMorph ]! !

!MauiDocMorph methodsFor: 'performance' stamp: 'cmm 1/26/2004 16:36'!
requireChangedNotificationsForAutoRefresh

	^true! !

!MauiDomainMorph class methodsFor: 'private' stamp: 'cmm 1/5/2005 22:58'!
maNewFor: anObject

	^ (super maNewFor: anObject)
		view: #beDefault ;
		yourself! !

!MauiDomainMorph class methodsFor: 'private' stamp: 'cmm 7/29/2004 17:12'!
workInProgressView

	^ 'work-in-progress'! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 1/4/2005 20:28'!
addPanel: aMauiDomainMorph
	"To layout in multiple directions, add a copy of myself to me and layout messages inside that however you wish.  aMauiDomainMorph must represent the same object as me."

	^ self
		addPanel: aMauiDomainMorph
		at: (self submorphs size + 1)! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 1/6/2005 23:41'!
addPanel: aMauiDomainMorph at: index
	"To layout in multiple directions, add a copy of myself to me and layout messages inside that however you wish.  aMauiDomainMorph must represent the same object as me."

	aMauiDomainMorph object == self object ifFalse: [ MauiUserError signal: 'Only another view of myself can integrate with me.  This is a view of a different object.' ].
	self == aMauiDomainMorph ifTrue: [ MauiUserError signal: 'I cannot be added to myself.  To create a panel add a copy of me to myself.' ].
	(submorphs includes: aMauiDomainMorph) ifFalse:
		[ self
			addMorph: aMauiDomainMorph
			asElementNumber: index.
		aMauiDomainMorph borderColor: #complexInset ].
	^ mauiMorphs add: aMauiDomainMorph! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:38'!
addUserMenuTo: aMenu

	userMessages notEmpty ifTrue: [ aMenu addLine ].
	userMessages do:
		[ : each |
		aMenu
			add: (self mauiWorld nameFor: each message selector)
			target: each
			selector: #invokeFromUserMenu ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 12/15/2004 23:49'!
addUserMessage: aMauiMessageMorph

	userMessages
		maDetect: [ : each | each message sameEffectAs: aMauiMessageMorph message ]
		ifFound:
			[ : foundMessageMorph | 
			userMessages 
				at: (userMessages indexOf: foundMessageMorph)
				put: aMauiMessageMorph ]
		ifNone: [ userMessages add: aMauiMessageMorph ]! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 8/15/2004 15:48'!
addViewsMenuTo: aMenu

	aMenu addLine.
	self sortedViewsDo:
		[ : each |  | menuItem sketch |
		menuItem _ 
			(MauiMenuItemMorph new
				contents: each ;
				target: self ;
				selector: #as:resetTargetNamed:in: ;
				arguments: { each.  each.  aMenu }).
		sketch _ 
			(self family 
				viewNamed: each
				for: self object) sketch.
		sketch ifNotNil: 
			[ sketch scalePoint: (self preferred: #scalePoint).
			menuItem balloonContentsMorph: sketch ].
		aMenu addMorphBack: menuItem ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/29/2004 15:15'!
as: viewName

	^ self beReplacedBy: (self asNewViewNamed: viewName)! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/29/2004 16:56'!
as: viewName resetTargetNamed: menuItemString in: aMenuMorph
	""
	| newTarget |
	newTarget _ self as: viewName.
	aMenuMorph items do: [ : each | each target: newTarget ].
	^newTarget! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 9/10/2004 17:35'!
asListEntry
	"This saves you all the laborious gestures of making me suitable as a list-entry in a Collection.  Just add the messages you want as 'columns' first."

	self
		listDirection: #leftToRight ;
		layoutInset: 1@1.
	self messageMorphsDo:
		[ : each | 
		each
			layoutInset: 1@-1 ;
			invocationStrategy:
				MauiImmediateInvocationStrategy new ;
			hideLabels ;
			lock ]
		
! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 1/5/2005 22:43'!
beDefault

	self view: #beDefault.
	self initializeSubmorphs! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 1/6/2005 13:09'!
beIconic

	| message |
	self
		clear ;
		view: #beIconic ;
		beInvisible;
		listDirection: #leftToRight;
		wrapDirection: #none;
		cellPositioning: #leftCenter ;
		addMorphBack: (SketchMorph withForm: object mauiIcon);
		layoutInset: 1@1 ;
		yourself.
	message _ self
		addMessage: 
			((MauiMessageMorph receiver: self object selector: #mauiName)
				invocationStrategy: MauiRepeatingInvocationStrategy new;
				hideLabels ;
				layoutInset: 1@1 ;
				lock ;
				invoke ;
				yourself).
	message beInvisible! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 1/1/2005 16:58'!
beLike: aMauiedMauiMorph
	"INSTRUCTIONS:  Find another MauiMorph with the desired-look, open its tool menu and select 'maui this Morph'.  A MauiMorph for that view will appear on the hand, drag it to the parameter-holder."

	self beReplacedBy:
		((aMauiedMauiMorph copyForNewObject: object)
			notificationHandler: self notificationHandler ;
			yourself)! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 7/29/2004 17:24'!
beReplacedBy: aMorph

	self mauiWorld userStrategy
		note: self
		beingReplacedBy: aMorph.
	self owner
		replaceSubmorph: self
		by: aMorph.
	"deleting caused my object to no longer be a player, reinstate it for me now."
	aMorph mauiWorld 
		onePlayerFor: aMorph object 
		is: aMorph.
	aMorph noteInvocationNeeded! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 1/5/2005 22:53'!
beSmall

	self
		view: #beSmall ;
		clear ;
		extent: 16@16! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:38'!
buildContextMenu

	| menu |
	menu _ super buildContextMenu.
	self mauiWorld userStrategy
		appendDomainMorphMenuItemsTo: menu
		for: self.
	self mauiWorld userStrategy
		addViewsMenuTo: menu
		for: self.
	self addUserMenuTo: menu.
	^menu! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 9/12/2004 22:08'!
buildToolMenu

	| menu |
	menu _ super buildToolMenu.
	menu add: 'as list entry' action: #asListEntry.
	menu addLine.
	menu add: 'manage views...' action: #openManageViewsDialog.
	menu add: 'family...' action: #openSetFamilyMessage.
	^menu! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 8/10/2004 00:03'!
canDropInto: aMauiMorph

	^ aMauiMorph isMauiDomainMorph 
		and: [ aMauiMorph object == self object ]
		and: [ self mauiWorld userStrategy allowsMorphComposition ]! !

!MauiDomainMorph methodsFor: 'sketch' stamp: 'cmm 8/14/2004 21:25'!
captureSketch

	self sketch: (SketchMorph withForm: self imageForm)! !

!MauiDomainMorph methodsFor: 'family' stamp: 'cmm 8/15/2004 22:14'!
family

	^ family ifNil: [ self mauiWorld family ]! !

!MauiDomainMorph methodsFor: 'family' stamp: 'cmm 12/1/2003 00:58'!
family: aMauiFamily

	family _ aMauiFamily! !

!MauiDomainMorph methodsFor: 'sketch' stamp: 'cmm 8/15/2004 22:55'!
hasSketch

	^ self sketch notNil! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 11/22/2003 18:03'!
hasUserMessageWithSameEffectAs: aMauiMessageMorph

	^userMessages anySatisfy: [ : each | each message sameEffectAs: aMauiMessageMorph message ]! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 11/20/2003 23:02'!
hasUserMessages

	^userMessages notEmpty! !

!MauiDomainMorph methodsFor: 'initializing' stamp: 'cmm 8/15/2004 22:15'!
initialize

	super initialize.
	userMessages _ OrderedCollection new "of MauiMessageMorphs".
	family _ self mauiWorld family.
	mauiMorphs _ Set new! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 1/10/2005 23:16'!
intoWorld: aWorld

	super intoWorld: aWorld.
	self world ifNotNil:
		[ self isSelfContained not
			ifTrue:
				[ self mauiWorld
					onePlayerFor: object
					is: self ].
		owner isBalloonHelp ifTrue: [ owner mauiAdjustVertices ] ]! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 11/24/2003 00:18'!
isMauiDomainMorph

	^true! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 1/17/2004 14:45'!
isReservedView: aString

	^object mauiReservedViews includes: aString! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 8/9/2004 23:35'!
justDroppedInto: aMorph event: anEvent
	"This message is sent to a dropped morph after it has been dropped on -- and been accepted by -- a drop-sensitive morph"

	aMorph == self world
		ifTrue:
			[ self mauiWorld
				onePlayerFor: self object
				is: self ]
		ifFalse: [ self mauiWorld removePlayer: self ]! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 1/1/2005 16:43'!
keyboardFocusChange: gainedFocus

	super keyboardFocusChange: gainedFocus.
	gainedFocus
		ifTrue: [ self isSelfContained ifFalse: [ self mauiWorld delineateFrom: self ] ]
		ifFalse: [ self mauiWorld undelineateFrom: self ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 2/20/2004 18:28'!
makeAllLikeMe
	"Make my class of players with my view in my world look just like me."

	| tempPrototype |
	tempPrototype _ self copyForNewObject: self object asMauiPrototype.
	self mauiWorld playersDo:
		[ : each |
		| classOfUpdatedView |
		classOfUpdatedView _ self family prototypeClassKeyFor: self object.
		(each ~~ self
			and: [ (each object isKindOf: classOfUpdatedView)
			and: [ view = each view ] ]
			and: [ (each family player: each overridesView: view from: classOfUpdatedView) not ])
				ifTrue:
					[ each beReplacedBy:
						((tempPrototype copyForNewObject: each object)
							notificationHandler: each notificationHandler;
							yourself) ] ]! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 1/4/2005 19:49'!
mauiDropInto: aMauiDomainMorph event: event at: spacerPosition
	super
		mauiDropInto: aMauiDomainMorph 
		event: event 
		at: spacerPosition.
	aMauiDomainMorph addPanel: self! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 12/27/2004 22:03'!
mauiNoteOutOfWorld

	super mauiNoteOutOfWorld.
	self mauiWorld removePlayer: self! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 12/31/2004 16:24'!
mouseEnter: aMouseEvent

	"I may not be a player if I am embedded within another MauiDomainMorph."
	(self mauiWorld isPlayer: self)
		ifTrue:
			[ 
super mouseEnter: aMouseEvent ]! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 12/31/2004 16:22'!
mouseLeave: aMouseEvent

	super mouseLeave: aMouseEvent.
	self world ifNotNil: [ self ensureNoSpacer ]! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 1/10/2005 23:17'!
noteNewOwner: aMorph

	(priorOwner ~= aMorph
	and: [ priorOwner isMauiMorph
	and: [ priorOwner isMauiDomainMorph ] ]) ifTrue: [ priorOwner removePanel: self ].
	super noteNewOwner: aMorph.
	self isSelfContained
		ifFalse:
			[ self world
				ifNotNil:
					[ self mauiWorld
						onePlayerFor: object
						is: self ] ]! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 1/10/2005 23:17'!
object: anObject

	object == anObject ifTrue: [ ^ self ].  "performance"
	self mauiWorld removePlayer: self.
	super object: anObject.
	(self world notNil and: [ self isSelfContained not ])
		ifTrue:
			[ self mauiWorld
				onePlayerFor: object
				is: self ].
	mauiMorphs do: [ : each | each object: anObject ].
	userMessages do:
		[ : each |
		each isDomainMessage
			ifTrue:
				[ (anObject isMauiPrototype and: [ each hasResult ]) ifTrue: [ each resultMorph resetObject ].
				each receiver: anObject ] ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 8/15/2004 20:20'!
openManageViewsDialog
	"... to remember this view, or revert to a past version."

	self asMauiMorph manageViews openInHand! !

!MauiDomainMorph methodsFor: 'family' stamp: 'cmm 9/12/2004 22:08'!
openSetFamilyMessage
	".. to remember this configuration separately."

	| dialog |
	dialog _ self asMauiMorph.
	(dialog addMessageNamed: #family) beGetterSetter.
	dialog openInHand! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 1/4/2005 19:48'!
panelsWith: messageSelector

	^ self panelsWithAll: { messageSelector }! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 1/4/2005 19:58'!
panelsWithAll: anArray
	"Answer the panel that has all the messages in anArray of their selectors."

	^ mauiMorphs select:
		[ : eachPanel |
		anArray allSatisfy: [ : eachSelector | eachPanel hasMessageNamed: eachSelector ] ]! !

!MauiDomainMorph methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:21'!
preferenceSelectors

	^ self mauiWorld userStrategy mauiDomainMorphPreferenceSelectors! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 1/4/2005 19:55'!
removePanel: aMauiDomainMorph
	"aMauiDomainMorph needs to have the same object as me."

	^ mauiMorphs
		remove: aMauiDomainMorph
		ifAbsent: [ MauiSoftwareError signal: 'Inconsistent sub-MauiMorph state?' ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 8/15/2004 21:07'!
removePrototype: aString atLevel: aClass
	"... and the menu option will go away for that view for any kind of aClass."

	self family
		removeAllOf: aString
		at: aClass! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 2/9/2004 00:19'!
removeUserMessage: aMauiMessageMorph

	userMessages
		maDetect: [ : each | each message sameEffectAs: aMauiMessageMorph message ]
		ifFound: [ : foundMessageMorph | userMessages remove: foundMessageMorph ]
		ifNone: [ "do nothing" ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/2/2003 23:36'!
revertToPrototype
	"... discarding your latest customizations."

	self as: self view! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 8/15/2004 21:04'!
savePrototype: aString atLevel: aClass
	"Remember me as a view named aString, that can then be applied to any kind of aClass."

	self 
		view: aString ;
		savePrototypeAtLevel: aClass! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 8/15/2004 20:38'!
savePrototypeAtLevel: aClass
	"... so that, going forward, objects of aClass kind will look similar to me."

	self family 
		remember: self
		atLevel: aClass.
	self makeAllLikeMe! !

!MauiDomainMorph methodsFor: 'sketch' stamp: 'cmm 8/14/2004 12:31'!
sketch

	^ self valueOfProperty: #sketch! !

!MauiDomainMorph methodsFor: 'sketch' stamp: 'cmm 8/14/2004 12:32'!
sketch: aSketchMorph

	self 
		setProperty: #sketch
		toValue: aSketchMorph! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 2/7/2004 12:18'!
sortedViewsDo: oneArgBlock

	self family
		sortedViewsFor: self
		do: oneArgBlock! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 1/5/2005 16:23'!
step
	super step.
	(owner notNil
	and: [ owner isBalloonHelp
	and: [ self world notNil ] ]) 
		ifTrue: [ owner mauiAdjustVertices ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 9/13/2004 11:12'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	userMessages _ userMessages veryDeepCopyWith: aDeepCopier.
	mauiMorphs _ mauiMorphs veryDeepCopyWith: aDeepCopier.
	preferences _ preferences veryDeepCopyWith: aDeepCopier.
	self sketch: (self sketch veryDeepCopyWith: aDeepCopier)! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/15/2004 16:44'!
view

	^view
		ifNil: [ #beDefault ]
		ifNotNil: [ view ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 1/3/2004 16:28'!
view: aString

	view _ aString! !

MauiDomainMorph subclass: #MauiMorphMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiMorphMorph commentStamp: 'cmm 8/15/2004 22:49' prior: 0!
This class is used to show a MauiMorph and operate it just like a domain object.!

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 8/15/2004 22:40'!
addBeLikeAnotherMessage

	| firstParameter message views |
	message _ self addMessageNamed: #beLike:.
	message labelAt: 1 put: 'Be like:'.
	firstParameter _ message parameterHolderMorphAt: 1.
	views _ self mauiMorph family 
		viewsNamed: self mauiMorph view
		for: self mauiMorph object class.
	views ifNotNil:
		[ views do:
			[ : each | 
			firstParameter addOptionalParameter: each copy ].
		firstParameter optionalParametersMorph elementsView: #beSketch ]! !

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 8/15/2004 22:29'!
addRemovePrototypeMessage

	| message firstParameter secondParameter amUserView |
	message _ self addMessageNamed: #removePrototype:atLevel:.
	message 
		labelAt: 1 put: 'Remove view:' ;
		labelAt: 2 put: 'for all kinds of:'.
	firstParameter _ message parameterHolderMorphAt: 1.
	amUserView _ false.
	self mauiMorph family 
		customViewsFor: self mauiMorph
		do: 
			[ : each | 
			each = self mauiMorph view 
				ifTrue:
					[ amUserView _ true.
					firstParameter dropParameter: each asMauiMorph ].
			firstParameter addOptionalParameter: each ].
	secondParameter _ message parameterHolderMorphAt: 2.
	amUserView ifTrue:
		[ self mauiMorph object class withAllSuperclassesDo:
			[ : each |
			(self mauiMorph family
				hasViewsAt: each
				named: self mauiMorph view)
					ifTrue: [ secondParameter addOptionalParameter: each ] ] ]! !

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 8/15/2004 22:36'!
addSavePrototypeMessage

	| saveMessage firstParameter secondParameter |
	saveMessage _ self addMessageNamed: #savePrototype:atLevel:.
	saveMessage 
		labelAt: 1 put: 'Remember view as:' ;
		labelAt: 2 put: 'for all kinds of:'.
	firstParameter _ saveMessage parameterHolderMorphAt: 1.
	self mauiMorph family 
		customViewsFor: self mauiMorph
		do: 
			[ : each | 
			each = self mauiMorph view ifTrue: [ firstParameter dropParameter: each asMauiMorph ].
			firstParameter addOptionalParameter: each ].
	secondParameter _ saveMessage parameterHolderMorphAt: 2.
	self mauiMorph object class withAllSuperclassesDo:
		[ : each | secondParameter addOptionalParameter: each ]! !

!MauiMorphMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/15/2004 23:03'!
beSketch
	"Shows how I looked when I was saved."
	(self mauiMorph hasSketch
	and: [ (self submorphs includes: self mauiMorph sketch) ])
		ifTrue: [ ^ self ].
	self
		beSmall ;
		beInvisible ;
		addMorph:
			(self mauiMorph sketch copy
				scalePoint: (self preferred: #scalePoint) ;
				yourself).
	self view: #beSketch! !

!MauiMorphMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2004 00:22'!
ensureItsObject

	| message |
"oops!!  This is flawed.  You may have many views of the object on screen, this is for a single particular MauiMorph.  You need a different way to identify the target MauiMorph.. perhaps a separate connector with its own color?"
	(self hasMessageNamed: #object) ifTrue: [ ^ self ].
	message _
		MauiMessageMorph
			receiver: self mauiMorph
			selector: #object.
	message
		invocationStrategy:
			(MauiImmediateInvocationStrategy new
				resultView: #beSmall ;
				yourself) ;
		labelAt: 1 put: 'A View of ' ;
		borderWidth: 0 ;
		useSquareCorners ;
		invokeIfPossible.
	message hasResult ifTrue: [ message resultMorph useRoundedCorners ].
	self addMessage: message! !

!MauiMorphMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/10/2004 23:18'!
initialize

	super initialize.
	self color: (self preferred: #colorScheme) dialogColor! !

!MauiMorphMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2004 00:31'!
initializeSubmorphs

	super initializeSubmorphs.
	self 
		listDirection: #leftToRight ;
		wrapDirection: #leftToRight ";
		ensureItsObject"! !

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 8/15/2004 22:52'!
manageViews
	"Change myself to the Manage Views dialog view."
	self
		labelString: 'Manage ', self mauiMorph view, ' Views' ;
		ensureLabelBar ;
		ensureCloseBox ;
		beDefault.
	self
		addSavePrototypeMessage ;
		addBeLikeAnotherMessage ;
		addRemovePrototypeMessage! !

!MauiMorphMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/10/2004 22:34'!
mauiMorph

	^ self object! !

MauiDomainMorph subclass: #MauiNumberMorph
	instanceVariableNames: 'stringMorph standardColor pointerOverColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiNumberMorph methodsFor: 'view' stamp: 'cmm 12/29/2003 23:26'!
beIconic

	stringMorph delete.
	super beIconic! !

!MauiNumberMorph methodsFor: 'events and overrides' stamp: 'cmm 12/29/2003 23:27'!
delineate

	stringMorph color: pointerOverColor! !

!MauiNumberMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 17:19'!
initialize

	super initialize.
	self useSquareCorners.
	pointerOverColor _ Color lightYellow.
	standardColor _ Color yellow.
	stringMorph _
		StringMorph new 
			color: standardColor ; 
			yourself! !

!MauiNumberMorph methodsFor: 'events and overrides' stamp: 'cmm 12/27/2004 17:20'!
initializeSubmorphs

	super initializeSubmorphs.
	(self includesMorphAnywhere: stringMorph) ifFalse: [ self addMorphBack: stringMorph ].
	self
		layoutInset: 0@0 ;
		beInvisible! !

!MauiNumberMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 17:16'!
postInitialize
	super postInitialize.
	self resetContents! !

!MauiNumberMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 17:15'!
resetContents
	stringMorph contents: object asString! !

!MauiNumberMorph methodsFor: 'events and overrides' stamp: 'cmm 12/29/2003 23:27'!
undelineate

	stringMorph color: standardColor! !

MauiDomainMorph subclass: #MauiPreferencesMorph
	instanceVariableNames: 'sections preferenceSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Kernel'!

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 8/12/2004 00:17'!
addPreferenceWidgetFor: preferenceSelector
	"Create a set of messages that indicate the level of override and allow override of preferences at my target or its super-preferences."

	| section message |
	section _ self ensureSectionFor: (self object sourceOfPreference: preferenceSelector).
	message _ section addMessageNamed: preferenceSelector.
	message addAsGetterSetter! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 8/12/2004 00:42'!
ensureSectionFor: aMauiPreferences
	"Ensure a section for aMauiPreferences target exists."
	| newSection |
	(sections includesKey: aMauiPreferences target) ifTrue: [ ^ sections at: aMauiPreferences target ].
	newSection _
		sections
			at: aMauiPreferences target
			put:
				(self object asMauiMorph
					preferenceSelectors:
						(preferenceSelectors select: [ : each | (self object sourceOfPreference: each) = aMauiPreferences ])  ;
					yourself).
	newSection
		ensureLabelBar ;
		labelString:
			(aMauiPreferences target == self object target
				ifTrue: [ 'Overridden' ]
				ifFalse: [ 'Inherited from ', aMauiPreferences target preferencesName ]).
	self addMorphBack: newSection.
	^ newSection! !

!MauiPreferencesMorph methodsFor: 'views' stamp: 'cmm 8/12/2004 00:19'!
inheritanceView
	"initializeSubmorphs is supposed to be a refreshing method, meaning it refreshes the morphs based on underlying state even if those morphs already exist from past state."
	self
		labelString: 'Preferences for ', self object target mauiName ;
		ensureLabelBar ;
		ensureCloseBox.
	self 
		removeAllSections ;
		initializeSections.
	preferenceSelectors do:
		[ : each |
		self addPreferenceWidgetFor: each ]! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 8/11/2004 23:52'!
initialize

	super initialize.
	sections _ Dictionary new.
	preferenceSelectors _ #().
	self color: (self preferred: #colorScheme) dialogColor! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 8/12/2004 22:07'!
initializeSections

	| nextUp |
	nextUp _ self object.
	[ self ensureSectionFor: nextUp.
	nextUp hasNextPreferences ]
		whileTrue: [ nextUp _ nextUp nextPreferences ]! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 8/11/2004 23:54'!
postInitialize

	preferenceSelectors _ self object target isMauiMorph
		ifTrue: [ self object target preferenceSelectors ]
		ifFalse: [ #() ].
	super postInitialize! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 8/11/2004 22:38'!
preferenceSelectors: anArray

	preferenceSelectors _ anArray! !

!MauiPreferencesMorph methodsFor: 'Morphic' stamp: 'cmm 12/30/2004 14:00'!
refreshData

	self view = #inheritanceView ifTrue: [ self inheritanceView ]! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 8/12/2004 00:50'!
removeAllSections

	sections keys do:
		[ : each | 
		(sections removeKey: each) delete ]! !

!MauiPreferencesMorph methodsFor: 'performance' stamp: 'cmm 8/12/2004 00:31'!
requireChangedNotificationsForAutoRefresh

	^ true! !

MauiDomainMorph subclass: #MauiStringMorph
	instanceVariableNames: 'editor useSmalltalkNotation standardColor pointerOverColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiStringMorph methodsFor: 'view' stamp: 'cmm 1/23/2004 16:36'!
beIconic

	editor delete.
	super beIconic! !

!MauiStringMorph methodsFor: 'Morphic' stamp: 'cmm 1/26/2004 00:03'!
color: aColor

	super color: aColor.
	editor ifNotNil: [ editor backgroundColor: aColor ]! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 1/24/2004 13:30'!
delineate

	editor textColor: pointerOverColor! !

!MauiStringMorph methodsFor: 'Morphic' stamp: 'cmm 1/25/2004 17:48'!
extent: aPoint

	super extent: aPoint.
	editor ifNotNil: [ editor noteNewOwnerExtent: aPoint ]! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 8/6/2004 09:58'!
initialize

	super initialize.
	self useSquareCorners.
	useSmalltalkNotation _ false.
	standardColor _ Color white darker.
	pointerOverColor _ Color white.
	self
		initializeEditor ;
		beInvisible;
		layoutInset: 0! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 1/5/2005 17:05'!
initializeEditor

	editor _ (self preferred: #stringEditor) copy
		textColor: standardColor;
		yourself! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 12/27/2004 16:55'!
initializeSubmorphs

	super initializeSubmorphs.
	(self includesMorphAnywhere: editor) ifFalse: [ self addMorphBack: editor ]! !

!MauiStringMorph methodsFor: 'Morphic' stamp: 'cmm 1/5/2005 17:06'!
intoWorld: aWorld

	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	editor addDependent: self! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 1/10/2005 21:52'!
object: aString

	super object: aString.
	self string ifNotNil: [ self resetContents ]! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 16:49'!
postInitialize

	super postInitialize.
	self resetContents! !

!MauiStringMorph methodsFor: 'Morphic' stamp: 'cmm 12/30/2004 14:06'!
refreshData

	super refreshData.
	useSmalltalkNotation ~= self showingSmalltalkNotation ifTrue: [ self resetContents ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 7/26/2004 13:43'!
representation

	^ self string isMauiPrototype
		ifTrue: [ String maEmpty ]
		ifFalse:
			[ useSmalltalkNotation 
				ifTrue: [ self string printString ] 
				ifFalse: [ self string ] ]! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 16:57'!
resetContents

	editor isWrapped
		ifTrue: [ editor contentsWrapped: self representation ]
		ifFalse: [ editor contentsAsIs: self representation ].
	editor adjustExtent! !

!MauiStringMorph methodsFor: 'testing' stamp: 'cmm 12/27/2004 16:57'!
showingSmalltalkNotation

	^ editor contents isEmpty
		ifTrue: [ false ]
		ifFalse: [ editor contents first = $' and: [ editor contents last = $' ] ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2004 17:10'!
standardColor

	^ standardColor! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 11/11/2003 22:55'!
string

	^self object! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2004 14:57'!
string: aString

	self object: aString! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 1/23/2004 16:37'!
undelineate

	editor textColor: standardColor! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 1/25/2004 18:05'!
update: anAssociation
	"This is signaled from my editor, a MauiStringEditor."

	"We don't allow contents of my editor to change, because they can only be changed when MY object changes."
	anAssociation key = #newContents: ifFalse: [ self resetContents ].
	anAssociation key = #ensureScroller ifTrue:
		[ self 
			hResizing: #rigid;
			vResizing: #rigid;
			extent: editor maxExtent ].
	anAssociation key = #ensureNoScroller ifTrue:
		[ self 
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 11/20/2003 22:17'!
useSmalltalkNotation: aBoolean

	useSmalltalkNotation _ aBoolean! !

!MauiStringMorph methodsFor: 'copying' stamp: 'cmm 8/8/2004 23:25'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	editor _ editor veryDeepCopyWith: aDeepCopier! !

!MauiStringMorph methodsFor: 'Morphic' stamp: 'cmm 8/8/2004 21:51'!
yellowButtonActivity: evt

	self openContextMenu! !

MauiMorph subclass: #MauiMessageMorph
	instanceVariableNames: 'labels parameterHolderMorphs resultMorph resultHolderMorph invocationStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiMessageMorph class methodsFor: 'creation' stamp: 'cmm 8/6/2004 10:10'!
mauiMessage: aMauiMessage

	^ self maNewFor: aMauiMessage! !

!MauiMessageMorph class methodsFor: 'creation' stamp: 'cmm 7/22/2004 11:48'!
receiver: anObject selector: selectorSymbol
	"Ui messages will need to be created via this method."

	^ self mauiMessage:
		(MauiMessage 
			receiver: anObject 
			selector: selectorSymbol)! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 12/6/2004 17:10'!
addAsGetterSetter
	"... allows drop of a new value, and always reflects the current value without having to refresh."

	| getterSetterOwner getterSetter position index |
	"capture these now, because asGetterSetter potentially changes my structure."
	getterSetterOwner _ self owner.
	position _ self position.
	index _ getterSetterOwner submorphs indexOf: self.
	getterSetter _ self beGetterSetter position: position; yourself.
	getterSetter ~~ self 
		ifTrue:
			[ getterSetterOwner
				addMessage: getterSetter
				at: index ]! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 7/27/2004 14:53'!
addReceiverIndicator
	"WARNING:  This functionality is not well-tested.  Use at your own risk.  It is here to see whether we ever want the ability to have messages directly on the desktop, e.g., not embedded directly into their object.  In those cases, you might need to know what object the message will be sent to.  This function provides an indicator of which object the message will be sent to."
	(self hasMessageNamed: #receiver)
		ifFalse:
			[ | message |
			message _ 
				((MauiMessageMorph
					receiver: self message
					selector: #receiver)

				listDirection: #leftToRight;
				invocationStrategy: MauiImmediateInvocationStrategy new;
				borderWidth: 0;
"				labelAt: 1 put: 'To:  ';"
				hideLabels;
				yourself).
			message invocationStrategy resultView: #beSmall.
			self addMessage: message at: 1 ]! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 7/22/2004 00:43'!
addToContextMenu
	"Invoke me from the context menu."

	self receiverMorph addUserMessage: self! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 10/1/2003 20:47'!
arguments

	^parameterHolderMorphs collect: [ : each | each parameterMorph object ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 7/22/2004 11:43'!
asMauiMessageUsing: aMauiMorph

	self message receiver: aMauiMorph object.
	^ self! !

!MauiMessageMorph methodsFor: 'converting' stamp: 'cmm 12/29/2003 22:12'!
asMauiMorph
	"No messageMorph is ever wrapped in another MauiMorph, and we need this for displaying a Collection of MauiMessageMorphs."

	^self! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 1/3/2005 22:18'!
balloonHelpString

	| answer |
	self message isValid ifFalse: [ ^ 'This message is not valid.' ].
	self wantsBalloonResult ifTrue: [ ^ nil ].
	answer _ String streamContents:
		[ : stream |
		self hasLabels 
			ifFalse:
				[ stream 
					nextPutAll: (self mauiWorld userStrategy nameFor: self message selector) ;
					cr ].
		stream nextPutAll: (self mauiWorld userStrategy nameFor: (self message implementorClass maFirstCommentAt: self message selector)) ].
	^answer isEmpty ifTrue: [ nil ] ifFalse: [ answer ]! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 11/19/2003 23:26'!
beGetter
	"... as a getter, I will always reflect my current value without the need for you to refresh."

	self invocationStrategy: MauiRepeatingInvocationStrategy new! !

!MauiMessageMorph methodsFor: 'converting' stamp: 'cmm 9/12/2004 22:06'!
beGetterSetter

	self canBeGetterSetter ifFalse: [ MauiUserError signal: 'I don''t have everything needed to be a getter setter.' ].
	^self message selector isUnary
		ifTrue:
			[ | receiverMorph newMessage |
			receiverMorph _ self receiverMorph.
			receiverMorph ifNotNil: [ receiverMorph removeMessage: self ].
			newMessage _ self endowWithSetter.
			receiverMorph ifNotNil: [ receiverMorph addMessage: newMessage ].
			newMessage ]
		ifFalse: [ self endowWithGetter ]! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 11/25/2003 23:30'!
beGetterSetterFor: setterMessageMorph

	self
		resultHolderMorph: (setterMessageMorph parameterHolderMorphAt: 1);
		invocationStrategy: MauiRepeatingInvocationStrategy new;
		hideLabels;
		hide;
		lock.
	setterMessageMorph addMessage: self.
	^setterMessageMorph! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/15/2003 00:00'!
binaryMessagePartsDo: oneArgBlock

	oneArgBlock value: self message selector! !

!MauiMessageMorph methodsFor: 'ide' stamp: 'cmm 7/15/2004 10:05'!
browseSenders

	SystemNavigation default browseAllCallsOn: self message selector! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:39'!
buildContextMenu

	| menu |
	menu _ super buildContextMenu
		defaultTarget: self;
		yourself.
	self mauiWorld userStrategy
		appendMessageMorphItemsTo: menu
		for: self.
	^ menu! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 12/18/2004 19:24'!
buildToolMenu

	| menu |
	menu _ super buildToolMenu.
	menu
		addUpdating: #hasLabelsMenuString
		action: #toggleLabels.
	menu
		add: 'change label...'
		target: self
		selector: #openLabelSetter.
	menu addLine.
	(self canBeGetter and: [ self isGetter not ])
		ifTrue: [ menu add: 'be a getter' target: self selector: #beGetter ].
	(self canBeGetterSetter and: [ self isGetterSetter not ])
		ifTrue: [ menu add: 'be a getter/setter' target: self selector: #addAsGetterSetter ].
	menu
		add: 'edit invoke strategy...'
		target: self
		selector: #openEditInvocationStrategy.
	menu addLine.
	(self isDomainMessage and: [ self receiverMorph notNil ])
		ifTrue:
			[ (self receiverMorph hasUserMessageWithSameEffectAs: self)
				ifTrue:
					[ menu 
						add: 'replace in context menu'
						target: self
						selector: #addToContextMenu.
					menu 
						add: 'remove from context menu'
						target: self
						selector: #removeFromContextMenu ]
				ifFalse:
					[ menu 
						add: 'add to context menu'
						target: self
						selector: #addToContextMenu ] ].
	menu addLine.
	menu
		add: (self string: 'view method' withKeyBindingFor: #keyForViewMethod)
		target: self selector: #viewMethod.
	menu
		addUpdating: #debugModeMenuString 
		action: #toggleDebugMode.
	^menu! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 11/6/2003 22:42'!
canBeGetter

	^self message selector isUnary! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 10/9/2003 22:03'!
canBeGetterSetter

	^self message selector isUnary
		ifTrue: [ self message hasCorrespondingSetter ]
		ifFalse: [ (self message selector occurrencesOf: $:) = 1 and: [ self message hasCorrespondingGetter ] ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 2/18/2004 20:23'!
canDropInto: aMauiMorph

	^ aMauiMorph object respondsTo: self message selector! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 7/26/2004 14:43'!
canInvoke

	^ self message receiver isMauiPrototype not and: [ self hasAllParameters ]! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 17:25'!
classInFocus

	^ self message implementorClass! !

!MauiMessageMorph methodsFor: 'copying' stamp: 'cmm 8/16/2004 15:51'!
cloneUi
	""
	| clone |
	clone _ self copy.
	"There's no reason to keep the resultMorph around.  It pops up with MauiPrototypes which is confusing."
	clone hasResult ifTrue: [ clone initializeResult ].
	^ clone openInHand! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 12/27/2004 16:59'!
createLabel: aString

	^(self preferred: #label) copy
		string: aString ;
		color: Color transparent;
		lock;
		beTabStop: false;
		initializeSubmorphs ;
		yourself! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/14/2004 11:56'!
createParameterMorph

	^ parameterHolderMorphs add:
		((self preferred: #parameterHolder) copy
			resetOptionalParameters ;
			yourself)! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 10/22/2003 21:48'!
debugModeMenuString

	^self message debugMode
		ifTrue: [ '<on>debug' ]
		ifFalse: [ '<off>debug' ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 7/22/2004 12:05'!
delete

	self receiverMorph ifNotNil: [ self receiverMorph removeMessage: self ].
	super delete! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 12/3/2004 12:31'!
determineResultHolder

	^(resultHolderMorph isNil or: [ self hasConventionalResultHolder ])
		ifTrue: 
			[ invocationStrategy resultTargetFor: self ]
		ifFalse: 
			[ resultHolderMorph ]! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 7/22/2004 18:10'!
endowWithGetter
	"I am a setter.  Wrap a new getter inside me."

	| getter |
	getter _
		MauiMessageMorph
	
		receiver: self message receiver
			selector: (self message selector copyWithout: $:) asSymbol.
	^ getter beGetterSetterFor: self! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 7/22/2004 01:17'!
endowWithSetter
	"I am a getter.  Wrap me inside a setter message and then return the setter."

	| setter |
	setter _ MauiMessageMorph
		receiver: self receiverMorph object
		selector: (self message selector copyWith: $:) asSymbol.
	^self beGetterSetterFor: setter! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/22/2004 18:17'!
family

	| rcvrMorph |
	^ (rcvrMorph _ self receiverMorph)
		ifNil: [ super family ]
		ifNotNil: [ rcvrMorph family ]! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 1/4/2005 09:50'!
getStrategyMessage

	| answer classMessage resultViewMessage resultHolderTargetMessage resultHolderTargetMessageParameter |
	answer _
		MauiMessageMorph
			receiver: self
			selector: #invocationStrategy.
	answer
		labelAt: 1
		put: 'Current Strategy'.
	answer 
		listDirection: #topToBottom ;
		selectStrategy: MauiRepeatingInvocationStrategy.

	answer invoke. "invoke to ensure a resultMorph that we now configure."
	

	classMessage _ 
		MauiMessageMorph
			receiver: self invocationStrategy
			selector: #mauiName.
	classMessage
		hideLabels ;
		beInvisible ;
		invocationStrategy: MauiRepeatingInvocationStrategy new ;
		lock.

	resultViewMessage _
		MauiMessageMorph
			receiver: self invocationStrategy
			selector: #resultView:.

	resultHolderTargetMessage _	
		MauiMessageMorph 
			receiver: self
			selector: #resultHolderTarget:.

	resultHolderTargetMessageParameter _ resultHolderTargetMessage parameterHolderMorphAt: 1.
	self invocationStrategy possibleTargets do:
		[ : each | resultHolderTargetMessageParameter addOptionalParameter: each ].

	answer resultMorph
		addMessage: classMessage ;
		addMessage: resultViewMessage ;
		addMessage: resultHolderTargetMessage.

	resultViewMessage beGetterSetter.
	resultHolderTargetMessage beGetterSetter.

	^answer! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 9/10/2004 15:31'!
grab

	self openInHand! !

!MauiMessageMorph methodsFor: 'keyboard' stamp: 'cmm 7/16/2004 14:40'!
handleKeystroke: aKeyboardEvent

	aKeyboardEvent wasHandled ifTrue: [ ^self ].
	self mauiWorld userStrategy
		handleMessageKeyboardEvent: aKeyboardEvent
		for: self.
	aKeyboardEvent wasHandled
		ifFalse: [ super handleKeystroke: aKeyboardEvent ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 9/10/2004 15:01'!
handlesMouseDown: aMouseEvent

	^aMouseEvent redButtonPressed
		ifTrue: [ invocationStrategy handlesMouseDown ]
		ifFalse: [ super handlesMouseDown: aMouseEvent ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 1/26/2004 23:33'!
handlesMouseOverDragging: evt

	^false! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 2/22/2004 19:21'!
hasAllParameters

	^parameterHolderMorphs allSatisfy: [ : e | e hasParameter ]! !

!MauiMessageMorph methodsFor: 'result' stamp: 'cmm 1/5/2005 15:30'!
hasConventionalResultHolder
	"An unconventional is one such as when we have a getter/setter."
	^ resultHolderMorph == ActiveHand
		or: [ resultHolderMorph == World
		or: [ resultHolderMorph == self 
		or: [ resultHolderMorph isBalloonHelp ] ] ]! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/27/2004 13:18'!
hasLabels

	^labels allSatisfy: [ : each | self submorphs includes: each ]! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/27/2004 14:57'!
hasLabelsMenuString

	^ self hasLabels
		ifTrue: [ self string: '<on>labelled' withKeyBindingFor: #keyForLabel ]
		ifFalse: [ self string: '<off>labelled' withKeyBindingFor: #keyForLabel ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 9/7/2003 23:04'!
hasResult

	^resultMorph notNil! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/29/2004 15:32'!
hideLabels

	self labelsDo: [ : each | each delete ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 2/5/2004 00:18'!
indexOfHolder: aMauiParameterHolderMorph

	^parameterHolderMorphs indexOf: aMauiParameterHolderMorph! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 1/6/2005 12:45'!
initialize

	super initialize.
	self
		listDirection: #leftToRight;
		wrapDirection: #none;
		hResizing: #shrinkWrap;
		layoutInset: 4@0 ;
		useRoundedCorners ;
		cellPositioning: #leftCenter.
	labels _ OrderedCollection new! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 8/5/2004 14:52'!
initializeColor

	self color: (self preferred: #colorScheme) messageBackgroundColor! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 12/1/2003 00:41'!
initializeInvocationStrategy

	invocationStrategy _ self message selector isUnary
		ifTrue: [ MauiClickedInvocationStrategy new ]
		ifFalse: [ MauiImmediateInvocationStrategy new ]! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 7/27/2004 13:51'!
initializeParameterHolderMorphs

	parameterHolderMorphs ifNotNil: [ parameterHolderMorphs do: [ : each | each delete ] ].
	self removeLabels.
	parameterHolderMorphs _ OrderedCollection new.
	self messagePartsDo:
		[ : eachPart |
		labels add: (self createLabel: eachPart).
		(eachPart last = $: or: [ eachPart first isLetter not "binary message" ])
			ifTrue:
				[ self addMorphBack: self createParameterMorph ] ].
	parameterHolderMorphs _ parameterHolderMorphs asArray.
	self showLabels! !

!MauiMessageMorph methodsFor: 'result' stamp: 'cmm 2/18/2004 22:35'!
initializeResult

	resultMorph ifNotNil: [ resultMorph delete ].
	resultMorph _ nil! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 7/22/2004 11:51'!
initializeSubmorphs

	super initializeSubmorphs.
	self initializeParameterHolderMorphs ! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 12/29/2004 17:08'!
intoWorld: aWorld

	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	self mauiWorld oneMessageMorphIs: self.
	(self isResultLocal and: [ resultMorph object isMauiPrototype ])
		ifTrue:
			[ resultMorph delete ]! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 2/7/2004 12:31'!
invocationStrategy
	"Answers my current MauiInvocationStrategy, an object that specifies which view is desired for my result when I invoke, and also where that result should be placed."

	^invocationStrategy! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/29/2004 17:42'!
invocationStrategy: aMauiInvocationStrategy

	invocationStrategy _ aMauiInvocationStrategy.
	invocationStrategy postInitialize: self! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 1/10/2005 23:54'!
invoke

	| result resultHolder |
	self message isValid ifFalse: [ ^ self ].
	self message arguments: self arguments.
	result _ self privateInvoke.
	result == self message receiver ifTrue: [ ^self maMarked: 'dev'. "flash animation" ].
	"Obtain the view."
	resultMorph _ (self reusableResultMorphFor: result) ifNil:
		[ "We tried to harvest the existing resultMorph, but couldn't.  Build a new view."
		self isResultLocal ifTrue: [ "an unusable local result, bye bye.." resultMorph delete ].
		self family
			newViewNamed: invocationStrategy resultView
			for: result ].
	"Pass on the app notification-handler."
	resultMorph notificationHandler: self notificationHandler.
	"Got the new view, now put it in the right place."
	(resultHolder _ self determineResultHolder) ifNotNil: [ self resultHolderMorph: resultHolder ].
	"Give an unshapely local-result the chance to customize me for better overall looks."
	resultMorph customize: self.
	invocationStrategy noteInvocationComplete: self! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 11/19/2003 19:16'!
invokeFromUserMenu

	invocationStrategy invokedFromUserMenu: self! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 8/21/2003 23:52'!
invokeIfPossible

	self canInvoke ifTrue: [ self invoke ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 7/22/2004 16:17'!
isDomainMessage

	| rcvrMorph |
	^ (rcvrMorph _ self receiverMorph)
		ifNil: [ self isUiMessage not ]
		ifNotNil: [ self message receiver == rcvrMorph object ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 11/6/2003 23:24'!
isGetter

	^self message selector isUnary and: [ invocationStrategy isSuitableForGetter ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 10/21/2003 23:15'!
isGetterSetter

	| getterName getterSymbol |
	getterSymbol _ nil.
	getterName _ self message selector copyWithout: $:.
	^(self message selector occurrencesOf: $:) = 1
		and: [ (Symbol hasInterned: getterName ifTrue: [ :sym | getterSymbol _ sym ])
		and: [ self hasMessageNamed: getterSymbol ] ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 8/18/2003 21:12'!
isMauiMessageMorph

	^true! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 12/8/2004 09:44'!
isResultLocal
	"Answers whether my result-Morph is contained as part of me or my receiverMorph."
	^ self hasResult
		and:
			[ (resultMorph hasOwner: self)
			or:
				[ | rm |
				rm _ self receiverMorph.
				rm notNil and: [ resultMorph hasOwner: rm ] ] ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 7/22/2004 16:12'!
isUiMessage
	"Answers whether my message is directed at a MauiMorph.  Note a ui-message can also be an isDomainMessage if my receiverMorphs object is also the same MauiMorph."

	^ self message receiver isMauiMorph! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 12/31/2004 16:28'!
keyboardFocusChange: gainedFocus

	gainedFocus
		ifTrue: [ self delineate ]
		ifFalse: "lost focus" [ self undelineate ]! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/27/2004 13:16'!
labelAt: anInteger put: aString
	"Used to customize the default parameter label for a message."

	| needToShow |
	(needToShow _ self hasLabels) ifTrue: [ self hideLabels ].
	[ labels size < anInteger ] whileTrue: [ labels add: nil ].
	labels
		at: anInteger 
		put: (self createLabel: aString).
	needToShow ifTrue: [ self showLabels ]! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/16/2004 15:04'!
labelsDo: oneArgBlock

	labels do: oneArgBlock! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 9/10/2004 16:53'!
mauiDropInto: aMauiDomainMorph event: event at: spacerPosition

	aMauiDomainMorph
		addMessage: self 
		at: spacerPosition.
	self position: event hand position - (0@self height).
	self message receiver: aMauiDomainMorph object! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 12/27/2004 22:22'!
mauiNoteOutOfWorld

	super mauiNoteOutOfWorld.
	self mauiWorld removeMessageMorph: self.
self maMarked: 'dev'.
"Just keeping things clean, this may not be necessary.."
	self isResultLocal
		ifTrue:
			[ resultMorph
				delete ;
				resetObject ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/1/2003 21:57'!
message

	^self object! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 7/26/2003 17:42'!
message: aMessage

	self object: aMessage! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/14/2003 23:59'!
messagePartsDo: oneArgBlock

	self message selector first isLetter
		ifTrue: [ self nonBinaryMessagePartsDo: oneArgBlock ]
		ifFalse: [ self binaryMessagePartsDo: oneArgBlock ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 10/8/2004 11:07'!
mouseDown: aMouseButtonEvent

	aMouseButtonEvent redButtonPressed 
		ifTrue:
			[ owner layoutPolicy isNil ifTrue: [ self comeToFront ].
			self root comeToFront.
			self invokeIfPossible ]
		ifFalse: [ super mouseDown: aMouseButtonEvent ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 1/3/2005 22:36'!
mouseEnter: aMouseEvent

	super mouseEnter: aMouseEvent.
	invocationStrategy
		mouseEntered: aMouseEvent
		for: self! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 1/4/2005 09:34'!
mouseLeave: aMouseEvent

	super mouseLeave: aMouseEvent.
	invocationStrategy
		mouseLeft: aMouseEvent
		for: self! !

!MauiMessageMorph methodsFor: 'converting' stamp: 'cmm 11/21/2003 00:07'!
newToken
	"We never create tokens of messages, it's not necessary!!"

	^self copy! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/14/2003 23:58'!
nonBinaryMessagePartsDo: oneArgBlock

	| stream |
	stream _ ReadStream on: self message selector.
	[ stream atEnd ]
		whileFalse:
			[ oneArgBlock value: (stream maUpToIncluding: $:) ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 8/16/2004 16:21'!
noteHoveringOver: aMauiMorph event: event
	"To get here, we know aMauiMorph can add me."

	^ invocationStrategy
		note: self
		hoveringOver: aMauiMorph
		event: event! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 7/19/2004 18:17'!
noteInvocationNeeded
	"My receiverMorph just came into the world by way of an as: or copy, etc.  I am one of his messageMorphs that, if the 'immediate' invocation strategy was chosen, should invoke again."

	self world ifNotNil:
		[ invocationStrategy noteInvocationNeededFor: self.
		super noteInvocationNeeded ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 1/31/2004 14:49'!
noteNewOwner: aMorph

	aMorph ifNotNil: [ self mauiWorld oneMessageMorphIs: self ].
	"If moved out of a MauiMorph.."
	(priorOwner notNil and: [ priorOwner isMauiMorph ]) ifTrue: [ priorOwner removeMessage: self ].
	invocationStrategy noteNewOwner: aMorph for: self.
	super noteNewOwner: aMorph! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/22/2004 18:17'!
notificationHandler

	| rcvrMorph |
	^ (rcvrMorph _ self receiverMorph)
		ifNil: [ super notificationHandler ]
		ifNotNil: [ rcvrMorph notificationHandler ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 12/8/2004 10:35'!
object: aMauiMessage

	super object: aMauiMessage.
	invocationStrategy ifNil: [ self initializeInvocationStrategy ]! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 8/16/2004 16:47'!
openEditInvocationStrategy
	"Alter the behavior of how and when I invoke."

	| dialog selectStrategyMessage parameterMorph |
	dialog _ MauiMorph plainDialogLabelled: 'Edit Invocation Strategy' for: self.

	selectStrategyMessage _
		MauiMessageMorph
			receiver: self
			selector: #selectStrategy:.
	parameterMorph _ selectStrategyMessage parameterHolderMorphAt: 1.
	MauiInvocationStrategy allSubclassesDo:
		[ : each | parameterMorph addOptionalParameter: each ].

	dialog 
		addMorphBack: selectStrategyMessage;
		addMorphBack: self getStrategyMessage.
	dialog openInHand! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 9/10/2004 15:37'!
openInHand

	| receiverMorph |
	receiverMorph _ self receiverMorph.
	super openInHand.
	(receiverMorph notNil and: [ self world notNil ])
		ifTrue:
	
		[ (receiverMorph containsPoint: self currentHand position)
	
			ifTrue: [ receiverMorph startTrackingDropZones ] ]! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 8/9/2004 23:53'!
openLabelSetter

	| answer |
	answer _ MauiMorph
		plainDialogLabelled: 'Change Label'
		for: self message.
	answer addMessage:
		(MauiMessageMorph
			receiver: self
			selector: #labelAt:put:).			
	answer openInHand! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 7/28/2003 12:16'!
parameterDropped

	invocationStrategy parameterDropped: self! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2003 16:52'!
parameterHolderMorphAt: anInteger
	"Answer the MauiParameterHolderMorph so that users may customize it."

	^parameterHolderMorphs at: anInteger! !

!MauiMessageMorph methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:16'!
preferenceSelectors

	^ self mauiWorld userStrategy mauiMessagePreferenceSelectors! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 1/2/2005 16:22'!
privateInvoke

	^[ self message debugMode ifTrue: [ self stopStepping ].
	self message invokeUsing: self notificationHandler ]

		maOn: MauiSetNotificationHandlerNotification
		do:
			[ : noti |
			| closingNotificationHandler |
			closingNotificationHandler _ self receiverMorph notificationHandler.
			self receiverMorph notificationHandler: noti handler.
			noti handler
				ifNil: [ self mauiWorld removePlayersWithNonDefaultNotificationHandler: closingNotificationHandler ].
			noti resume ]

		on: MaUserError
		do:
			[ : err |
			err messageText isString
				ifTrue: [ self error: err messageText ]
				ifFalse:
					[ "it must be a MauiDoc"
					err doc maui.
					err messageText ] ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/26/2004 16:50'!
receiver: anObject

	| didChange |
	didChange _ self message receiver
 == anObject.
	self message receiver: anObject.
	messageMorphs do: [ : each | each receiver: anObject ].
	didChange ifTrue: [ self noteInvocationNeeded ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/22/2004 00:55'!
receiverMorph

	^ self nearestOwnerThat:
		[ : morph | 
		morph isMauiMorph 
		and: [ "domain msg" morph object == self message receiver 
		or: [ "ui msg" morph == self message receiver ] ] ]! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 12/30/2004 13:53'!
refreshData

	super refreshData.
	invocationStrategy refreshData: self! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 7/22/2004 00:42'!
removeFromContextMenu
	"Cleans me off the context menu."

	self receiverMorph removeUserMessage: self! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 11/19/2003 21:58'!
removeFromContextMenuFor: aMauiDomainMorph

	aMauiDomainMorph removeUserMessage: self! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 2/19/2004 00:11'!
removeLabel: aMauiStringMorph

	(labels remove: aMauiStringMorph) delete! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 2/19/2004 00:10'!
removeLabels

	labels copy do: [ : each | self removeLabel: each ]! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 1/7/2005 17:47'!
resetParameterHolderMorphs
self maMarked: 'delete'.
	parameterHolderMorphs do: [ : each | each reset ]! !

!MauiMessageMorph methodsFor: 'result' stamp: 'cmm 1/4/2005 09:49'!
resetResultHolderMorph

	resultHolderMorph _ nil! !

!MauiMessageMorph methodsFor: 'result' stamp: 'cmm 9/30/2003 23:50'!
resultHolderMorph

	^resultHolderMorph! !

!MauiMessageMorph methodsFor: 'result' stamp: 'cmm 1/6/2005 22:14'!
resultHolderMorph: aMorph

	resultHolderMorph _ aMorph.
	(self hasResult and: [ resultMorph isInWorld not ])
		ifTrue:
			[ resultHolderMorph == ActiveHand
				ifTrue: [ resultMorph openInHand ]
				ifFalse:
					[ resultHolderMorph == World
						ifTrue: [ resultMorph openInWorld ]
						ifFalse:
							[ resultHolderMorph isBalloonHelp
								ifTrue:
									[ | hand |
									hand _ self world activeHand ifNil: [ ActiveHand ].
									hand
										addAlarm: #spawnMauiBalloon:for:
										withArguments: { resultHolderMorph. self }
										after: self balloonHelpDelayTime ]
								ifFalse: [ resultHolderMorph addMorphBack: resultMorph ] ] ] ]! !

!MauiMessageMorph methodsFor: 'result' stamp: 'cmm 1/4/2005 09:51'!
resultHolderTarget
	^ invocationStrategy resultHolderTarget! !

!MauiMessageMorph methodsFor: 'result' stamp: 'cmm 1/4/2005 09:49'!
resultHolderTarget: aString

	invocationStrategy resultHolderTarget: aString.
	self resetResultHolderMorph! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 12/25/2003 21:36'!
resultMorph

	^resultMorph! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 12/25/2003 21:21'!
resultMorph: aMauiMorph
	"This method should rarely be needed."
	resultMorph _ aMauiMorph! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 1/6/2005 18:15'!
reusableResultMorphFor: resultObject
	"The user may have customized the current resultMorph; preserve those customizations.  If we have or can copy their existing resultMorph that can be merely refreshed, return it, otherwise nil."
	^ (self hasResult and: [ resultMorph view = invocationStrategy resultView ])
		ifTrue:
			[ "Is the resultMorph still suitable for the class of resultObject?"
			(resultMorph isOptimizedFor: resultObject)
				ifTrue:
					[ (self isResultLocal or: [ resultMorph isInWorld not ])
						ifTrue:
							[ "reuse the existing local view"
							resultMorph object: resultObject; yourself ]
						ifFalse:
							[ "otherwise we have to copy it"
							resultMorph copyForNewObject: resultObject ] ] ]! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 7/15/2004 17:19'!
selectStrategy: mauiInvocationStrategyClass
	"Select a strategy that controls when the message is invoked."

	self invocationStrategy:
		(self invocationStrategy newBehavingAs: mauiInvocationStrategyClass)! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 17:24'!
selectorInFocus

	^ self message selector! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/29/2004 15:32'!
showLabels

	| x |
	self hasLabels ifTrue: [ ^ self ].
	x _ 1.
	self labelsDo:
		[ : each |
		self
			addMorph: each
			asElementNumber: x.
		x _ x + 2 ]! !

!MauiMessageMorph methodsFor: 'debugging' stamp: 'cmm 7/26/2004 17:36'!
signalWhereInvalid

	super signalWhereInvalid.
	parameterHolderMorphs do:
		[ : each | (self submorphs includes: each) ifFalse: [ MauiSoftwareError signal ] ].
	
(self message receiver == self receiverMorph object or: [ self message receiver == self receiverMorph ]) ifFalse: [ MauiSoftwareError signal ]! !

!MauiMessageMorph methodsFor: 'ide' stamp: 'cmm 11/19/2003 23:35'!
toggleDebugMode
	"... trace the execution of this message in the debugger the next time it is invoked."

	self message debugMode: self message debugMode not! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/27/2004 14:58'!
toggleLabelled

	self toggleLabels! !

!MauiMessageMorph methodsFor: 'labels' stamp: 'cmm 7/27/2004 13:29'!
toggleLabels

	^ self hasLabels
		ifTrue: [ self hideLabels ]
		ifFalse: [ self showLabels ]! !

!MauiMessageMorph methodsFor: 'overriding' stamp: 'cmm 7/27/2004 12:47'!
uiBasicApi
	"Answer the Array of basic ui-configuration selector Symbols useful to beginning users of Maui."

	^super uiBasicApi, #(hideLabels showLabels canInvoke invocationStrategy: resultHolderMorph:)! !

!MauiMessageMorph methodsFor: 'copying' stamp: 'cmm 12/8/2004 09:45'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	labels _ labels veryDeepCopyWith: aDeepCopier.
	self mauiWorld userStrategy adjustLabelsOf: self.
	parameterHolderMorphs _ parameterHolderMorphs veryDeepCopyWith: aDeepCopier.
	object _ object veryDeepCopyWith: aDeepCopier.
	resultHolderMorph _
		self isResultLocal
			ifTrue: [ resultHolderMorph veryDeepCopyWith: aDeepCopier ]
			ifFalse: [ nil ].
	invocationStrategy _ invocationStrategy veryDeepCopyWith: aDeepCopier.
	"save the configuration of the resultMorphs"
	resultMorph _ resultMorph veryDeepCopyWith: aDeepCopier! !

!MauiMessageMorph methodsFor: 'ide' stamp: 'cmm 7/15/2004 10:01'!
viewMethod
	"View the details about how this method works."

	SystemNavigation default
		methodHierarchyBrowserForClass: self message receiver class 
		selector: self message selector! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 1/3/2005 23:03'!
wantsBalloonResult

	^ self hasResult
	and: [ invocationStrategy wantsBalloonResultTarget
	and: [ invocationStrategy handlesMouseOver ] ]! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 7/27/2004 00:13'!
xoutOfWorld: aWorld
	"When my owners owners owner is deleted, I don't know about it down here except that this method is called."

	super outOfWorld: aWorld.
	self mauiWorld removeMessageMorph: self! !

!MauiMorph class methodsFor: 'factory' stamp: 'cmm 7/22/2004 13:37'!
closeBoxImage
	"Supplied here because we don't necessarily have ComicBold"

	^ CloseBoxImage ifNil:
		[ CloseBoxImage _ (Form
		
	extent: 9@9
		
	depth: 16
		
	fromArray: #( 65537 0 0 1 65536 65537 65536 0 65537 65536 1 65537 1 65537 0 0 65537 65537 65536 0 0 1 65537 0 0 0 65537 65537 65536 0 1 65537 1 65537 0 65537 65536 0 65537 65536 65537 0 0 1 65536)
		
	offset: 0@0)
			
			mapColor: Color black
			to: Color white ;
			yourself ]! !

!MauiMorph class methodsFor: 'private' stamp: 'cmm 8/14/2004 10:45'!
maNewFor: anObject

	^self new
		object: anObject ;
		initializeSubmorphs ;
		yourself! !

!MauiMorph class methodsFor: 'factory' stamp: 'cmm 7/26/2004 13:13'!
newFor: anObject

	^ anObject mauiMorphClass maNewFor: anObject! !

!MauiMorph class methodsFor: 'creation' stamp: 'cmm 12/30/2004 12:58'!
plainDialogLabelled: aString for: anObject
	"Create a MauiMorph where you merely need messages, not any special features of that object.  Useful for 'dialog-box' style uis."

	| answer |
	answer _ (self maNewFor: anObject)
		name: aString;
		color: MauiPreferences global colorScheme dialogColor;
		listDirection: #topToBottom ;
		balloonTextSelector: nil;
		borderWidth: 0;
		beDialog: true ;
		yourself.
	aString ifNotNil: 
		[ answer 
			ensureLabelBar ;
			ensureCloseBox ;
			labelString: aString ].
	^ answer! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 7/29/2004 23:20'!
aboutToBeGrabbedBy: aHand

	super aboutToBeGrabbedBy: aHand.
	self
		align: aHand position
		with: aHand position! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 8/13/2004 00:06'!
acceptDroppingMorph: droppingMorph event: event
	"droppingMorph should be either a MauiMessageMorph or, if dragged directly out of one of the IDE browsers, a TransformMorph."

	droppingMorph
		mauiDropInto: self
		event: event
		at: self spacerPosition.
	self ensureNoSpacer! !

!MauiMorph methodsFor: 'close-box' stamp: 'cmm 8/11/2004 16:56'!
addCloseBoxTo: aMorph

	aMorph
		addMorph: self createDeleteMessage
		asElementNumber: 1! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 11/25/2003 23:41'!
addHalo
	"... present Morphic tools for graphical manipulation."

	"(Comment overridden for balloon help)."
	^super addHalo! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 7/26/2004 17:34'!
addMessage: customizedMessageMorph

	^ self
		addMessage: customizedMessageMorph
		at: (self submorphs size + 1)! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 7/25/2004 22:03'!
addMessage: customizedMessageMorph at: index

	customizedMessageMorph position: self position + self layoutInset.
	(self 
		addMorph: customizedMessageMorph
		asElementNumber: index).
	^ messageMorphs
		at: customizedMessageMorph message selector
		put: customizedMessageMorph! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 8/15/2004 20:33'!
addMessageNamed: selectorSymbol

	^ self addMessage: (self newMessageNamed: selectorSymbol)! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:53'!
arrangementMenu

	^MenuMorph new

		addUpdating: #usingLeftToRightLayoutString target: self selector: #listDirection: argumentList: #(leftToRight) ;

		addUpdating: #usingTopToBottomLayoutString target: self selector: #listDirection: argumentList: #(topToBottom) ;

		yourself! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 12/29/2004 15:16'!
asNewViewNamed: aString

	^ (self family
		newViewNamed: aString
		for: object)

		view: aString ;
		notificationHandler: self notificationHandler ;
		yourself! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 7/8/2004 21:05'!
balloonHelpString

	(object isString or: [ object isNumber ]) ifTrue: [ ^ nil ].
	^ object mauiName contractTo: 300! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 2/20/2004 16:19'!
beDialog: aBoolean

	^ self setProperty: #isDialog toValue: aBoolean! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 12/30/2004 12:52'!
beInvisible

	self
		borderColor: Color transparent;
		cellInset: 0;
		color: Color transparent! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/14/2004 23:39'!
beTabStop: aBoolean

	self
		setProperty: #isTabStop
		toValue: aBoolean! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 1/1/2005 14:44'!
beginMauiEffect: aMauiEffect

	self runningMauiEffects
		maAt: aMauiEffect selector
		ifPresent: [ : existingEffect | existingEffect terminate ]
		ifAbsent: [ "nothing to terminate" ].
self maMarked: 'dev'.  "Potential timing problem? (e.g., 1) hasRunningEffects 2) last effect terminates 3) ifFalse:..  Ehh, no way..  it's all single-threaded anyway.  Symptom would be; dropped effects..?"
	self hasRunningEffects ifFalse:
		[ self
			startStepping: #stepAllEffects
			at: Time millisecondClockValue
			arguments: nil
			stepTime: (self preferred: #transitionDuration) // 3 ].
	self runningMauiEffects
		at: aMauiEffect selector
		put: aMauiEffect! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 11/19/2003 23:43'!
browseCommonUiMessages
	"... needed to use me effectively."

	self 
		browseMessages: self uiBasicApi
		receiver: self! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 7/14/2004 17:26'!
browseDomainClass
	"View some of my messages and how they work."

	Browser 
		newOnClass: self classInFocus
		selector: self selectorInFocus! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 7/14/2004 17:26'!
browseDomainFull
	"Shows where in the package-structure I and objects like me reside."

	Browser 
		fullOnClass: self classInFocus
		selector: self selectorInFocus! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 7/14/2004 17:25'!
browseDomainHierarchy
	"View all of my messages and how they work, arranged by my superclasses."
	Utilities
		spawnHierarchyForClass: self classInFocus
		selector: self selectorInFocus! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/22/2004 01:11'!
browseMessages: aCollection receiver: anObject

	| answer |
	answer _ OrderedCollection new.
	aCollection do:
		[ : each |
		each isSymbol
			ifTrue: 
				[ answer add: 
					(MauiMessageMorph
						receiver: anObject
						selector: each) ] ].
	(self family
		newViewNamed: thisContext printString
		for: answer) openInHand! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 11/20/2003 00:00'!
browseUiClass
	"View some of my user-interface messages and how they work."

	Browser 
		newOnClass: self class
		selector: nil! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 11/20/2003 00:01'!
browseUiFull
	"Shows where in the package-structure where my user-interface class resides."

	Browser 
		fullOnClass: self class 
		selector: nil! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 11/20/2003 00:01'!
browseUiHierarchy
	"View all of my user-interface messages and how they work, arranged by my superclasses."

	Utilities
		spawnHierarchyForClass: self class
		selector: nil! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:40'!
buildContextMenu

	| menu |
	menu _ (MenuMorph entitled: (object mauiName contractTo: 20))
		addStayUpIcons.
	self mauiWorld userStrategy
		appendStandardMenuItemsTo: menu
		for: self.
	^ menu! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 1/9/2005 00:37'!
buildDomainMessagesMenu

	| menu |
	menu _ MenuMorph new
		defaultTarget: self.
	menu add: 'find message...' action: #openDomainHud.
	menu addLine.
	menu
		add: (self string: 'browse class' withKeyBindingFor: #keyForOpenClass)
		action: #browseDomainClass.
	menu
		add: (self string: 'browse hierarchy' withKeyBindingFor: #keyForOpenHierarchy)
		action: #browseDomainHierarchy.
	menu
		add: (self string: 'browse full' withKeyBindingFor: #keyForOpenPackage)
		action: #browseDomainFull.
	messageMorphs notEmpty ifTrue:
		[ menu
			addLine;
			add: 'set my mauiBasicApi' action: #setMauiBasicApi ].
	self setUpBalloonHelpIn: menu.
	^ menu! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 8/9/2004 23:55'!
buildLayoutMenu

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu
		addUpdating: #usingShrinkWrappedLayoutString action: #setShrinkWrapView;
		addUpdating: #usingCustomLayoutString action: #setCustomizableView.
	self isCustomLayout 
		ifFalse: 
			[ menu add: 'arrange' subMenu: self arrangementMenu.
			menu add: 'wrap' subMenu: self wrapMenu ].
	self setUpBalloonHelpIn: menu.
	^menu! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 11/22/2003 17:44'!
buildMessagesMenu

	| menu |
	menu _ MenuMorph new.
	menu
		add: 'domain' subMenu: self buildDomainMessagesMenu;
		add: 'ui' subMenu: self buildUiMessagesMenu.
	^menu! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 12/30/2004 11:02'!
buildSelectorsMenuFor: selectors receiver: anObject actionSelector: actionSelector advancedSelectors: advancedSelectors

	| menu title |
	title _ anObject printString.
	title size > 80 ifTrue: [ title _ title copyFrom: 1 to: 80 ].
	menu _ MenuMorph new
		addTitle: 'messages for ', title;
		addStayUpIcons.
	selectors do:
		[ : each |
		each isSymbol
			ifTrue:
				[ menu
					add: each
					target: self
					selector: actionSelector
					argumentList: { each.  anObject } ]
			ifFalse: [ each = selectors first ifFalse: [ menu addLine ] ] ].
	advancedSelectors isEmptyOrNil
		ifFalse:
			[ menu addLine.
			menu
				add: 'more...' 
				target: self 
				selector: #browseMessages:receiver:
				argumentList: { advancedSelectors. anObject } ].
	^menu! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 12/22/2004 12:43'!
buildToolMenu

	| menu |
	menu _ (MenuMorph entitled: (object mauiName contractTo: 20))
		defaultTarget: self;
		addStayUpIcons.
	menu add: 'maui this Morph' action: #maui.
	menu add: 'pointers to my object' action: #openPointersList.
	menu addLine.
	menu
		add: 'messages' 
		subMenu: self buildMessagesMenu.
	menu 
		add: 'layout' 
		subMenu: self buildLayoutMenu.
	menu addLine.
	menu 
		add: (self string: 'explore object' withKeyBindingFor: #keyForExploreObject)
		action: #exploreObject.
	menu 
		add: (self string: 'explore ui' withKeyBindingFor: #keyForExploreMorph)
		action: #exploreUi.
	menu addLine.
	menu add: 'be invisible' action: #beInvisible.
	^menu! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 8/10/2004 23:34'!
buildUiMessagesMenu

	| menu |
	menu _ MenuMorph new
		defaultTarget: self.
	menu
		add: 'close-box' action: #ensureCloseBox ;
		addLine;
		add: 'select...' action: #presentSelectUiMessageMenu;
		add: 'browse common' action: #browseCommonUiMessages;
		add: 'search' action: #openUiHud;
		addLine;
		add: 'browse class' action: #browseUiClass;
		add: 'browse hierarchy' action: #browseUiHierarchy;
		add: 'browse full' action: #browseUiFull.
	self setUpBalloonHelpIn: menu.
	^menu! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/18/2004 20:23'!
canDropInto: aMauiMorph
	"You can't generally drop any MauiMorph into any other MauiMorph.  It just doesn't make sense.."

	^ false! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/29/2004 22:13'!
canHaveFillStyles
	"Superclass says I can't.  Hey, this ain't Java, so we do it because we can."

	^ true! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 8/11/2004 22:26'!
canSupport: anObject
	"Answer whether my class can support anObject.  For example, a MaCollectionMorph is specifically suited to support Collections, however, a regular MauiDomainMorph can also do it (providing just messages, no scrollbars, etc.)."

	^(self isOptimizedFor: anObject) or: [ anObject mauiMorphClass inheritsFrom: self class ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 17:24'!
classInFocus

	^ object class! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 1/4/2005 20:00'!
clear
	"Delete all of my messages and panels."

	"Note this doesn't use removeAllMorphs so it goes through all of the proper player removal, etc."
	submorphs copy do: [ : each | each delete ]! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 1/1/2005 16:58'!
cloneUi
	"Hand over a new user-interface for me."

	^ (self copyForNewObject: object)
		notificationHandler: self notificationHandler ;
		openInHand! !

!MauiMorph methodsFor: 'close-box' stamp: 'cmm 8/11/2004 17:06'!
closeBoxMenuString

	^ self hasCloseBox
		ifTrue: [ '<on>close-box' ]
		ifFalse: [ '<off>close-box' ]! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 10/8/2003 22:16'!
copyForNewObject: anObject

	^self copy
		object: anObject;
		yourself! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 7/22/2004 01:10'!
createDeleteMessage

	| msg |
	msg _ MauiMessageMorph
		receiver: self
		selector: #delete.
	^ msg
		cornerStyle: #square;
		hideLabels;
		beInvisible;
		addMorphBack: (SketchMorph withForm: MauiMorph closeBoxImage) ;
		yourself! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 1/6/2005 17:31'!
customize: aMauiMessageMorph
	"This method is called when I become the local result of aMauiMessageMorph.  At this point it may be useful to customize the aMauiMessageMorph to accomodate me living there now."! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 1/1/2005 14:56'!
defaultBorderColor

	^ (self preferred: #colorScheme) borderColor! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 8/11/2004 15:09'!
defaultLabel

	| defaultLabelSelector |
	^ object perform: 
		((object respondsTo: (defaultLabelSelector _ self preferences defaultLabelSelector))
			ifTrue: [ defaultLabelSelector ]
			ifFalse: [ #mauiName ])! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/10/2005 23:29'!
delete
	"Remove me from the screen."
	super delete.

self maMarked: 'dev'.
"Oops, this leaves me in a transparent state, which makes me hard to see after reopening."
"
	(MauiEffect
		target: self
		selector: #maAllMorphsAlpha:
		range: (1.0 to: 0.0)
		duration: (self preferred: #transitionDuration)
		finally: [ super delete ]) begin
"! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 1/1/2005 17:43'!
delineate
	"indicate my borders."

	owner ifNil: [ "forget it" ^ self ].
	"If already delineated, skip the transition becuase its distracting."
	self borderColor = (self preferred: #colorScheme) highlightColor ifTrue: [ ^ self ].
	self borderColor: ((self preferred: #colorScheme) highlightColor alpha: 0.0).
	(MauiEffect
		target: self
		selector: #maBorderColorAlpha:
		range: (0.0 to: ((self preferred: #colorScheme) highlightColor alpha))
		duration: (self preferred: #transitionDuration)
		finally: [ "nothing more" ]) begin! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 7/26/2004 17:34'!
depthFirstDo: oneArgBlock
	"Enumerate my structure in a depth-first fashion."

	self submorphs
		do:
			[ : each | 
			each isMauiMorph 
				ifTrue:
					[ oneArgBlock value: each.
					each depthFirstDo: oneArgBlock ] ]! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/15/2004 00:18'!
depthFirstReverseDo: oneArgBlock
	"Enumerate my structure in a reverse depth-first fashion."

	| siblings myPosition |
	owner ifNil: [ ^self ].
	siblings _ owner submorphs.
	myPosition _ siblings indexOf: self.
	myPosition-1 to: 1 by: -1 do: [ : position | oneArgBlock value: (siblings at: position) ].
	owner depthFirstReverseDo: oneArgBlock! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/30/2004 13:58'!
desiredRefreshInterval
	^ 1000 "milliseconds"! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 10/14/2003 00:12'!
domainAdvancedApi
	"Answer an plethora of selector Symbols you want for advanced users of your domain have access to."

	^object mauiAdvancedApi! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 1/1/2005 14:10'!
endMauiEffect: aMauiEffect

	self runningMauiEffects
		removeKey: aMauiEffect selector
		ifAbsent: [ "shouldn't happen, but who cares" ].
	self hasRunningEffects ifFalse: [ self stopSteppingSelector: #stepAllEffects ]! !

!MauiMorph methodsFor: 'close-box' stamp: 'cmm 8/11/2004 16:57'!
ensureCloseBox

	self hasCloseBox ifTrue: [ ^ self ].
	self addCloseBoxTo:
		(self isLabelled
			ifTrue: [ labelBar ]
			ifFalse: [ self ])! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 8/11/2004 17:09'!
ensureLabelBar

	labelBar ifNil: [ self initializeLabelBar ].
	self hasCloseBox ifTrue:
		[ self 
			ensureNoCloseBox ;
			addCloseBoxTo: labelBar ].
	self addMorph: labelBar! !

!MauiMorph methodsFor: 'close-box' stamp: 'cmm 8/11/2004 16:50'!
ensureNoCloseBox

	self isLabelled ifTrue: [ self removeMyCloseBoxFromSubmorphsOf: labelBar ].
	self removeMyCloseBoxFromSubmorphsOf: self! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 8/11/2004 17:11'!
ensureNoLabelBar

	| needsCloseBox |
	needsCloseBox _ self hasCloseBox.
	self ensureNoCloseBox.
	self isLabelled ifTrue: [ labelBar delete ].
	needsCloseBox ifTrue: [ self ensureCloseBox ]! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 9/10/2004 15:36'!
ensureNoSpacer

	self stopTrackingDropZones.
	spacer ifNotNil: [ spacer shrinkAndDelete ].
	spacer _ nil! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/11/2004 10:28'!
ensurePreferences

	^ preferences ifNil: [ preferences _ self family ensurePreferences newOverrideFor: self ]! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/2/2004 23:00'!
ensureSpacerBehind: submorph

	| submorphIndex |
	submorphIndex _ self submorphs indexOf: submorph.
	submorphIndex = 0 ifTrue: [ ^ self ].
	(self submorphs size > submorphIndex
	and: [ spacer == (self submorphs at: submorphIndex + 1) ]) ifTrue: [ ^ self ].
	self initializeSpacer.
	self addMorph: spacer behind: submorph! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/2/2004 23:29'!
ensureSpacerInFrontOf: submorph

	| submorphIndex |
	submorphIndex _ self submorphs indexOf: submorph.
	submorphIndex = 0 ifTrue: [ ^ self ].
	(submorphIndex > 1 
	and: [ { spacer. labelBar } includes: (self submorphs at: submorphIndex - 1) ]) ifTrue: [ ^ self ].
	self initializeSpacer.
	self addMorph: spacer inFrontOf: submorph! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 11/19/2003 23:07'!
exploreObject
	"... presents an expandable tree view of me."

	object explore! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 11/19/2003 23:11'!
exploreUi
	"... presents an expandable tree-view of the Morphic user-interface object you see on the screen."

	self explore! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/2/2004 12:09'!
extentOfDraggedMorph

	^ self primaryHand firstSubmorph extent! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 12/25/2003 12:12'!
externalName

	^self name! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 8/15/2004 22:16'!
family
	"needed when building optionalValues editor for a message."
	^ self mauiWorld family! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 1/8/2004 00:25'!
findRemainingFocus

	| ownerChain |
	ownerChain _ owner
		ifNil: [ priorOwner ifNil: [ #() ] ifNotNil: [ priorOwner ownerChain ] ]
		ifNotNil: [ owner ownerChain ].
	^ownerChain isEmpty
		ifFalse:
			[ ownerChain 
				detect: [ : e | e notNil and: [ e isMauiMorph ] ]
				ifNone: [ nil ] ]! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 01:01'!
focusOnNextPlayerUsing: aKeyboardEvent

	aKeyboardEvent hand newKeyboardFocus: self nextTabStop! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:33'!
focusOnPreviousPlayerUsing: aKeyboardEvent

	aKeyboardEvent hand newKeyboardFocus: self priorTabStop  ! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 9/10/2004 15:20'!
grab

	ActiveHand grabMorph: self! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 7/16/2004 14:40'!
handleKeystroke: aKeyboardEvent

	| h |
	h _ false.
	aKeyboardEvent wasHandled ifTrue: [ ^self ].
	h _ self mauiWorld userStrategy
		handleStandardKeyboardEvent: aKeyboardEvent
		for: self.
	aKeyboardEvent wasHandled: h.
	h ifFalse: [ super handleKeystroke: aKeyboardEvent ]! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 1/8/2005 12:59'!
handleRedButton

	self isSticky ifFalse: [ self grab ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/19/2004 23:16'!
handlesBasicMouseOverDrag: evt

	| submorph |
	evt hand submorphs size = 1 ifFalse: [ ^ false ].
	submorph _ evt hand firstSubmorph renderedMorph.
	submorph canDropIntoMauiMorph ifFalse: [ ^false ].
	(self wantsDroppedMorph: submorph event: evt) ifFalse: [ ^ false ].
	^true! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/6/2004 21:22'!
handlesKeyboard: aKeyboardEvent

	^self containsPoint: aKeyboardEvent position! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/21/2003 23:26'!
handlesMouseDown: aMouseButtonEvent

	aMouseButtonEvent yellowButtonPressed ifTrue: [ ^true ].
	aMouseButtonEvent redButtonPressed ifTrue: [ ^true ].
	^super handlesMouseDown: aMouseButtonEvent! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/7/2004 16:12'!
handlesMouseOver: aMouseEvent

	^ self isDialog not! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 8/16/2004 16:32'!
handlesMouseOverDragging: evt

	^ self handlesBasicMouseOverDrag: evt! !

!MauiMorph methodsFor: 'close-box' stamp: 'cmm 8/11/2004 16:53'!
hasCloseBox

	^ (self submorphs anySatisfy: [ : each | self isMyDeleteMessage: each ])
	or: 
		[ self isLabelled
		and: [ labelBar submorphs anySatisfy: [ : each | self isMyDeleteMessage: each ] ] ]! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 12/30/2004 12:50'!
hasFocus

self maMarked: 'delete'.  "not sure if this is needed."
	self isDelineated ! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 10/21/2003 23:10'!
hasMessageNamed: selectorSymbol

	^messageMorphs includesKey: selectorSymbol! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 13:06'!
hasRunningEffects
	^ runningEffects notNil and: [ runningEffects notEmpty ]! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/3/2004 21:40'!
hasSubmorphsOtherThanSpacers

	^ self submorphs notEmpty
	and: [ submorphs anySatisfy: [ : each | each class ~= MauiSpacer "ugh" ] ]! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 7/27/2004 12:28'!
hasUserMessageWithSameEffectAs: aMauiMessageMorph
	"Only MauiDomainMorphs have user messages."

	^ false! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 6/1/2004 00:56'!
includesMorphAnywhere: aMorph

	self allMorphsDo: [ : each | each == aMorph ifTrue: [ ^ true ] ].
	^ false! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/3/2004 19:39'!
initialMarkerExtentOf: aMauiSpacer

	self hasSubmorphsOtherThanSpacers ifFalse: [ ^ self extent - self layoutInset ].
	^ self listDirection = #topToBottom
		ifTrue:
			[ self primaryHand firstSubmorph width @ 0 ]
		ifFalse:
			[ "left-to-right"
			0 @ self primaryHand firstSubmorph height ]! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 1/4/2005 19:22'!
initialize

	super initialize.
	self initializeNotificationHandler.
	self
		balloonTextSelector: #balloonHelpString;
		extent: 16@16;
		cellPositioning: #leftCenter;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		wrapDirection: #none;
		layoutInset: 4 ;
		cellInset: 2;
		cellPositioning: #topLeft ;
		borderWidth: 1;
		initializeColor;
		borderColor: self defaultBorderColor ";
		shadowOffset: 12@12;
		addDropShadow".
	self
		beTabStop: true ;
		initializeMessageMorphs ;
		initializeRedButtonMessage.
	lastRefreshTime _ 0.
	needsRefreshed _ true.
	object _ self! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 8/5/2004 14:49'!
initializeColor

	| fill color1 color2 |
	color1 _ (self preferred: #colorScheme) color1.
	color2 _ (self preferred: #colorScheme) color2.
	self color: color1.
	fill _ GradientFillStyle ramp: {0.18 -> color1. 1.0 -> color2 }.
	fill origin: self topLeft.
	fill direction: (self width // 3) @ self bounds extent y.
	fill normal: self bounds extent x @ 0.
	fill radial: false.
	self fillStyle: fill! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 9/10/2004 17:23'!
initializeLabelBar

	labelBar _ RectangleMorph new
		color: self color twiceDarker;
		layoutPolicy: TableLayout new ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		listDirection: #leftToRight ;
		borderWidth: 0 ;
		position: self position+self layoutInset ;
		yourself.
	label _ TextMorph new
		textColor: (self family viewNamed: #beDefault for: '') standardColor ;
		width: 64 ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		contentsAsIs: self defaultLabel ;
		yourself.
	labelBar addMorphBack: label! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 10/3/2003 00:40'!
initializeMessageMorphs

	messageMorphs _ Dictionary new! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 1/2/2005 16:15'!
initializeNotificationHandler

	notificationHandler _ MauiNotificationHandler default! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 7/22/2004 17:30'!
initializeRedButtonMessage

	self redButtonMessage:
		(MauiMessage 
			receiver: self
			selector: #handleRedButton)! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 13:03'!
initializeRunningEffects

	runningEffects _ Dictionary new! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/2/2004 12:55'!
initializeSpacer

	spacer ifNotNil: [ spacer shrinkAndDelete ].
	spacer _ self newDropMarkerFor: self! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 1/4/2005 20:09'!
initializeSubmorphs
	"Restore my standard configuration, wipe the slate clean."

	self clear! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/6/2004 15:07'!
intoWorld: aWorld

	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	self noteInvocationNeeded! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/2/2004 18:02'!
is: aPoint inFirstHalfOf: aMorph

	^ self listDirection = #topToBottom
		ifTrue: [ aPoint y < (aMorph position y + (aMorph height // 2)) ]
		ifFalse: [ aPoint x < (aMorph position x + (aMorph width // 2)) ]
			! !

!MauiMorph methodsFor: 'layout' stamp: 'cmm 10/13/2003 22:38'!
isCustomLayout

	^self layoutPolicy isNil! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 12/30/2004 13:01'!
isDelineated
self maMarked: 'delete'.
	^self borderColor = (self preferred: #colorScheme) highlightColor! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 2/20/2004 16:19'!
isDialog

	^ self
		valueOfProperty: #isDialog
		ifAbsent: [ false ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/28/2003 00:09'!
isHandInBeginningHalfOf: aMorph

	^self listDirection = #topToBottom
		ifTrue: [ self primaryHand y < aMorph center y ]
		ifFalse: [ self primaryHand x < aMorph center x ]! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 12/30/2004 12:57'!
isInvisible
	^ self color = Color transparent! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 7/22/2004 12:37'!
isLabelled

	^ labelBar notNil and: [ labelBar owner == self ]! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 11/24/2003 00:19'!
isMauiDomainMorph

	^false! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 7/10/2003 22:22'!
isMauiMorph

	^true! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 11/2/2003 20:17'!
isMauiParameterHolderMorph

	^false! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 8/11/2004 15:34'!
isMyDeleteMessage: aMorph

	^ aMorph isMauiMessageMorph
	and: [ aMorph message selector = #delete
	and: [ aMorph message receiver == self ] ]! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 1/6/2005 18:07'!
isOptimizedFor: anObject
	"There's no guarantee the same messasge will return the same class of object.  Answer whether my class is specifically meant to support anObject."

	^anObject mauiMorphClass == self class! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 12/6/2004 15:20'!
isSelfContained
	"Answer if I am contained by another MauiMorph with the same object."
	self allOwnersDo: [ : each | (each isMauiMorph and: [ each object == self object ]) ifTrue: [ ^ true ] ].
	^ false! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/14/2004 23:38'!
isTabStop

	^self valueOfProperty: #isTabStop! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 7/22/2004 13:08'!
labelString: aString

	label ifNil: [ self initializeLabelBar ].
	label contentsAsIs: aString! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 7/27/2004 14:29'!
labelledMenuString

	^ self 
		string:
			(self isLabelled
				ifTrue: [ '<on>labelled' ]
				ifFalse: [ '<off>labelled' ])
		withKeyBindingFor: #keyForLabel! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 15:36'!
maBorderWidthAndExtentDelta: aFloat
	"When you increase border width, it invades onto the Morph itself.  So try doing it by increasing the extent of the Morph in concert with its border width to give the effect that its border extended outward from the Morph rather than inward."

	| int deltaBorderWidth |
	int _ aFloat roundTo: 1.
	deltaBorderWidth _ int - self borderWidth.
	deltaBorderWidth = 0 ifFalse:
		[ self
			borderWidth: int ;
			extent: (self extent + ((deltaBorderWidth*2)@(deltaBorderWidth*2))) ;
			position: (self position - (deltaBorderWidth@deltaBorderWidth)) ]! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 7/29/2004 15:33'!
makeIcon
	"Hand over an icon for me which can be dropped as a parameter to a message."

	^ (self asNewViewNamed: #beIconic) openInHand! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 8/15/2004 23:23'!
maui

	self captureSketch.
	super maui beSketch! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/21/2004 17:22'!
mauiNoteOutOfWorld

	super mauiNoteOutOfWorld.
	self initializeNotificationHandler! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/6/2003 14:43'!
mauiWorld

	| myWorld |
	^MauiWorld for:
		((myWorld _ self world)
			ifNil: [ World ]
			ifNotNil: [ myWorld ])! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 2/10/2004 00:19'!
messageMorphsDo: oneArgBlock

	messageMorphs do: oneArgBlock! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 8/8/2004 22:56'!
messageNamed: selectorSymbol

	^ messageMorphs at: selectorSymbol! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/30/2004 13:43'!
millisecondsSinceLastRefresh
	^ Time millisecondClockValue - lastRefreshTime! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/10/2005 23:02'!
mouseDown: aMouseButtonEvent

	aMouseButtonEvent yellowButtonPressed
		ifTrue:
			[ self mauiWorld userStrategy
				yellowDown: aMouseButtonEvent
				on: self ].
	aMouseButtonEvent redButtonPressed
		ifTrue: [ redButtonMessage invokeUsing: self notificationHandler ]
		ifFalse: [ "do nothing" ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/4/2005 09:35'!
mouseEnter: aMouseEvent

	super mouseEnter: aMouseEvent.
	aMouseEvent hand newKeyboardFocus: self! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 9/10/2004 15:35'!
mouseEnterDragging: evt
	"If invocationStrategy is mouse-over then shift must be pressed for droppage.  Otherwise, it acts like a magic-decoder card."

	| draggingMorph strategyNotedHovering |
	draggingMorph _ evt hand firstSubmorph renderedMorph.
	strategyNotedHovering _ false.
	draggingMorph isMauiMessageMorph
		ifTrue: [ strategyNotedHovering _ draggingMorph noteHoveringOver: self event: evt ].
	(strategyNotedHovering or: [ self isCustomLayout ])
		ifFalse:
			[ self initializeSpacer.
			self hasSubmorphsOtherThanSpacers
				ifTrue: [ self startTrackingDropZones ]
				ifFalse: [ self submorphs isEmpty ifTrue: [ self addMorph: spacer ] ] ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/4/2005 09:35'!
mouseLeave: aMouseEvent

	super mouseLeave: aMouseEvent.
	aMouseEvent hand newKeyboardFocus: self findRemainingFocus! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/28/2003 00:26'!
mouseLeaveDragging: evt

	self ensureNoSpacer! !

!MauiMorph methodsFor: 'api-widgets' stamp: 'cmm 7/22/2004 01:10'!
newActionMessage: selectorSymbol receiver: anObject
	"selectorSymbol is a no-argument selector and is created as a button according to the users preference."

	^(MauiMessageMorph
		receiver: anObject 
		selector: selectorSymbol)

		invocationStrategy: MauiClickedInvocationStrategy new;
		borderWidth: 2;
		setBorderStyle: #complexRaised;
		yourself! !

!MauiMorph methodsFor: 'api-widgets' stamp: 'cmm 8/10/2004 00:24'!
newCheckbox: selectorSymbol

	| message |
	message _ 
		(self newGetterSetter: selectorSymbol)

			optionalValuesStrategy: MauiCycleParametersStrategy new;
			optionalValues: { true. false };
			yourself.
	message getter resultHolderMorph: message optionalValuesActivatorMessage.
	^message! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 8/2/2004 11:19'!
newDropMarkerFor: aMauiMorph

	^ MauiSpacer 
		for: aMauiMorph 
		targetExtent: self extentOfDraggedMorph! !

!MauiMorph methodsFor: 'api-widgets' stamp: 'cmm 7/22/2004 01:16'!
newGetter: selectorSymbol

	^(MauiMessageMorph 
		receiver: self object
		selector: selectorSymbol) beGetter! !

!MauiMorph methodsFor: 'api-widgets' stamp: 'cmm 8/10/2004 00:24'!
newGetterSetter: setterSymbol

	^(MauiMessageMorph 
		receiver: self object
		selector: setterSymbol) addAsGetterSetter! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 8/15/2004 20:33'!
newMessageNamed: selectorSymbol

	^ MauiMessageMorph
		receiver: self object
		selector: selectorSymbol! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/11/2004 21:58'!
nextPreferenceSource

	^ self family! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/15/2004 23:43'!
nextSibling

	| siblings myPosition |
	owner ifNil: [ ^nil ].
	siblings _ owner submorphs.
	myPosition _ siblings indexOf: self.
	^myPosition = siblings size 
		ifTrue: [ nil ] 
		ifFalse: 
			[ myPosition+1 to: siblings size do:
				[ : submorphIndex | 
				(siblings at: submorphIndex) isMauiMorph 
					ifTrue: [ ^ siblings at: submorphIndex ] ].
			nil ]! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/15/2004 22:36'!
nextTabStop

	^self nextTabStop: false! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 01:11'!
nextTabStop: includeMyself

	| nextTry |
	includeMyself ifTrue: [ self isTabStop ifTrue: [ ^self ] ].
	self depthFirstDo: [ : each | each isTabStop ifTrue: [ ^ each ] ].
	(nextTry _ self nextSibling) ifNotNil: [ ^nextTry ].
	nextTry _ (nextTry _ self nextMauiOwner) ifNotNil: [ nextTry nextSibling ].
	^nextTry
		ifNil: [ self outermostMorphThat: [ : each | each isMauiMorph ] ]
		ifNotNil: [ nextTry nextTabStop: true ]! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/30/2004 13:50'!
noteDataRefreshed
	lastRefreshTime _ Time millisecondClockValue! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/3/2004 16:22'!
noteNewOwner: aMorph
	"Override in subclasses, prior to calling super you have the priorOwner."

	(priorOwner notNil
	and: [ priorOwner isMauiMorph
	and: [ aMorph ~~ priorOwner ] ]) 
		ifTrue: 
			[ priorOwner noteNoLongerOwning: aMorph ].
	super noteNewOwner: aMorph.
	"When you do 'MyClass maui' and drop it on the desktop, transfer keyboard focus to the newly created Morph."
	priorOwner == ActiveHand ifTrue: [ ActiveHand newKeyboardFocus: self ].
	priorOwner _ aMorph! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 8/2/2004 21:37'!
noteNoLongerOwning: aMorph
	"I used to own aMorph, now it has moved on.  If interested, subclasses may override."! !

!MauiMorph methodsFor: 'domain notifications' stamp: 'cmm 1/2/2004 14:11'!
notificationHandler

	^notificationHandler! !

!MauiMorph methodsFor: 'domain notifications' stamp: 'cmm 12/12/2004 23:59'!
notificationHandler: aMaNotificationHandler

	aMaNotificationHandler
		ifNil: [ self initializeNotificationHandler ]
		ifNotNil: [ notificationHandler _ aMaNotificationHandler ]! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 6/2/2003 00:13'!
object

	^object! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 1/5/2005 16:13'!
object: anObject

	object == anObject ifTrue: [ ^self ].  "performance"
self maMarked: 'dev'.
"This seems like good code, uncomment this and see if the reason you commented it out exposes itself."
"	(self canSupport: anObject)
		ifFalse: [ MauiUserError signal: self class printString, ' cannot support ', anObject printString ]."
	anObject isMauiPrototype ifTrue: [ self delete ].
	object ifNotNil: [ object removeDependent: self ].
	object _ anObject.
	self messageMorphsDo:
		[ : each |
		each isDomainMessage
			ifTrue:
				[ (anObject isMauiPrototype and: [ each hasResult ]) ifTrue: [ each resultMorph resetObject ].
				each receiver: anObject ] ].
	self name: anObject mauiName.
	anObject isMauiPrototype ifFalse: [ self postInitialize ].
	self noteInvocationNeeded! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 11/18/2003 23:44'!
openContextMenu

	| menu |
	menu _ self buildContextMenu.
	self
		setUpBalloonHelpIn: menu.
	menu popUpInWorld! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 1/2/2005 20:29'!
openDomainHud
	"... my messages for one that suits you."

	| readyToSendMessages methodSelector |
	Cursor wait showWhile:
		[ methodSelector _ MaMethodSelector new addSuperclassHierarchy: object class.
		readyToSendMessages _ methodSelector methods
			collect: 
				[ : each | 
				MauiMessage
					receiver: object 
					selector: each methodSymbol ] ].
	(readyToSendMessages asSortedCollection: [ : a : b | a selector < b selector ]) maNewSearchContext maui! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/1/2005 16:35'!
openInHand

	super openInHand.
	self owner = ActiveHand ifTrue: [ ActiveHand newKeyboardFocus: self ]! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 12/22/2004 22:14'!
openPointersList
	"This is helpful for debugging why certain objects do not get garbage collected."

	self pointersListMorph openInHand! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/12/2004 00:56'!
openPreferences

	self ensurePreferences maui as: #inheritanceView! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 8/11/2004 18:06'!
openToolMenu
	"... for customizing me."

	| menu |
	menu _ self buildToolMenu.
	self setUpBalloonHelpIn: menu.
	menu popUpInWorld! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 12/16/2004 01:28'!
openUiHud
	"... my user-interface messages for one that suits you."

	| readyToSendMessages methodSelector |
	Cursor wait showWhile:
		[ methodSelector _ MaMethodSelector new addSuperclassHierarchy: self class.
		readyToSendMessages _ methodSelector methods
			collect: 
				[ : each | 
				MauiMessage
					receiver: self 
					selector: each methodSymbol ] ].
	(MaCollectionContext collection: (readyToSendMessages asSortedCollection: [ : a : b | a selector < b selector ])) maui! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/11/2004 23:02'!
overridePreferencesFrom: aMauiFamily

	preferences _ (aMauiFamily preferences newOverrideFor: self)! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 12/22/2004 22:14'!
pointersListMorph
	"This is helpful for debugging why certain objects do not get garbage collected."

	| exclude mauiMorph |
	exclude _ Set with: self.
	exclude addAll: (self mauiWorld playersFor: self object).
	mauiMorph _
		(Smalltalk
			pointersTo: self object
			except: exclude) asMauiMorph.
	mauiMorph elementsView: #beDefault.
	mauiMorph listMorphsDo:
		[ : each |
		each object maAllInstVarNamesDo:
			[ : eachName |  | msg |
			msg _ each addMessageNamed: #instVarNamed:.
			msg
				invocationStrategy: MauiRepeatingInvocationStrategy new ;
				hideLabels.
			msg parameterHolderMorph dropParameter: eachName asMauiMorph ] ].
	^ mauiMorph! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 7/22/2004 11:39'!
possibleTransfersFrom: aTransferMorph

	aTransferMorph dragTransferType = #messageList
		ifTrue:
			[ ^ { self halt: 'what do you want to drop here?'. self maMarked: 'dev'. } ].
	aTransferMorph dragTransferType = #file
		ifTrue:
			[ | fd |
			fd _ FileDirectory on: aTransferMorph passenger.
			^ { fd.  aTransferMorph passenger.  fd localName } ].
	Transcript cr; show: 'MauiMorph>>possibleTransfersFrom: doesn''t support ', aTransferMorph dragTransferType.
	^ { aTransferMorph passenger }! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 1/5/2005 16:12'!
postInitialize
	"This method offers a subclass hook for initializing any object-dependent variables that could not be calculated in initialize.  Remember to call 'super postInitialize', as the code below needs to run."

	object ifNotNil:
		[ self requireChangedNotificationsForAutoRefresh ifTrue: [ object addDependent: self ] ]! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/11/2004 17:51'!
preferenceSelectors

	^ self mauiWorld userStrategy mauiMorphPreferenceSelectors! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/6/2004 17:54'!
preferences

	^ preferences ifNil:
		[ self family
			ifNil: [ MauiPreferences global ]
			ifNotNil: [ self family preferences ] ]! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/5/2004 15:55'!
preferred: preferenceSelector

	^ self preferences preferred: preferenceSelector! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/6/2004 17:55'!
preferred: preferenceSymbol is: anObject

	self ensurePreferences
		preferred: preferenceSymbol
		is: anObject! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/8/2004 23:51'!
preferredStringMorph: aString

	^ (self preferred: #stringMorph) copy
		string: aString ;
		yourself! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 11/22/2003 17:35'!
presentSelectUiMessageMenu
	"View a list of user-interface messages to add to my surface."

	self 
		presentSelectorsMenuFor: self uiBasicApi
		receiver: self
		actionSelector: #selectMessageSelectedBy:receiver:
		advancedSelectors: self uiAdvancedApi! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 11/19/2003 23:40'!
presentSelectorsMenuFor: selectors receiver: anObject actionSelector: actionSelector advancedSelectors: advancedSelectors

	| menu |
	menu _ 
		self
			buildSelectorsMenuFor: selectors 
			receiver: anObject 
			actionSelector: actionSelector 
			advancedSelectors: advancedSelectors.
	self setUpBalloonHelpIn: menu.
	menu popUpInWorld! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:29'!
priorSibling

	| siblings myPosition |
	owner ifNil: [ ^nil ].
	siblings _ owner submorphs.
	myPosition _ siblings indexOf: self.
	myPosition < 2 ifTrue: [ ^nil ].
	myPosition-1 to: 1 by: -1 do:
		[ : submorphIndex |
		(siblings at: submorphIndex) isMauiMorph ifTrue: [ ^ siblings at: submorphIndex ] ].
	^nil! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:21'!
priorTabStop

	^self priorTabStop: false! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:33'!
priorTabStop: includeMyself

	includeMyself ifTrue: [ self isTabStop ifTrue: [ ^self ] ].
	^(self priorSibling
		ifNil: [ self nextMauiOwner ifNil: [ ^nil ] ]) priorTabStop: true! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 8/3/2004 16:00'!
privateAddMorph: aMorph atIndex: index

	| needsNewOwnerSignal |
	needsNewOwnerSignal _ aMorph world isNil.
	super 
		privateAddMorph: aMorph
		atIndex: index.
	needsNewOwnerSignal ifTrue: [ aMorph noteNewOwner: self ].
	^ aMorph! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/27/2004 23:05'!
privateDelete
	"Unfortunately, I see no easier way to hook when I am deleted reliably (replaceSubmorph:by: doesn't call #delete)."

	super privateDelete.
	self allMorphsDo: [ : each | each mauiNoteOutOfWorld ]! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 7/13/2004 17:09'!
redButtonMessage: aMauiMessage

	redButtonMessage _ aMauiMessage! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/30/2004 13:51'!
refreshData
	"Used for automatic refresh of the 'data' in MauiMorphs.  By default, all MauiMorphs have their requireChangedNotificationsForAutoRefresh set to false, meaning they refresh automatically according to their desiredRefreshInterval.  But for some MauiMorphs, such as a MauiCollectionMorph with lots of elements, it could be costly to constantly rebuild the list of results.  For those, refreshing is turned off after every refresh until the next changed notification."

	needsRefreshed _ false.
	self noteDataRefreshed! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 9/12/2004 21:30'!
removeMessage: aMauiMessageMorph
	"adjusts my domain model to indicate I no longer have aMauiMessageMorph."

	| selector |
	selector _ aMauiMessageMorph message selector.
	((self hasMessageNamed: selector)
		and: [ (messageMorphs at: selector) == aMauiMessageMorph ])

		ifTrue: [ messageMorphs removeKey: selector ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 8/11/2004 16:49'!
removeMyCloseBoxFromSubmorphsOf: aMorph

	aMorph submorphs
		maDetect: [ : each | (self isMyDeleteMessage: each) ]
		ifFound: [ : deleteMessage | deleteMessage delete ]
		ifNone: [ "didn't have one, no problem." ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/30/2004 10:26'!
replaceSubmorph: subMorph by: newMorph

	"Look for a message and modify its invocation-strategy to use newMorph's view."
	self mauiWorld messageMorphsDo:
		[ : each |
		each resultMorph == subMorph
			ifTrue:
				[ each resultMorph: newMorph.
				each invocationStrategy resultView: newMorph view ] ].
	super
		replaceSubmorph: subMorph 
		by: newMorph! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 2/4/2004 22:19'!
reportOnAttribute: aSymbol

	self allMorphsDo: [ : e | Transcript cr; show: (e perform: aSymbol) printString->e printString ]! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 12/27/2004 16:34'!
requireChangedNotificationsForAutoRefresh
	"In general, Morphics #step facility eliminates the need to listen for changes.  For most fast-access getters, we just get the value from the domain and, if different from the current, update the morph.  For expensive getters, however, we utilize Smalltalk built-in listener mechanism (e.g., changed/update)."

	^ false! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/21/2004 18:16'!
resetObject

	self object: object asMauiPrototype! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/9/2004 23:25'!
resetPreferences

	preferences _ nil! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 13:05'!
resetRunningEffects

	runningEffects _ nil! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/21/2004 23:14'!
reverseDepthFirstDo: oneArgBlock
	"Enumerate my structure in a reverse depth-first fashion."

	| siblings myPosition |
self maMarked: 'dev'.  "this code is untested.."
	owner ifNil: [ ^self ].
	siblings _ owner submorphs.
	myPosition _ siblings indexOf: self.
	myPosition-1 to: 1 by: -1 do: [ : position | oneArgBlock value: (siblings at: position) ].
	owner reverseDepthFirstDo: oneArgBlock! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 14:45'!
runningMauiEffects
	^ runningEffects ifNil: [ runningEffects _ Dictionary new ]! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 7/22/2004 01:09'!
selectMessageSelectedBy: selectorSymbol receiver: anObject

	^ (MauiMessageMorph
		receiver: anObject
		selector: selectorSymbol) openInHand! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 17:23'!
selectorInFocus

	^ nil! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 11/19/2003 23:37'!
setCustomizableView
	"Let's you place messages anywhere you wish."

	self 
		layoutPolicy: nil;
		hResizing: #rigid;
		vResizing: #rigid! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/26/2004 17:34'!
setMauiBasicApi

	object class
		compile: (String streamContents:
			[ : stream |
			stream nextPutAll: 'mauiBasicApi
	^#('.
			self submorphs do: 
				[ : each | 
				each isMauiMessageMorph
					ifTrue:
						[ stream nextPutAll: each message selector; space ] ].
			stream nextPut: $) ])
		classified: '*maui'! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 11/19/2003 23:37'!
setShrinkWrapView
	"Widgets are arranged automatically in rows or columns for you.  They cannot be moved."

	self 
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 8/5/2004 14:18'!
setUpBalloonHelpIn: aMenu
	"Set up the balloon-help for aMenu accounting for my usability-preferences."

	aMenu submorphs do:
		[ : each | 
		(each maIsMenuItemMorph and: [ each maCanInvoke ])
			ifTrue:
				[ each setBalloonText:
					(self preferences preferenceOrMenuBalloonMessage: each mauiBalloonText) ] ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 13:49'!
setupSend: aMessageSend using: aMauiMorph

	^ aMessageSend 
		arguments: { aMauiMorph } ;
		yourself! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:55'!
shiftFocus: aKeyboardEvent

	aKeyboardEvent shiftPressed
		ifTrue: [ self focusOnPreviousPlayerUsing: aKeyboardEvent ]
		ifFalse: [ self focusOnNextPlayerUsing: aKeyboardEvent ].
	aKeyboardEvent wasHandled: true! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/30/2004 14:08'!
shouldRefreshData
	^ needsRefreshed
	or:
		[ self millisecondsSinceLastRefresh > self desiredRefreshInterval
		and: [ self requireChangedNotificationsForAutoRefresh not ] ]! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 8/11/2004 10:18'!
signalWhereInvalid

	super signalWhereInvalid.
	messageMorphs do:
		[ : each |
		(self submorphs includes: each) ifFalse: [ MauiSoftwareError signal ] ].
	(preferences notNil and: [ preferences target ~~ self ]) ifTrue: [ MauiSoftwareError signal ]! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 9/10/2004 12:01'!
spacerPosition

	^ spacer
		ifNil: [ submorphs size + 1 ]
		ifNotNil: [ submorphs indexOf: spacer ifAbsent: [ submorphs size + 1 ] ]! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 9/10/2004 15:36'!
startTrackingDropZones

	self
		startStepping: #trackDropZones 
		at: Time millisecondClockValue
		arguments: nil 
		stepTime: 100! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/5/2005 23:36'!
step
	
	(object isMauiPrototype or: [ self world isNil ])
		ifTrue:
			[ self stopStepping.   "we're not valid to be stepping!!"
			self mauiWorld removePlayer: self ].
	self refreshData! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 14:47'!
stepAllEffects
	self runningMauiEffects do: [ : each | each step ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/31/2004 17:01'!
stepEffect: aMauiEffect

	aMauiEffect step! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/1/2005 14:33'!
stepTime
	"This value affects the smoothness of the animation effects."
	^ 1000! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 9/10/2004 15:36'!
stopTrackingDropZones
	self stopSteppingSelector: #trackDropZones! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 7/27/2004 14:30'!
string: menuItemString withKeyBindingFor: keyBindingSymbol

	^ String streamContents:
		[ : stream |
		stream
			nextPutAll: menuItemString ;
			nextPutAll: '  (' ;
			nextPut: (self preferred: keyBindingSymbol) ;
			nextPut: $) ]! !

!MauiMorph methodsFor: 'close-box' stamp: 'cmm 8/11/2004 17:05'!
toggleCloseBox

	self hasCloseBox
		ifTrue: [ self ensureNoCloseBox ]
		ifFalse: [ self ensureCloseBox ]! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 8/11/2004 15:02'!
toggleLabelled
	"Toggle my label on and off."

	self isLabelled
		ifTrue: [ self ensureNoLabelBar ]
		ifFalse: [ self ensureLabelBar ]! !

!MauiMorph methodsFor: 'spacer' stamp: 'cmm 1/3/2005 10:52'!
trackDropZones
	"I am called many times per second when a droppable Morph is hovering, ready to be dropped onto me.  Put a 'spacer' morph whereever the current morph *could* be dropped."

	| handPosition morphsUnderHand submorphUnderHand |
	self primaryHand submorphs isEmpty
		ifTrue:
			[ self stopTrackingDropZones.
			^ self ].
	handPosition _ self primaryHand position.
	morphsUnderHand _ self morphsAt: (self globalPointToLocal: handPosition).
	morphsUnderHand size > 1 ifFalse: [ ^ self ].
	submorphUnderHand _ morphsUnderHand at: morphsUnderHand size - 1. "<-- the one held directly by me."
	submorphUnderHand == spacer ifTrue: [ ^ self ].
	((self is: handPosition inFirstHalfOf: submorphUnderHand)
	and: [ submorphUnderHand ~~ labelBar ])
		ifTrue: [ self ensureSpacerInFrontOf: submorphUnderHand ]
		ifFalse: [ self ensureSpacerBehind: submorphUnderHand ]! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 10/14/2003 22:22'!
uiAdvancedApi
	"Answer an Array of selector Symbols that you wish for MauiMorphs to have available in the add message menu option."

	| answer |
	answer _ Set new.
	self class withAllSuperclassesDo:
		[ : eachClass |
		(eachClass inheritsFrom: Morph) 
			ifTrue:
				[ eachClass advancedMauiSelectorsDo: [ : eachSelector | answer add: eachSelector ] ] ].
	^answer asSortedCollection! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 11/16/2003 23:54'!
uiBasicApi
	"Answer the Array of basic ui-configuration selector Symbols useful to beginning users of Maui."

	^#(flash beInvisible color: listDirection: layoutPolicy: hResizing: vResizing:)! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 1/1/2005 17:50'!
undelineate

	| targetColor |
	owner ifNil: [ ^ self ].
	targetColor _
		(self isInvisible
			ifTrue: [ Color transparent ]
			ifFalse: [ self defaultBorderColor ]).
	self borderColor isColor
		ifFalse: [ self borderColor: (self preferred: #colorScheme) highlightColor ].
	(MauiEffect
		target: self
		selector: #maBorderColorAlpha:
		range: (self borderColor alpha to: 0.0)
		duration: (self preferred: #transitionDuration)
		finally: [ self borderColor: targetColor ]) begin! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/30/2004 13:48'!
update: dummy

	needsRefreshed _ true! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 9/4/2003 00:58'!
usingCustomLayoutString

	^self layoutPolicy
		ifNil: [ '<on>custom' ]
		ifNotNil: [ '<off>custom' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:51'!
usingLeftToRightLayoutString

	^self listDirection = #leftToRight
		ifTrue: [ '<on>left-to-right' ]
		ifFalse: [ '<off>left-to-right' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:56'!
usingNoWrapString

	^self wrapDirection = #none
		ifTrue: [ '<on>none' ]
		ifFalse: [ '<off>none' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 11/18/2003 22:21'!
usingShrinkWrappedLayoutString

	^self layoutPolicy
		ifNil: [ '<off>automatic' ]
		ifNotNil: [ '<on>automatic' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:51'!
usingTopToBottomLayoutString

	^self listDirection = #topToBottom
		ifTrue: [ '<on>top-to-bottom' ]
		ifFalse: [ '<off>top-to-bottom' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:03'!
usingWrapBottomToTopString

	^self wrapDirection = #bottomToTop
		ifTrue: [ '<on>bottom-to-top' ]
		ifFalse: [ '<off>bottom-to-top' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:58'!
usingWrapLeftToRightString

	^self wrapDirection = #leftToRight
		ifTrue: [ '<on>left-to-right' ]
		ifFalse: [ '<off>left-to-right' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:00'!
usingWrapRightToLeftString

	^self wrapDirection = #rightToLeft
		ifTrue: [ '<on>right-to-left' ]
		ifFalse: [ '<off>right-to-left' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:02'!
usingWrapTopToBottomString

	^self wrapDirection = #topToBottom
		ifTrue: [ '<on>top-to-bottom' ]
		ifFalse: [ '<off>top-to-bottom' ]! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 12/30/2004 13:57'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	messageMorphs _ messageMorphs veryDeepCopyWith: aDeepCopier.
	priorOwner _ nil.
	redButtonMessage _ redButtonMessage veryDeepCopyWith: aDeepCopier.
	redButtonMessage receiver: self.
	labelBar _ labelBar veryDeepCopyWith: aDeepCopier.
	label _ label veryDeepCopyWith: aDeepCopier.
	self
		initializeNotificationHandler ;
		resetRunningEffects.
	lastRefreshTime _ 0.
	needsRefreshed _ true! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 12/24/2003 14:40'!
view

	^'n/a'! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/26/2004 22:20'!
wantsDroppedMorph: aMorph event: event

	aMorph isMauiMorph ifTrue: [ ^ aMorph canDropInto: self ].
	aMorph isTransferMorph 
		ifTrue: 
			[ aMorph dragTransferType = #messageList ifTrue: [ ^ (aMorph canBeMauiMessageFor: self) ].
			^ false ].
	"a pinball Morph?  Why not?"  
	^true! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 7/14/2003 21:46'!
wantsSteps

	^true! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:06'!
wrapMenu

	^MenuMorph new

		addUpdating: #usingNoWrapString target: self selector: #wrapDirection: argumentList: #(none) ;

		addUpdating: #usingWrapLeftToRightString target: self selector: #wrapDirection: argumentList: #(leftToRight) ;

		addUpdating: #usingWrapRightToLeftString target: self selector: #wrapDirection: argumentList: #(rightToLeft) ;

		addUpdating: #usingWrapTopToBottomString target: self selector: #wrapDirection: argumentList: #(topToBottom) ;

		addUpdating: #usingWrapBottomToTopString target: self selector: #wrapDirection: argumentList: #(bottomToTop) ;

		yourself! !

MauiMorph subclass: #MauiParameterHolderMorph
	instanceVariableNames: 'parameterMorph optionalParameters optionalParametersMorph optionalParametersStrategy dropMarker stringEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiParameterHolderMorph class methodsFor: 'accessing' stamp: 'cmm 1/4/2004 20:33'!
parameterHolderExtent

	^24@16! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 2/26/2004 23:39'!
acceptDroppingMorph: aMorph event: event

	aMorph isTransferMorph
		ifTrue:
			[ | possibleTransfers |
			possibleTransfers _ self possibleTransfersFrom: aMorph.
			possibleTransfers size = 1
				ifTrue: [ self dropParameter: possibleTransfers anyOne asMauiMorph ]
				ifFalse:
					[ | selectionDialog |
					selectionDialog _ possibleTransfers asMauiMorph.
					selectionDialog addMorph:
						(StringMorph new contents: 'Choose the form of ', aMorph dragTransferType ; yourself).
					event hand attachMorph: selectionDialog ] ]
		ifFalse: [ self dropParameter: aMorph ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 7/29/2004 15:34'!
addOptionalParameter: anObject
	"Drop a suggested parameter and it will remain easily accessible by invoking the red (left) button on the parameter-holder."
	"(^^^ that's the users balloon help ^^^)"

	optionalParameters add: anObject! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2004 13:15'!
argumentIndex

	^ self myMessageMorph indexOfHolder: self! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2004 13:15'!
argumentName

	^ self message argumentNameAt: self argumentIndex! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 2/5/2004 00:53'!
argumentType

	^Utilities
		classFromPattern: self argumentName
		withCaption: nil! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 12/3/2004 11:08'!
balloonHelpString

	| argName |
	^ (argName _ self argumentName)
		ifNil: [ 'This parameter is not valid because the message is not valid.' ]
		ifNotNil:
			[ 'Supply ', (self mauiWorld userStrategy nameFor: argName) ]! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 2/5/2004 00:52'!
browseParameterHierarchy

	| type |
	type _ self argumentType.  "answers the class of the argument"
	type ifNil: [ ^ self ].
	Utilities
		spawnHierarchyForClass: type
		selector: self message selector! !

!MauiParameterHolderMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:40'!
buildContextMenu

	| answer |
	answer _ MenuMorph new.
	self mauiWorld userStrategy
		appendParameterHolderMenuItemsTo: answer
		for: self.
	^ answer! !

!MauiParameterHolderMorph methodsFor: 'menu' stamp: 'cmm 8/5/2004 15:34'!
buildToolMenu

	| menu |
	menu _ (MenuMorph entitled: object mauiName)
		defaultTarget: self;
		yourself.
	menu
		add: 'edit optional-parameters...'
		target: self
		selector: #editOptionalValues.
	menu
		add: 'select evaluator...'
		target: self
		selector: #selectEvaluator.
	^ menu! !

!MauiParameterHolderMorph methodsFor: 'testing' stamp: 'cmm 11/11/2003 00:44'!
canSupport: anObject
	"For Morphs whose object is themself, override the default canSupport:."

	^anObject class = self class or: [ self class inheritsFrom: anObject class ]! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 1/1/2005 14:57'!
defaultBorderColor

	^ #complexInset! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 2/23/2004 23:04'!
deleteParameterMorph

	self hasParameter
		ifTrue:
			[ parameterMorph delete.
			parameterMorph _ nil ]! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 1/10/2005 23:33'!
dropParameter: aMorphOrMauiMorph

	self setParameter: aMorphOrMauiMorph.
	[ self myMessageMorph parameterDropped ]
		ensure:
			[ optionalParametersStrategy 
				parameterDropped: aMorphOrMauiMorph
				into: self.
	self hideDropMarker ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/16/2004 16:46'!
editOptionalValues
	"to be selected by clicking in the parameter-holder."
	| answer |
	answer _ MauiMorph plainDialogLabelled: 'Edit Optional Parameters' for: self.
	answer
		listDirection: #leftToRight ;
		wrapDirection: #leftToRight.
	answer addMessage:
		((MauiMessageMorph
			receiver: answer object
			selector: #addOptionalParameter:)

			labelAt: 1 put: 'add:';
			yourself).
	answer addMessage:
		((MauiMessageMorph
			receiver: answer object
			selector: #removeOptionalParameter:)

			labelAt: 1 put: 'remove:';
			yourself).
	answer addMessage:
		((MauiMessageMorph
			receiver: answer object
			selector: #optionalParameters:)

			labelAt: 1 put: 'set to:';
			yourself).
	answer addMessage:
		((MauiMessageMorph
			receiver: answer object
			selector: #resetOptionalParameters)

			labelAt: 1 put: 'reset';
			yourself).
	answer addMessage: (self optionalParametersStrategyMessageFor: answer).
	answer addMessage:
		((MauiMessageMorph
			receiver: answer object
			selector: #optionalParameters)

			hideLabels;
			invocationStrategy: MauiRepeatingInvocationStrategy new ;
			yourself).
	answer openInHand! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/8/2004 21:27'!
ensureNoOptionalParametersMorph

	optionalParametersMorph ifNotNil: [ optionalParametersMorph delete ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 1/26/2004 15:35'!
ensureNoStringEditor

	stringEditor ifNotNil:
		[ stringEditor delete.
		stringEditor breakDependents.
		stringEditor _ nil.
		self initializeExtent ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 1/14/2004 01:01'!
ensureStringEditor

	stringEditor
		ifNil:
			[ self initializeStringEditor.
			self addMorph: stringEditor ]! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 12/21/2003 20:56'!
family

	^self myMessageMorph family! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 7/16/2004 14:40'!
handleKeystroke: aKeyboardEvent

	| keyPressed |
	aKeyboardEvent wasHandled ifTrue: [ ^self ].
	self mauiWorld userStrategy
		handleParameterHolderKeyboardEvent: aKeyboardEvent
		for: self.
	aKeyboardEvent wasHandled ifTrue: [ ^self ].
	keyPressed _ aKeyboardEvent keyCharacter.
	keyPressed = (self preferred: #keyForCancelEdit) ifTrue: [ ^ self ].
	keyPressed = (self preferred: #keyForAccept) ifTrue: [ ^ self ].
	keyPressed = (self preferred: #keyForFocusShift) ifTrue: [ ^ self shiftFocus: aKeyboardEvent ].
	self ensureStringEditor.
	aKeyboardEvent hand newKeyboardFocus: stringEditor.
	stringEditor handleKeystroke: aKeyboardEvent! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 7/22/2004 17:30'!
handleRedButton

	optionalParameters isEmpty
		ifTrue:
			[ self ensureStringEditor.
			ActiveHand newKeyboardFocus: stringEditor. ]
		ifFalse: [ self selectOptionalParameters ]! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 1/7/2004 23:18'!
handlesMouseOverDragging: evt

	^self handlesBasicMouseOverDrag: evt! !

!MauiParameterHolderMorph methodsFor: 'testing' stamp: 'cmm 1/7/2005 17:44'!
hasParameter

	^ parameterMorph notNil and: [ parameterMorph owner == self ]! !

!MauiParameterHolderMorph methodsFor: 'drop marker' stamp: 'cmm 7/30/2004 17:17'!
hideDropMarker

	dropMarker ifNotNil: [ dropMarker shrinkAndDelete ]! !

!MauiParameterHolderMorph methodsFor: 'drop marker' stamp: 'cmm 8/3/2004 16:31'!
initialMarkerExtentOf: aMauiSpacer

	^ self extent - (self layoutInset*2+2)! !

!MauiParameterHolderMorph methodsFor: 'initializing' stamp: 'cmm 1/7/2005 17:49'!
initialize

	super initialize.
	self
		initializeExtent;
		useSquareCorners;
		layoutInset: 7@2;  "need a little width for the user to position hand to type"
		cellInset: 2;
		dropEnabled: true;
		listDirection: #topToBottom ;
		borderColor: self defaultBorderColor.
	self object: self  "I will invoke any messages added to me.".
	self resetOptionalParameters.
	optionalParametersStrategy _ MauiClickAndPickParameterStrategy new! !

!MauiParameterHolderMorph methodsFor: 'initializing' stamp: 'cmm 8/8/2004 23:42'!
initializeColor

	self color: Color black! !

!MauiParameterHolderMorph methodsFor: 'initializing' stamp: 'cmm 9/18/2003 00:52'!
initializeExtent

	self extent: self class parameterHolderExtent! !

!MauiParameterHolderMorph methodsFor: 'initializing' stamp: 'cmm 1/8/2005 12:52'!
initializeOptionalParametersMorph

	optionalParametersMorph ifNotNil: [ optionalParametersMorph delete ].
	optionalParametersMorph _ optionalParameters asMauiMorph
		cellPositioning: #topLeft ;
		labelString: 'Select:' ;
		ensureLabelBar ;
		sticky: true ;
		yourself.
	self onParameterListEntryDo:
		(MessageSend
			receiver: self  "this is updated in setupSend:using:"
			selector: #redButtonMessage:
			argument:
				(MauiMessage
					receiver: self
					selector: #dropParameter:
					arguments: { 'TBD' })).
	^ optionalParametersMorph! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 8/5/2004 22:15'!
initializeStringEditor

	stringEditor ifNotNil: [ self ensureNoStringEditor ].
	stringEditor _ (self preferred: #stringEditor) copy.
	stringEditor addDependent: self! !

!MauiParameterHolderMorph methodsFor: 'testing' stamp: 'cmm 11/2/2003 20:17'!
isMauiParameterHolderMorph

	^true! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 12/31/2004 16:28'!
keyboardFocusChange: gainedFocus

	gainedFocus
		ifTrue: [ self delineate ]
		ifFalse: "lost focus" [ self undelineate ]! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 2/5/2004 00:25'!
message

	^self myMessageMorph message! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 1/8/2004 00:03'!
mouseEnterDragging: evt

	self showDropMarker! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 12/31/2004 16:23'!
mouseLeave: aMouseMoveEvent

	super mouseLeave: aMouseMoveEvent.
	(stringEditor notNil and: [ stringEditor contents isEmpty ]) 
		ifTrue:
			[ self ensureNoStringEditor ]! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 1/8/2004 00:08'!
mouseLeaveDragging: evt

	self
		hideDropMarker;
		initializeExtent! !

!MauiParameterHolderMorph methodsFor: 'private' stamp: 'cmm 9/26/2003 00:17'!
myMessageMorph

	^self owner! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 2/5/2004 21:44'!
nextTabStop

	^super nextTabStop nextTabStop ! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 8/2/2004 21:37'!
noteNoLongerOwning: aMorph

	aMorph == parameterMorph ifTrue: [ parameterMorph _ nil ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/24/2003 12:36'!
onParameterListEntryDo: oneArgBlock

	optionalParametersMorph onListEntryDo: oneArgBlock! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/6/2004 10:59'!
optionalParameterMorphFor: anObject

	self optionalParametersMorph listMorphsDo:
		[ : each | each object = anObject ifTrue: [ ^each ] ].
	"this shouldn't be necessary."
	^anObject asMauiMorph! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 11/27/2003 18:11'!
optionalParameters

	^optionalParameters! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/6/2004 10:54'!
optionalParameters: aCollection
	"Can be used to share optional-parameters with another view so they can be maintained in one place."

	optionalParameters _ aCollection.
	self resetOptionalParametersMorph! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/6/2004 10:54'!
optionalParametersMorph

	^ optionalParametersMorph ifNil: [ self initializeOptionalParametersMorph ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/22/2003 22:11'!
optionalParametersStrategy

	^optionalParametersStrategy! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 1/7/2005 00:00'!
optionalParametersStrategy: aMauiOptionalParametersStrategy

	optionalParametersStrategy _ aMauiOptionalParametersStrategy.
	aMauiOptionalParametersStrategy initializeUsing: self! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/11/2004 12:56'!
optionalParametersStrategyMessageFor: aMauiMorph

	| answer |
	answer _ 
		MauiMessageMorph
			receiver: aMauiMorph object
			selector: #optionalParametersStrategy:.
	MauiOptionalParametersStrategy allSubclassesDo:
		[ : eachInvocationStrategyClass |
		(answer parameterHolderMorphAt: 1) addOptionalParameter: eachInvocationStrategyClass new ].
	(answer parameterHolderMorphAt: 1) optionalParametersStrategy: MauiClickAndPickParameterStrategy new.
	answer beGetterSetter.
	^answer! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 10/1/2003 20:47'!
parameterMorph

	^parameterMorph! !

!MauiParameterHolderMorph methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:30'!
preferenceSelectors

	^ self mauiWorld userStrategy mauiParameterHolderMorphPreferenceSelectors! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 8/5/2004 22:38'!
preferences

	^ self myMessageMorph
		ifNil: [ MauiPreferences global ]
		ifNotNil: [ super preferences ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/25/2003 20:29'!
removeOptionalParameter: anObject
	"Remove anObject as one of the optional parameters that appears when you click the red (left) button on parameter-holder."

	optionalParameters remove: anObject! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 9/4/2003 23:46'!
reset

	self deleteParameterMorph.
	self initializeExtent! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 7/25/2004 22:57'!
resetOptionalParameters
	"... and get my own new, independent collection of optional parameters."
	self optionalParameters: OrderedCollection new! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/6/2004 10:54'!
resetOptionalParametersMorph

	optionalParametersMorph _ nil! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 8/11/2004 12:56'!
selectEvaluator
	"to interpret expressions typed directly into the parameter-holder."
	| answer currentEvaluatorMessage |
	answer _ MauiMorph plainDialogLabelled: 'Select String Evaluator' for: self.
	answer
		listDirection: #topToBottom ;
		wrapDirection: #none.
	currentEvaluatorMessage _
		MauiMessageMorph
			receiver: answer object
			selector: #stringEvaluator:.
	currentEvaluatorMessage listDirection: #topToBottom.
	currentEvaluatorMessage invocationStrategy resultView: #beIconic.
	MauiStringEvaluator withAllSubclassesDo:
		[ : eachEvaluatorClass |
		(currentEvaluatorMessage parameterHolderMorphAt: 1) addOptionalParameter: eachEvaluatorClass ].
	(currentEvaluatorMessage parameterHolderMorphAt: 1) optionalParametersStrategy: MauiListSelectionStrategy new.
	currentEvaluatorMessage beGetterSetter.
	answer addMessage: currentEvaluatorMessage.
	answer openInHand! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/22/2003 22:11'!
selectOptionalParameters

	self optionalParametersStrategy selectUsing: self! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 1/8/2005 12:44'!
setParameter: aMauiMorph.

	self deleteParameterMorph.
	parameterMorph _ aMauiMorph.
	self addMorphFront: parameterMorph! !

!MauiParameterHolderMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 14:03'!
setupSend: aMessageSend using: aMauiMorph
	"Set up aMessageSend to set its redButtonMessage: so that it will, upon activation, invoke dropParameter: (which was set in initializeOptionalParametersMorph) to faciliate 'combo-box' style behavior."
	aMessageSend selector = #redButtonMessage:
		ifTrue:
			[ "see initializeOptionalParametersMorph"
			aMessageSend receiver: aMauiMorph.
			"Here, we copy the MauiMessage that invokes #dropParameter:, that way they can all have their own argument, aMauiMorph.  Whew, this is *complicated!!*"
			aMessageSend arguments
				at: 1
				put: aMessageSend arguments first commonCopy.
			(aMessageSend arguments at: 1) "The MauiMessage self>>#dropParameter:"
				arguments: (Array with: aMauiMorph) ]
		ifFalse:
			[ aMessageSend arguments: (Array with: aMauiMorph) ].
	^ aMessageSend! !

!MauiParameterHolderMorph methodsFor: 'drop marker' stamp: 'cmm 8/2/2004 11:06'!
showDropMarker

	dropMarker
		ifNil: [ dropMarker _ self newDropMarkerFor: self ]
		ifNotNil: [ dropMarker targetExtent: self extentOfDraggedMorph ].
	self addMorphBack: dropMarker.
	dropMarker startStepping! !

!MauiParameterHolderMorph methodsFor: 'debugging' stamp: 'cmm 1/7/2005 17:45'!
signalWhereInvalid

	super signalWhereInvalid.
self maMarked: 'dev'.  "This check is no longer necessary."
	self hasParameter 
		ifTrue: 
			[ (self submorphs includes: parameterMorph) ifFalse: [ MauiSoftwareError signal ] ].
	optionalParametersMorph ifNotNil: [ optionalParametersMorph signalWhereInvalid ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 8/5/2004 16:29'!
stringEvaluator

	^ (self preferred: #stringEditor) evaluator! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 8/5/2004 16:26'!
stringEvaluator: aMauiStringEvaluatorClass

	| replacementStringEditor |
	replacementStringEditor _ (self preferred: #stringEditor) copy.
	replacementStringEditor evaluator: aMauiStringEvaluatorClass.
	self
		preferred: #stringEditor
		is: replacementStringEditor! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 11/27/2003 18:41'!
uiBasicApi

	^super uiBasicApi, #(optionalParameters addOptionalParameter: removeOptionalParameter:)! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 8/9/2004 21:53'!
update: anAssociation
	"This is signaled from MauiStringEditor>>#handleKeystroke:"
	| keyPressed keyboardEvent mauiStringEditor |
	anAssociation key = #keyboardEvent ifFalse: [ ^ self ].
	keyboardEvent _ anAssociation value first.
	keyPressed _ keyboardEvent keyCharacter.
	mauiStringEditor _ anAssociation value last.
	(keyPressed = (self preferred: #keyForAccept)
	and: [ keyboardEvent shiftPressed = (self preferred: #modifierForAccept)
	or: [ (self preferred: #modifierForAccept) = false "allow back-tabbing" ] ])
		ifTrue:
			[ "user wants to drop the value"
			self dropParameter: mauiStringEditor evaluatedContents asMauiMorph.
			self ensureNoStringEditor.
			keyboardEvent wasHandled: true ].
	(keyPressed = (self preferred: #keyForFocusShift)
	and: [ keyboardEvent shiftPressed = (self preferred: #modifierForFocusShift) ])
		ifTrue:
			[ self
				dropParameter: mauiStringEditor evaluatedContents asMauiMorph ;
				ensureNoStringEditor.
			keyboardEvent shiftPressed
				ifTrue: [ keyboardEvent hand newKeyboardFocus: self priorTabStop ]
				ifFalse: [ keyboardEvent hand newKeyboardFocus: self nextTabStop ].
			keyboardEvent wasHandled: true ].
	keyPressed = (self preferred: #keyForCancelEdit)
		ifTrue:
			[ self ensureNoStringEditor.
			keyboardEvent wasHandled: true ]! !

!MauiParameterHolderMorph methodsFor: 'copying' stamp: 'cmm 7/23/2004 15:13'!
veryDeepFixupWith: aDeepCopier

	super veryDeepFixupWith: aDeepCopier.
	"These are 'dynamic' things, not part of the desired save, so we clean them up, just in case."
	self 
		ensureNoStringEditor ;
		hideDropMarker! !

!MauiParameterHolderMorph methodsFor: 'copying' stamp: 'cmm 8/14/2004 11:54'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	"We allow sharing of optional parameters, so we don't want to ruin that if the user has decided to share."
	optionalParametersMorph _ optionalParametersMorph veryDeepCopyWith: aDeepCopier.
	optionalParametersStrategy _ optionalParametersStrategy veryDeepCopyWith: aDeepCopier.
	parameterMorph _ parameterMorph veryDeepCopyWith: aDeepCopier.
	dropMarker _ dropMarker veryDeepCopyWith: aDeepCopier.
	stringEditor _ stringEditor veryDeepCopyWith: aDeepCopier! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 8/15/2004 23:36'!
wantsDroppedMorph: aMorph event: event

	self myMessageMorph isDomainMessage ifFalse: [ ^ true ].
	aMorph isTransferMorph ifTrue: [ ^ true ].
	aMorph isMauiMorph ifFalse: [ ^ false ].
	aMorph isMauiMessageMorph ifTrue: [ ^ false ]. "so reordering isn't so clunky"
	aMorph isDialog ifTrue: [ ^ false ].
	^ true! !

RectangleMorph subclass: #MauiSpacer
	instanceVariableNames: 'targetExtent firstStepTime deltaExtent delete client originalExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiSpacer class methodsFor: 'test' stamp: 'cmm 7/30/2004 17:14'!
example2

	[ | s |
	s _ 
		self
			originalExtent: 4@4
			targetExtent: 200@20.
	s openInWorld; position: 50@50.
	"wait until opened"
	[ s world isNil ] whileTrue: [ ].
	(Delay forMilliseconds: 90) wait.
	s shrinkAndDelete ] fork! !

!MauiSpacer class methodsFor: 'create' stamp: 'cmm 8/2/2004 10:29'!
for: aMauiMorph targetExtent: targetExtentPoint

	^ self new
		client: aMauiMorph ;
		targetExtent: targetExtentPoint ;
		yourself! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/3/2004 21:56'!
client: aMauiMorph

	client _ aMauiMorph.
	self originalExtent: (aMauiMorph initialMarkerExtentOf: self)! !

!MauiSpacer methodsFor: 'operate' stamp: 'cmm 8/2/2004 12:02'!
delete: aBoolean

	delete _ aBoolean! !

!MauiSpacer methodsFor: 'private' stamp: 'cmm 8/2/2004 23:16'!
desiredDuration

	^ 111 "milliseconds"! !

!MauiSpacer methodsFor: 'private' stamp: 'cmm 8/1/2004 23:41'!
elapsedTime

	^ (Time millisecondClockValue - firstStepTime) max: 1! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/2/2004 12:03'!
initialize

	super initialize.
	self
		delete: false ;
		borderWidth: 1 ;
		color: Color transparent ;
		borderColor: Color transparent! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/2/2004 10:30'!
originalExtent: aPoint

	originalExtent _ aPoint.
	self extent: aPoint! !

!MauiSpacer methodsFor: 'private' stamp: 'cmm 8/1/2004 23:44'!
reachedTargetExtent

	^ delete
		ifTrue: [ self extent <= targetExtent ]
		ifFalse: [ self extent >= targetExtent ]! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/2/2004 10:38'!
reset
	"I have not reachedTargetExtent, prepare to step my way there."
	self
		color: Color transparent ;
		borderColor: Color transparent.
	deltaExtent _ targetExtent - self extent.
	"since we are resetting our extents, we need to reset the flag that allows the animation."
	firstStepTime _ nil! !

!MauiSpacer methodsFor: 'operate' stamp: 'cmm 8/2/2004 12:04'!
shrinkAndDelete

	self world 
		ifNil: [ self delete ]
		ifNotNil:
			[ self
				targetExtent: originalExtent ;
				delete: true ;
				startStepping ]! !

!MauiSpacer methodsFor: 'Morphic' stamp: 'cmm 8/5/2004 14:51'!
step

	firstStepTime ifNil: [ firstStepTime _ Time millisecondClockValue ].
	self extent: 
		(delete
			ifTrue:
				[ originalExtent + deltaExtent abs + (deltaExtent * self elapsedTime // self desiredDuration) ]
			ifFalse:
				[ originalExtent + (deltaExtent * self elapsedTime // self desiredDuration) ]).
	(self elapsedTime > self desiredDuration or: [ self reachedTargetExtent ])
		ifTrue: 
			[ self extent: targetExtent.
			World doOneCycle. "gotta make sure it happens."
			self stopStepping.
			delete 
				ifTrue: [ self delete ]
				ifFalse: [ self borderColor: (client preferred: #colorScheme) highlightColor ] ]! !

!MauiSpacer methodsFor: 'Morphic' stamp: 'cmm 7/30/2004 16:31'!
stepTime

	^ 0! !

!MauiSpacer methodsFor: 'accessing' stamp: 'cmm 8/3/2004 16:31'!
targetExtent

	^ targetExtent! !

!MauiSpacer methodsFor: 'operate' stamp: 'cmm 8/2/2004 12:04'!
targetExtent: aPoint

	targetExtent _ aPoint.
	self delete: false.
	self reset! !

!MauiSpacer methodsFor: 'copying' stamp: 'cmm 8/1/2004 21:54'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	client _ client veryDeepCopyWith: aDeepCopier! !

TextMorph subclass: #MauiStringEditor
	instanceVariableNames: 'maxExtent scroller evaluator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiStringEditor commentStamp: 'cmm 8/5/2004 00:05' prior: 0!
I start out extremely narrow as the first line is typed.  But I don't want to extend to the full maxExtent x if there's only one line.  Instead, I go to one-seventh the width of the screen before wrapping to the second line.

As number of lines increases, I try to maintain a reasonably squarish shape, meaning my width increases.  Once my height consumes half the screen, I add a vertical scroll bar.!

!MauiStringEditor methodsFor: 'scroller' stamp: 'cmm 6/1/2004 01:05'!
addScroller

	| scrollerRect |
	self ensureNoScroller.
	scrollerRect _ RectangleMorph new
		borderWidth: 0;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	scroller _ MauiScrollPane new
		borderWidth: 0;
		extent: maxExtent ;
		hResizing: #spaceFill.
	owner
		replaceSubmorph: self
		by: scroller.
	scrollerRect addMorph: self.
	self margins: (0@0 corner: (self scrollBarWidth+8)@0).
	scroller scroller
		hResizing: #spaceFill ;
		addMorph: scrollerRect.
	scroller maFixScrollBar.
	scroller scrollBarWidth: self scrollBarWidth.! !

!MauiStringEditor methodsFor: 'extent' stamp: 'cmm 8/6/2004 09:59'!
adjustExtent

	| textWidth minimumNumberOfLines minimumHeight |
	textWidth _ self contentsWidth.
	minimumNumberOfLines _ (textWidth // self width) max: 1.
	minimumNumberOfLines = 1
		ifTrue:
			[ self setWidthIfNecessary: (textWidth min: self compactWidth) ]
		ifFalse:
			[ minimumHeight _ minimumNumberOfLines * textStyle defaultFont height.
			(minimumHeight*4//3) > self width  "if we're getting to tall"
				ifTrue: 
					[ "new width based on height"  
					self setWidthIfNecessary: minimumHeight * 4 // 3 ] ].
	self adjustScroller! !

!MauiStringEditor methodsFor: 'scroller' stamp: 'cmm 2/20/2004 18:07'!
adjustScroller

	self height > maxExtent y
		ifTrue: [ self ensureScroller.  scroller maFixScrollBar ]
		ifFalse: [ self ensureNoScroller ]! !

!MauiStringEditor methodsFor: 'accessing' stamp: 'cmm 8/4/2004 17:36'!
compactWidth
	"The width before the first-line of text should wrap to the next line."

	^ World width // 7! !

!MauiStringEditor methodsFor: 'accessing' stamp: 'cmm 8/6/2004 09:56'!
contentsWidth

	^ textStyle defaultFont widthOfString: self contents string! !

!MauiStringEditor methodsFor: 'Morphic' stamp: 'cmm 8/4/2004 23:18'!
delete
	"If I have a scroller, then I am wrapped inside it and that is what needs deleting."

	self hasScroller ifTrue: [ self ensureNoScroller ].
	self breakDependents.
	super delete.! !

!MauiStringEditor methodsFor: 'scroller' stamp: 'cmm 1/25/2004 16:54'!
ensureNoScroller

	scroller ifNotNil: 
		[ scroller owner
			replaceSubmorph: scroller
			by: self.
		scroller _ nil.
		self changed: #ensureNoScroller->self ]! !

!MauiStringEditor methodsFor: 'scroller' stamp: 'cmm 8/4/2004 23:17'!
ensureScroller

	self hasScroller
		ifFalse:
	
		[ self
	
			addScroller ;
	
			changed: #ensureScroller->self ]! !

!MauiStringEditor methodsFor: 'evaluation' stamp: 'cmm 8/8/2004 21:37'!
evaluatedContents
	"Answer an object the result of evaluating my contents.  If it is an uncompilable expression, then return the exacly entered expression as a String."

	^ evaluator 
		evaluate: self userString
		for: self! !

!MauiStringEditor methodsFor: 'evaluation' stamp: 'cmm 8/5/2004 16:29'!
evaluator

	^ evaluator! !

!MauiStringEditor methodsFor: 'evaluation' stamp: 'cmm 8/5/2004 15:36'!
evaluator: aMauiStringEvaluator

	evaluator _ aMauiStringEvaluator! !

!MauiStringEditor methodsFor: 'Morphic' stamp: 'cmm 2/24/2004 22:29'!
handleKeystroke: aKeyboardEvent

	| didTypeChar |
	didTypeChar _ false.
	aKeyboardEvent wasHandled ifTrue: [ ^self ].
	self changed: #keyboardEvent->{ aKeyboardEvent.  self }.
	aKeyboardEvent wasHandled 
		ifFalse: 
			[ super handleKeystroke: aKeyboardEvent.
			didTypeChar _ true ].
	didTypeChar 
		ifTrue: 
			[ self adjustExtent.
"			WorldState addDeferredUIMessage:
				(MessageSend
					receiver: self
					selector: #reinstateFocus:start:stop:
					arguments: { aKeyboardEvent. paragraph instVarNamed: 'selectionStart'.  paragraph instVarNamed: 'selectionStop' })" ].
	aKeyboardEvent wasHandled: true! !

!MauiStringEditor methodsFor: 'Morphic' stamp: 'cmm 1/24/2004 14:43'!
handlesMouseDown: aMouseEvent

	^aMouseEvent redButtonPressed! !

!MauiStringEditor methodsFor: 'scroller' stamp: 'cmm 8/4/2004 23:17'!
hasScroller

	^ scroller notNil! !

!MauiStringEditor methodsFor: 'initialize' stamp: 'cmm 8/5/2004 15:35'!
initialize

	super initialize.
	self 
		initializeMaxExtent ;
		autoFit: true;
		width: 10;
		contentsWrapped: '' ;
		textColor: Color green ;
		backgroundColor: (Color r: 0.1 g: 0 b: 0.8 alpha: 0.7) ;
		evaluator: MauiSmalltalkEvaluator! !

!MauiStringEditor methodsFor: 'initialize' stamp: 'cmm 8/4/2004 17:34'!
initializeMaxExtent

	maxExtent _ (World width // 2) @ (World height // 2)! !

!MauiStringEditor methodsFor: 'accessing' stamp: 'cmm 1/25/2004 18:04'!
maxExtent

	^maxExtent! !

!MauiStringEditor methodsFor: 'extent' stamp: 'cmm 1/25/2004 11:40'!
newContents: aString

	super newContents: aString.
	self changed: #newContents: -> nil.
	self adjustExtent! !

!MauiStringEditor methodsFor: 'Morphic' stamp: 'cmm 1/25/2004 17:56'!
noteNewOwnerExtent: aPoint

	scroller ifNotNil: [ scroller extent: aPoint ]! !

!MauiStringEditor methodsFor: 'evaluation' stamp: 'cmm 1/14/2004 00:46'!
notify: error at: location in: source
	"This is sent by the Compiler when I am used as the requestor (passed in the notifying: parameter)."
	Transcript cr; show: 'syntax error.'.
	Exception signal: 'syntax error'! !

!MauiStringEditor methodsFor: 'accessing' stamp: 'cmm 1/14/2004 00:18'!
preferred: preferenceSelector

	^MauiPreferences global perform: preferenceSelector! !

!MauiStringEditor methodsFor: 'Morphic' stamp: 'cmm 2/24/2004 22:30'!
reinstateFocus: aKeyboardEvent start: start stop: stop
"This method doesn't work.  When typing, the cursor position still goes back to the beginning as soon as the scroll bar appears.."
	World doOneCycle.
	aKeyboardEvent hand newKeyboardFocus: self.
	paragraph
		selectionStart: start
		selectionStop: stop! !

!MauiStringEditor methodsFor: 'scroller' stamp: 'cmm 1/24/2004 15:26'!
scrollBarWidth

	^10! !

!MauiStringEditor methodsFor: 'evaluation' stamp: 'cmm 1/14/2004 00:56'!
selectionInterval

	^1 to: self userString size! !

!MauiStringEditor methodsFor: 'extent' stamp: 'cmm 8/4/2004 23:21'!
setWidthIfNecessary: width
	"Necessary if the user has not already made me bigger than my maxExtent."

	"has the user resized me manually?  How do we check?"
	(false or: [ self hasScroller ])
		ifFalse: [ self width: (width+3 min: maxExtent x) ]! !

!MauiStringEditor methodsFor: 'Morphic' stamp: 'cmm 1/25/2004 20:40'!
step

	"Transcript cr; show: (paragraph instVarNamed: 'selectionStart') printString"! !

!MauiStringEditor methodsFor: 'copying' stamp: 'cmm 8/4/2004 00:13'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	scroller _ scroller veryDeepCopyWith: aDeepCopier! !

!TextMorph methodsFor: '*maui' stamp: 'cmm 1/21/2004 23:54'!
mauiBasicApi
	^#(contents: contents contentsWrapped: isAutoFit autoFit: isWrapped )! !

!SystemWindow methodsFor: '*maui' stamp: 'cmm 1/19/2004 23:15'!
canDropIntoMauiMorph

	^false! !

!BorderedMorph class methodsFor: '*maui' stamp: 'cmm 10/14/2003 22:27'!
advancedMauiSelectorsDo: aBlock

	self selectorsDo:
		[ : each |  | c |
		c _ self organization categoryOfElement: each.
		(c isNil or: [ c beginsWith: 'private' ]) ifFalse: [ aBlock value: each ] ]! !

MaObject subclass: #MaClientProcess
	instanceVariableNames: 'process progress shouldStop waiterOnStop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MaClientProcess class methodsFor: 'as yet unclassified' stamp: 'cmm 8/4/2003 12:17'!
doBlock: aBlock

	^self new
		doBlock: aBlock;
		postInitialize;
		yourself! !

!MaClientProcess methodsFor: 'private' stamp: 'cmm 11/16/2003 21:42'!
doBlock: aBlock

	process _
		[ 
		[ [ aBlock value ] ensure: [ progress stop ] ]
			on: MaProgressNotification
			do:
				[ : noti |
				progress updateFrom: noti.
				noti resume ] ] newProcess! !

!MaClientProcess methodsFor: 'private' stamp: 'cmm 1/19/2004 22:06'!
initialize

	shouldStop _ true.
	progress _ MaProgressor new.
	self unitsVerbPhrase: 'items processed'.
	waiterOnStop _ Semaphore new! !

!MaClientProcess methodsFor: 'testing' stamp: 'cmm 6/30/2003 16:20'!
isRunning

	^progress isRunning! !

!MaClientProcess methodsFor: 'actions' stamp: 'cmm 1/19/2004 22:50'!
pleaseStop
	"Set my shouldStop flag true."

	shouldStop _ true.
	self isRunning ifTrue: [ waiterOnStop wait ].
	self stop! !

!MaClientProcess methodsFor: 'private' stamp: 'cmm 11/13/2003 23:49'!
postInitialize

	self priority: Processor userBackgroundPriority! !

!MaClientProcess methodsFor: 'accessing' stamp: 'cmm 7/10/2003 23:36'!
priority: anInteger

	process priority: anInteger! !

!MaClientProcess methodsFor: 'accessing' stamp: 'cmm 6/24/2003 17:15'!
progress

	^progress! !

!MaClientProcess methodsFor: 'accessing' stamp: 'cmm 1/19/2004 21:46'!
resume
	"... when you're ready to continue."
	progress start.
	process resume! !

!MaClientProcess methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:35'!
runningTime

	^progress runningTime! !

!MaClientProcess methodsFor: 'testing' stamp: 'cmm 6/24/2003 16:39'!
shouldStop

	^shouldStop! !

!MaClientProcess methodsFor: 'actions' stamp: 'cmm 2/25/2004 00:01'!
signalWaiterOnStop
	"If your process has been asked to pleaseStop, be sure to call this method."

	waiterOnStop signal! !

!MaClientProcess methodsFor: 'actions' stamp: 'cmm 8/17/2003 23:48'!
start

	shouldStop _ false.
	progress start.
	process resume! !

!MaClientProcess methodsFor: 'actions' stamp: 'cmm 6/30/2003 17:28'!
stop

	progress stop! !

!MaClientProcess methodsFor: 'actions' stamp: 'cmm 1/19/2004 21:45'!
suspend
	"Pause the running of this process, lightening cpu burden."
	progress stop.
	process suspend! !

!MaClientProcess methodsFor: 'actions' stamp: 'cmm 11/17/2003 21:46'!
terminate

	progress stop.
	process terminate! !

!MaClientProcess methodsFor: 'actions' stamp: 'cmm 6/30/2003 16:30'!
terminateProcess
	"Should be used only after you've sent #pleaseStop."

	process terminate! !

!MaClientProcess methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:54'!
unitsVerbPhrase: aString

	progress unitsVerbPhrase: aString! !

MaObject subclass: #MaPlotSpecification
	instanceVariableNames: 'title series style'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MaPlotSpecification class methodsFor: 'creation' stamp: 'cmm 5/21/2003 22:46'!
title: aString

	^self new title: aString! !

!MaPlotSpecification methodsFor: 'accessing' stamp: 'cmm 6/3/2003 21:32'!
addAllSeries: aCollection

	aCollection do: [ : each | self addSerie: each ]! !

!MaPlotSpecification methodsFor: 'accessing' stamp: 'cmm 6/2/2003 00:46'!
addSerie: aPlotSerie

	series
		at: aPlotSerie name
		ifAbsentPut: [ aPlotSerie ]! !

!MaPlotSpecification methodsFor: 'private' stamp: 'cmm 5/21/2003 22:44'!
initialize

	super initialize.
	series _ Dictionary new! !

!MaPlotSpecification methodsFor: 'accessing' stamp: 'cmm 5/21/2003 23:27'!
serieNamed: aString

	^series at: aString ifAbsentPut: [ PlotSerie name: aString ]! !

!MaPlotSpecification methodsFor: 'accessing' stamp: 'cmm 5/21/2003 23:50'!
seriesDo: aBlock

	series do: aBlock! !

!MaPlotSpecification methodsFor: 'accessing' stamp: 'cmm 5/21/2003 22:48'!
style

	^style! !

!MaPlotSpecification methodsFor: 'accessing' stamp: 'cmm 5/21/2003 22:48'!
style: aString

	style _ aString! !

!MaPlotSpecification methodsFor: 'accessing' stamp: 'cmm 5/21/2003 22:45'!
title

	^title! !

!MaPlotSpecification methodsFor: 'private' stamp: 'cmm 5/21/2003 22:46'!
title: aString

	title _ aString! !

MaObject subclass: #MailingAddress
	instanceVariableNames: 'street zip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Test domains'!

!MailingAddress class methodsFor: '*maui' stamp: 'cmm 1/27/2004 16:10'!
mauiBasicApi

	^#(street:zip:)! !

!MailingAddress class methodsFor: 'instance creation' stamp: 'cmm 1/27/2004 16:09'!
street: streetString zip: zipString

	^self new
		street: streetString;	
		zip: zipString;
		yourself! !

!MailingAddress methodsFor: '*maui' stamp: 'cmm 1/27/2004 16:07'!
mauiBasicApi

	^#(street zip)! !

!MailingAddress methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:05'!
street

	^street! !

!MailingAddress methodsFor: 'building' stamp: 'cmm 1/27/2004 16:05'!
street: aString

	street _ aString
! !

!MailingAddress methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:05'!
zip

	^zip! !

!MailingAddress methodsFor: 'building' stamp: 'cmm 1/27/2004 16:05'!
zip: aString

	zip _ aString
! !

MaObject subclass: #MauiColorScheme
	instanceVariableNames: 'colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MauiColorScheme class methodsFor: 'as yet unclassified' stamp: 'cmm 1/1/2005 17:44'!
orangeSlate

	^ self new
		color1: (Color h: 50.0 s: 0.62 v: 1.0);  "tan"
		color2: (Color h: 25.0 s: 0.73 v: 0.8);  "orange"
		borderColor: #complexRaised ;
		highlightColor: Color green ;
		messageBackgroundColor: Color darkGray;
		dialogColor: (Color r: 0.028 g: 0.384 b: 0.472) "grayish-blue" ;
		yourself! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/30/2004 12:47'!
borderColor

	^ self colorFor: #borderColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/30/2004 12:47'!
borderColor: aColor

	colors
		at: #borderColor
		put: aColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:38'!
color1

	^ self colorFor: #color1! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:40'!
color1: aColor

	colors
		at: #color1
		put: aColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:38'!
color2

	^ self colorFor: #color2! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:40'!
color2: aColor

	colors
		at: #color2
		put: aColor! !

!MauiColorScheme methodsFor: 'private' stamp: 'cmm 8/5/2004 14:38'!
colorFor: selectorSymbol

	^ colors
		at: selectorSymbol
		ifAbsent: [ self randomColor ]! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:39'!
dialogColor

	^ self colorFor: #dialogColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:40'!
dialogColor: aColor

	colors
		at: #dialogColor
		put: aColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:39'!
highlightColor

	^ self colorFor: #highlightColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:40'!
highlightColor: aColor

	colors
		at: #highlightColor
		put: aColor! !

!MauiColorScheme methodsFor: 'initialize' stamp: 'cmm 8/5/2004 14:58'!
initialize

	super initialize.
	colors _ Dictionary new! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:39'!
messageBackgroundColor

	^ self colorFor: #messageBackgroundColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:40'!
messageBackgroundColor: aColor

	colors
		at: #messageBackgroundColor
		put: aColor! !

!MauiColorScheme methodsFor: 'private' stamp: 'cmm 8/5/2004 14:38'!
randomColor

	| r |
	r _ Random seed: Time millisecondClockValue.
	^ Color
		r: r next
		g: r next
		b: r next! !

MaObject subclass: #MauiDoc
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MauiDoc class methodsFor: 'as yet unclassified' stamp: 'cmm 2/11/2004 00:28'!
streamContents: aBlock

	| answer |
	answer _ self new.
	aBlock value: answer.
	^answer! !

!MauiDoc methodsFor: 'build' stamp: 'cmm 1/26/2004 21:52'!
add: anObject

	elements add: anObject.
	self changed! !

!MauiDoc methodsFor: 'build' stamp: 'cmm 1/26/2004 21:28'!
elements: anOrderedCollection

	elements _ anOrderedCollection.
	self changed! !

!MauiDoc methodsFor: 'read' stamp: 'cmm 1/26/2004 21:28'!
elementsDo: aBlock

	elements do: aBlock! !

!MauiDoc methodsFor: 'initialize' stamp: 'cmm 1/26/2004 21:29'!
initialize

	super initialize.
	self elements: OrderedCollection new! !

!MauiDoc methodsFor: 'build' stamp: 'cmm 1/26/2004 21:55'!
remove: anObject

	elements remove: anObject.
	self changed! !

MaObject subclass: #MauiEffect
	instanceVariableNames: 'target selector range duration finally startTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiEffect commentStamp: 'cmm 12/30/2004 11:10' prior: 0!
I am used by MauiMorphs to slide a particular visual-property, denoted by my 'selector' from one value to another over a period of time.  I calculate the proper value based on linear position of the duration that we are in.  MauiMorphs invoke me in their step method and I do the work.!

!MauiEffect class methodsFor: 'create' stamp: 'cmm 12/30/2004 14:22'!
target: aMauiMorph selector: selectorSymbol range: anInterval duration: aMaDuration finally: aBlock
	^ self new
		target: aMauiMorph ;
		selector: selectorSymbol ;
		range: anInterval ;
		duration: aMaDuration ;
		finally: aBlock ;
		yourself! !

!MauiEffect methodsFor: 'api' stamp: 'cmm 12/30/2004 14:47'!
begin

	duration = 0
		ifTrue: [ self jumpToEnd ]
		ifFalse: [ target beginMauiEffect: self ]! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 14:37'!
duration: millisecondsInteger
	duration _ millisecondsInteger! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 12/30/2004 14:36'!
ensureStarted
	startTime ifNil: [ startTime _ Time millisecondClockValue ]! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 14:22'!
finally: aBlock
	finally _ aBlock! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 1/9/2005 18:32'!
jumpToEnd

	finally value.
	target
		perform: selector
		with: range last! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 13:01'!
range: anInterval
	range _ anInterval! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 12/30/2004 14:36'!
runningTime

	^ Time millisecondClockValue - startTime! !

!MauiEffect methodsFor: 'accessing' stamp: 'cmm 12/30/2004 13:02'!
selector
	^ selector! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 13:01'!
selector: aSymbol
	selector _ aSymbol! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 1/9/2005 18:31'!
step

	| runningTime |
	self ensureStarted.
	runningTime _ self runningTime.
	runningTime < duration
		ifTrue:
			[ | currentValue |
			currentValue _ ((range last - range first) * (runningTime / duration) + range first) asFloat.
			target
				perform: selector
				with: currentValue ]
		ifFalse:
			[ "ensure we end up at the final value."
			self
				jumpToEnd ;
				terminate ]! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 13:00'!
target: aMauiMorph
	target _ aMauiMorph! !

!MauiEffect methodsFor: 'api' stamp: 'cmm 12/30/2004 14:48'!
terminate
	"Sometimes, an effect is in the middle of its animation when something occurs that should make it go the other way (i.e., entering and then leaving a MauiMorph causes a delineate followed by undelineate, but the delineate animation may not yet be completed)."

	target endMauiEffect: self! !

MaObject subclass: #MauiFamily
	instanceVariableNames: 'name views preferences'
	classVariableNames: 'AllFamilies'
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MauiFamily commentStamp: 'cmm 12/2/2003 20:54' prior: 0!
I know the visual-representation of a set of classes whose instances are displayed as MauiMorphs.  My main responsibilities are:

	- keep track of the views, class 

	!

!MauiFamily class methodsFor: 'reserved views' stamp: 'cmm 12/1/2003 00:20'!
default

	^self named: '(default)'! !

!MauiFamily class methodsFor: 'initializing' stamp: 'cmm 12/1/2003 00:04'!
initialize

	super initialize.
	AllFamilies _ Dictionary new "key:  family-name, value:  aMauiFamily"! !

!MauiFamily class methodsFor: 'accessing' stamp: 'cmm 12/1/2003 00:22'!
named: aString

	^AllFamilies 
		at: aString
		ifAbsentPut: [ self newNamed: aString ]! !

!MauiFamily class methodsFor: 'create' stamp: 'cmm 9/12/2004 20:58'!
newNamed: aString

	^self new
		name: aString;
		yourself! !

!MauiFamily class methodsFor: 'reserved views' stamp: 'cmm 7/22/2004 16:38'!
resetDefault

	AllFamilies
		removeKey: self default name
		ifAbsent: [ "ok" ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 1/4/2005 20:27'!
buildViewNamed: aSymbol for: anObject

	| answer |
	answer _ anObject asMauiMorph.
	(answer isMauiDomainMorph and: [ aSymbol ~= #beDefault ])
		ifTrue: [ answer perform: aSymbol ].
	answer overridePreferencesFrom: self.
	^answer! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 1/17/2004 17:57'!
customViewsFor: aMauiDomainMorph do: oneArgBlock

	self
		viewsFrom: (self prototypeClassKeyFor: aMauiDomainMorph object)
		do:
			[ : each | (aMauiDomainMorph object mauiReservedViews includes: each) ifFalse: [ oneArgBlock value: each ] ]! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/11/2004 10:28'!
ensurePreferences

	^ preferences ifNil: [ preferences _ self preferences newOverrideFor: self ]! !

!MauiFamily methodsFor: 'testing' stamp: 'cmm 12/18/2003 22:19'!
hasViewsAt: aClass named: aString

	^(views
		at: aClass
		ifAbsent: [ ^false ]) includesKey: aString! !

!MauiFamily methodsFor: 'initialize' stamp: 'cmm 12/18/2003 23:37'!
initialize

	super initialize.
	"views:
		keys:  class
		values:  another dictionary, viewName->OC of the versions of those views"
	views _ Dictionary new.
	self initializeReservedViews! !

!MauiFamily methodsFor: 'initialize' stamp: 'cmm 12/29/2003 21:22'!
initializeReservedViews

	ProtoObject withAllSubclassesDo:
		[ : eachClass |
		(eachClass isMeta not
		and: [ eachClass methodDict includesKey: #mauiReservedViews "hmm..." ])
			ifTrue:
				[ eachClass mauiReservedViews do:
					[ : eachView |
					self 
						viewsAt: eachClass
						named: eachView ] ] ]! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 12/1/2003 00:05'!
name

	^name! !

!MauiFamily methodsFor: 'initialize' stamp: 'cmm 12/1/2003 00:20'!
name: aString

	name _ aString! !

!MauiFamily methodsFor: 'create' stamp: 'cmm 8/11/2004 21:43'!
newViewNamed: aString for: anObject

	^aString isSymbol
		ifTrue: 
			[ self 
				buildViewNamed: aString 
				for: anObject ]
		ifFalse: 
			[ (self viewNamed: aString for: anObject) copy
				object: anObject ;
				overridePreferencesFrom: self ;
				yourself ]! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/11/2004 21:58'!
nextPreferenceSource

	^ MauiPreferences global! !

!MauiFamily methodsFor: 'testing' stamp: 'cmm 2/20/2004 18:28'!
player: aMauiMorph overridesView: viewName from: aClass

	| playerClass |
	playerClass _ self prototypeClassKeyFor: aMauiMorph object.
	playerClass withAllSuperclassesDo:
		[ : eachClass |
		eachClass = aClass ifTrue: [ ^ false ].
		(self
			hasViewsAt: eachClass
			named: viewName) ifTrue: [ ^ true ] ].
	^ false! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/8/2004 20:40'!
preferences

	^ preferences ifNil: [ MauiPreferences global ]! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/11/2004 22:57'!
preferencesName

	^ 'family ', self name! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/5/2004 21:52'!
preferred: preferenceSymbol is: anObject

	self ensurePreferences
		preferred: preferenceSymbol
		is: anObject! !

!MauiFamily methodsFor: 'printing' stamp: 'cmm 12/16/2003 00:48'!
printOn: aStream

	super printOn: aStream.
	aStream
		space;
		nextPutAll: name! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 9/12/2004 20:43'!
prototypeClassKeyFor: anObject

	^ anObject class
"
	^anObject isBehavior ifTrue: [ Metaclass ] ifFalse: [ anObject class ]"! !

!MauiFamily methodsFor: 'remember views' stamp: 'cmm 8/14/2004 21:07'!
remember: aMauiMorph as: viewName atLevel: aClass

	| v |
	aMauiMorph captureSketch.
	(v _ self
		viewsAt: aClass
		named: viewName)

			addFirst: (aMauiMorph copyForNewObject: aMauiMorph object asMauiPrototype).
	"Keep bloat managed by keeping only the last 25 versions of each particular view."
	[ v size > 25 ] whileTrue: [ v removeLast ]! !

!MauiFamily methodsFor: 'remember views' stamp: 'cmm 2/15/2004 20:50'!
remember: aMauiDomainMorph atLevel: aClass

	self
		remember: aMauiDomainMorph
		as: aMauiDomainMorph view
		atLevel: aClass! !

!MauiFamily methodsFor: 'remove' stamp: 'cmm 2/19/2004 23:18'!
removeAllOf: viewName at: aClass

	(self viewsAt: aClass) removeKey: viewName! !

!MauiFamily methodsFor: 'remember views' stamp: 'cmm 7/29/2004 16:09'!
renameTo: aString

	AllFamilies
		at: aString
		put: (AllFamilies removeKey: self name).
	self name: aString! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/6/2004 11:10'!
resetPreferences

	preferences _ nil! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 7/29/2004 17:59'!
sortedViewsFor: aMauiDomainMorph do: oneArgBlock

	| allViews |
	allViews _ OrderedCollection new.
	self
		viewsFrom: (self prototypeClassKeyFor: aMauiDomainMorph object)
		do: [ : each | (allViews includes: each) ifFalse: [ allViews add: each ] ].
	^allViews asSortedCollection do: oneArgBlock! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 7/29/2004 16:15'!
viewNamed: aString for: anObject
	"Answers the actual view stored in me at aString for anObject."

	| v |
	v _ 
		self
			viewsNamed: aString
			for: (self prototypeClassKeyFor: anObject).
	^v isEmptyOrNil
		ifTrue: [ anObject asMauiMorph ]
		ifFalse: [ v first ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 12/18/2003 22:48'!
viewsAt: aClass

	^views 
		at: aClass
		ifAbsentPut: [ Dictionary new ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 12/18/2003 22:12'!
viewsAt: aClass named: aString

	^(self viewsAt: aClass)
		at: aString
		ifAbsentPut: [ OrderedCollection new ]! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 7/16/2004 11:06'!
viewsFrom: aClass do: oneArgBlock

	(MauiWorld current userStrategy likesViewsFor: aClass) ifFalse: [ ^ self ].
	(self viewsAt: aClass) keysDo: oneArgBlock.
	self
		viewsFrom: aClass superclass
		do: oneArgBlock! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 12/18/2003 22:19'!
viewsNamed: aString for: aClass

	aClass = nil ifTrue: [ ^nil ].
	^(self hasViewsAt: aClass named: aString)
		ifTrue: [ self viewsAt: aClass named: aString ]
		ifFalse: [ self viewsNamed: aString for: aClass superclass ]! !

MaObject subclass: #MauiInvocationStrategy
	instanceVariableNames: 'resultView resultHolderTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

MauiInvocationStrategy subclass: #MauiClickedInvocationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiClickedInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 7/10/2003 00:34'!
handlesMouseDown
	^true! !

!MauiClickedInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 8/16/2004 16:21'!
note: aMauiMessageMorph hoveringOver: aMauiMorph event: event
	"Indicate we didn't care about this notification."

	^ false! !

MauiInvocationStrategy subclass: #MauiImmediateInvocationStrategy
	instanceVariableNames: 'needsInvoked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiImmediateInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 2/18/2004 12:01'!
initialize

	super initialize.
	needsInvoked _ true! !

!MauiImmediateInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 7/21/2004 00:15'!
noteInvocationComplete: aMauiMessageMorph

	super noteInvocationComplete: aMauiMessageMorph.
	needsInvoked _ false! !

!MauiImmediateInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2004 18:18'!
noteInvocationNeededFor: aMauiMessageMorph

	needsInvoked _ true! !

!MauiImmediateInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 9/12/2004 14:33'!
noteNewOwner: aMauiDomainMorph for: aMauiMessageMorph

	aMauiMessageMorph startStepping.
	needsInvoked _ true! !

!MauiImmediateInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 7/9/2003 23:37'!
parameterDropped: aMauiMessageMorph

	aMauiMessageMorph invokeIfPossible! !

!MauiImmediateInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 1/7/2005 17:47'!
postInvokeCleanup: aMauiMessageMorph
self maMarked: 'delete'.
	aMauiMessageMorph resetParameterHolderMorphs! !

!MauiImmediateInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 12/30/2004 13:52'!
refreshData: aMauiMessageMorph

	needsInvoked
		ifTrue: 
			[ aMauiMessageMorph invokeIfPossible.
			needsInvoked _ false ]! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 1/3/2005 12:17'!
balloonResultTargetIdentifier

	^'balloon'! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/12/2004 23:35'!
handResultTargetIdentifier

	^'hand'! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 7/10/2003 00:34'!
handlesMouseDown
	^false! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 7/10/2003 00:01'!
handlesMouseOver
	^false! !

!MauiInvocationStrategy methodsFor: 'initializing' stamp: 'cmm 2/8/2004 23:02'!
initialize

	super initialize.
	self 
		resultView: #beDefault ;
		resultHolderTarget: self localResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'menu' stamp: 'cmm 11/19/2003 21:45'!
invokedFromUserMenu: aMauiMessageMorph

	aMauiMessageMorph canInvoke
		ifTrue: [ aMauiMessageMorph invokeIfPossible ]
		ifFalse: [ aMauiMessageMorph openInHand ]! !

!MauiInvocationStrategy methodsFor: 'converting' stamp: 'cmm 11/6/2003 23:24'!
isSuitableForGetter

	^false! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/7/2004 11:16'!
localResultTargetIdentifier

	^'self'! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 1/3/2005 22:38'!
mouseEntered: aMouseEvent for: aMauiMessageMorph
	"mouse-over strategy invokes now."! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 1/4/2005 09:33'!
mouseLeft: aMouseEvent for: aMauiMessageMorph
	"mouse-over strategy gets rid of resultMorph."! !

!MauiInvocationStrategy methodsFor: 'converting' stamp: 'cmm 2/5/2004 23:31'!
newBehavingAs: mauiInvocationStrategyClass

	^mauiInvocationStrategyClass new
		copySameFrom: self;
		yourself! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 12/3/2004 12:33'!
noResultTargetIdentifier

	^'none'! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 8/16/2004 16:23'!
note: aMauiMessageMorph hoveringOver: aMauiMorph event: event
	"All but clicked strategy invoke aMauiMessageMorph for aMauiMorph."

	^ (event shiftPressed and: [ aMauiMessageMorph message selector isUnary ])
		ifTrue:
			[ aMauiMessageMorph
				receiver: aMauiMorph object;
				invokeIfPossible.
			true ]
		ifFalse: [ false ]! !

!MauiInvocationStrategy methodsFor: 'messages' stamp: 'cmm 7/21/2004 00:14'!
noteInvocationComplete: aMauiMessageMorph

	aMauiMessageMorph hasResult ifTrue: [ aMauiMessageMorph resultMorph startStepping ]! !

!MauiInvocationStrategy methodsFor: 'messages' stamp: 'cmm 7/19/2004 18:17'!
noteInvocationNeededFor: aMauiMessageMorph! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 11/30/2003 16:31'!
noteNewOwner: aMauiDomainMorph for: aMauiMessageMorph
	"immediate strategy should invoke now."! !

!MauiInvocationStrategy methodsFor: 'messages' stamp: 'cmm 7/9/2003 23:36'!
parameterDropped: aMauiMessageMorph
	"This is when the immediate should invokeIfPossible."! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 1/3/2005 12:18'!
possibleTargets

	^{ self localResultTargetIdentifier.  self handResultTargetIdentifier.  self worldResultTargetIdentifier. self balloonResultTargetIdentifier. self noResultTargetIdentifier  }! !

!MauiInvocationStrategy methodsFor: 'initializing' stamp: 'cmm 7/14/2003 00:57'!
postInitialize: aMauiMorph
	"Used by the repeating to startStepping."! !

!MauiInvocationStrategy methodsFor: 'messages' stamp: 'cmm 1/7/2005 17:47'!
postInvokeCleanup: aMauiMessageMorph
	"This runs right after the invoke.  The immediate will want to cleanup the parameterHolderMorphs."
	
self maMarked: 'delete'! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 12/30/2004 13:52'!
refreshData: aMauiMessageMorph
	"the repeating strategy should invokeIfPossible."! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/7/2004 01:02'!
resultHolderTarget

	^resultHolderTarget! !

!MauiInvocationStrategy methodsFor: 'api' stamp: 'cmm 1/4/2005 21:37'!
resultHolderTarget: aString
	"aString can be:
		'self'  (the messageMorph itself)
		'world'
		'hand'
		'balloon'
		'none'"

	resultHolderTarget _ aString! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 1/6/2005 12:29'!
resultTargetFor: aMauiMessageMorph

	self wantsLocalResultTarget ifTrue: [ ^ aMauiMessageMorph ].
	self wantsHandResultTarget ifTrue: [ ^ ActiveHand ].
	self wantsWorldResultTarget ifTrue: [ ^ World ].
	self wantsBalloonResultTarget ifTrue:
		[ ^ MauiBalloonMorph
			contentsMorph: aMauiMessageMorph resultMorph 
			for: aMauiMessageMorph ].
	^ nil! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/6/2004 00:07'!
resultView

	^resultView! !

!MauiInvocationStrategy methodsFor: 'api' stamp: 'cmm 7/15/2004 10:28'!
resultView: aString
	"Set the default view that should be assumed by the object resulting from my invocation."

	resultView _ aString! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 1/3/2005 12:17'!
wantsBalloonResultTarget

	^resultHolderTarget = self balloonResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/12/2004 23:37'!
wantsHandResultTarget

	^resultHolderTarget = self handResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/7/2004 11:14'!
wantsLocalResultTarget

	^resultHolderTarget = self localResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 7/9/2004 10:44'!
wantsWorldResultTarget

	^resultHolderTarget = self worldResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 7/9/2004 10:44'!
worldResultTargetIdentifier

	^'world'! !

MauiInvocationStrategy subclass: #MauiMouseOverInvocationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 7/10/2003 00:34'!
handlesMouseOver

	^true! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2003 19:58'!
invokedFromUserMenu: aMauiMessageMorph

	aMauiMessageMorph openInHand! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 1/3/2005 22:38'!
mouseEntered: aMouseEvent for: aMauiMessageMorph

	aMauiMessageMorph canInvoke
		ifTrue:
			[ aMauiMessageMorph invokeIfPossible.
			aMouseEvent wasHandled: true ]! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 1/6/2005 22:24'!
mouseLeft: aMouseEvent for: aMauiMessageMorph

	aMauiMessageMorph isResultLocal ifTrue: [ aMauiMessageMorph resultMorph delete ].
	self wantsBalloonResultTarget
		ifTrue: [ aMouseEvent hand removeAlarm: #spawnMauiBalloon:for: ]! !

MauiInvocationStrategy subclass: #MauiRepeatingInvocationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiRepeatingInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2003 19:59'!
invokedFromUserMenu: aMauiMessageMorph

	aMauiMessageMorph openInHand! !

!MauiRepeatingInvocationStrategy methodsFor: 'testing' stamp: 'cmm 2/7/2004 01:05'!
isSuitableForGetter

	^self wantsLocalResultTarget ! !

!MauiRepeatingInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 1/27/2005 13:02'!
noteInvocationComplete: aMauiMessageMorph

	"Delete the parameter only under these special circumstances."
self maMarked: 'dev'.
"Hmmm, maybe we should delete it simply when we are about to add a new morph to the resultHolderMorph and the resultHolderMorph contains the resultMorph (now priorResultMorph) and its local..."
	(aMauiMessageMorph owner notNil
	and: [ aMauiMessageMorph isGetter
	and: [ aMauiMessageMorph owner isMauiMessageMorph
	and: [ aMauiMessageMorph owner isGetterSetter ] ] ])
		ifTrue:
			[ aMauiMessageMorph resultHolderMorph deleteParameterMorph ]! !

!MauiRepeatingInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 7/21/2004 23:49'!
noteInvocationNeededFor: aMauiMessageMorph

	aMauiMessageMorph world ifNotNil: [ aMauiMessageMorph startStepping ]! !

!MauiRepeatingInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 7/19/2004 17:55'!
noteNewOwner: aMauiDomainMorph for: aMauiMessageMorph

	aMauiDomainMorph
		ifNil: [ aMauiMessageMorph stopStepping ]
		ifNotNil: [ aMauiMessageMorph startStepping ]! !

!MauiRepeatingInvocationStrategy methodsFor: 'initializing' stamp: 'cmm 12/6/2004 14:57'!
postInitialize: aMauiMorph

	aMauiMorph world ifNotNil: [ aMauiMorph startStepping ]! !

!MauiRepeatingInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 12/30/2004 13:52'!
refreshData: aMauiMessageMorph

	aMauiMessageMorph invokeIfPossible! !

MaObject subclass: #MauiMessage
	instanceVariableNames: 'receiver reference arguments debugMode'
	classVariableNames: 'CachedReferences'
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiMessage commentStamp: 'cmm 8/19/2003 22:42' prior: 0!
I represent a Message object that has access to a little more information to faciliate ease-of-use functions in Maui.  For example, since I know my MethodReference, I facilitate the balloons that appear for MauiParameterHolderMorph's.!

!MauiMessage class methodsFor: 'initialize-release' stamp: 'cmm 12/24/2003 13:21'!
initialize

	super initialize.
	CachedReferences _ WeakIdentityKeyDictionary new "aCompiledMethod->aMethodReference for it"! !

!MauiMessage class methodsFor: 'private' stamp: 'cmm 2/12/2004 22:58'!
methodReferenceFor: anObject selector: selectorSymbol

	| compiledMethod |
	compiledMethod _ anObject class lookupSelector: selectorSymbol.
	compiledMethod ifNil: [ MauiUserError signal: anObject class printString, ' cannot understand ', selectorSymbol ].
	^(CachedReferences
		at: compiledMethod
		ifAbsentPut:
			[ (MethodReference new
				setStandardClass: compiledMethod maMethodClass 
				methodSymbol: compiledMethod selector;
				yourself) ])! !

!MauiMessage class methodsFor: 'create' stamp: 'cmm 12/24/2003 12:43'!
receiver: anObject selector: selectorSymbol

	^self
		receiver: anObject
		selector: selectorSymbol
		arguments: #()! !

!MauiMessage class methodsFor: 'create' stamp: 'cmm 2/12/2004 22:59'!
receiver: anObject selector: selectorSymbol arguments: anArray

	| compiledMethod |
	compiledMethod _ anObject class lookupSelector: selectorSymbol.
	compiledMethod ifNil: [ MauiUserError signal: anObject class printString, ' cannot understand ', selectorSymbol ].
	^self new
		receiver: anObject;
		reference:
			(self
				methodReferenceFor: anObject
				selector: selectorSymbol) ;			
		postInitialize;
		arguments: anArray! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 12/3/2004 11:02'!
argumentNameAt: argIndex
	^ reference maSourceCode
		ifNotNilDo:
			[ : source |
			source asString readStream nextLine substrings 
		
		at: 2*argIndex
		
		ifAbsent: [ nil ] ]! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 7/22/2004 17:27'!
arguments

	^ arguments! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 12/24/2003 13:37'!
arguments: anArray

	arguments _ anArray! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 8/21/2003 23:15'!
asMessage

	^Message
		selector: self selector
		arguments: arguments! !

!MauiMessage methodsFor: 'copying' stamp: 'cmm 11/20/2003 00:37'!
commonCopy

	^self copyWithAttributes: #('arguments')! !

!MauiMessage methodsFor: 'copying' stamp: 'cmm 2/12/2004 23:25'!
copyForNewReceiver: anObject

	^self
		copyForNewReceiver: anObject
		selector: self selector! !

!MauiMessage methodsFor: 'copying' stamp: 'cmm 2/12/2004 23:25'!
copyForNewReceiver: anObject selector: selectorSymbol

	^self commonCopy
		receiver: anObject;
		reference:
			(self class 
				methodReferenceFor: anObject
				selector: selectorSymbol)
		yourself! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 10/22/2003 21:47'!
debugMode

	^debugMode! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 10/22/2003 21:47'!
debugMode: aBoolean

	debugMode _ aBoolean! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 10/9/2003 21:18'!
hasCorrespondingGetter

	| getterName |
	receiver ifNil: [ MauiUserError signal: 'I have no receiver.' ].
	getterName _ self selector copyWithout: $:.
	^Symbol
		hasInterned: getterName
		ifTrue: [ : selector | ^receiver respondsTo: selector ]! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 12/19/2004 12:22'!
hasCorrespondingSetter

	| setterName |
	setterName _ self selector copyWith: $:.
	^Symbol
		hasInterned: setterName
		ifTrue: [ : selector | ^receiver respondsTo: selector ]! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 10/22/2003 00:16'!
implementorClass
	"If my selector is inherited from one of my superclasses, answer it instead of my receiver class."

	receiver class withAllSuperclassesDo:
		[ : each |
		(each methodDict includesKey: self selector) ifTrue: [ ^ each ] ].
	^nil! !

!MauiMessage methodsFor: 'copying' stamp: 'cmm 11/20/2003 00:38'!
independentCopy

	^self commonCopy! !

!MauiMessage methodsFor: 'private' stamp: 'cmm 10/22/2003 21:49'!
initialize

	super initialize.
	self debugMode: false! !

!MauiMessage methodsFor: 'actions' stamp: 'cmm 1/2/2004 14:50'!
invokeUsing: aMaNotificationHandler

	debugMode ifTrue: [ self halt: 'debugging on' ].
	^aMaNotificationHandler
		send: self asMessage
		to: receiver! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 2/13/2004 00:37'!
isValid

	^self implementorClass notNil! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 11/22/2003 18:11'!
mauiName

	^'>> ', self selector! !

!MauiMessage methodsFor: 'private' stamp: 'cmm 8/21/2003 23:13'!
postInitialize

	self arguments: (Array new: (self selector occurrencesOf: $:))! !

!MauiMessage methodsFor: 'printing' stamp: 'cmm 8/21/2003 23:45'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: ' with selector: ';
		print: self selector;
		nextPutAll: ' and arguments: ';
		print: arguments! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 8/24/2003 14:46'!
receiver

	^receiver! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 1/18/2004 14:56'!
receiver: anObject

	receiver _ anObject! !

!MauiMessage methodsFor: 'private' stamp: 'cmm 8/19/2003 22:56'!
reference: aMethodReference

	reference _ aMethodReference! !

!MauiMessage methodsFor: 'comparing' stamp: 'cmm 11/22/2003 17:50'!
sameEffectAs: aMauiMessage

	aMauiMessage == self ifTrue: [ ^true ].
	aMauiMessage receiver ~~ self receiver ifTrue: [ ^false ].
	aMauiMessage selector ~~ self selector ifTrue: [ ^false ].
	aMauiMessage arguments ~= self arguments ifTrue: [ ^false ].
	^true! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 8/19/2003 23:17'!
selector

	^reference methodSymbol! !

!MauiMessage methodsFor: 'copying' stamp: 'cmm 7/22/2004 16:25'!
veryDeepFixupWith: aDeepCopier
	"The only way we ever want make a copy of my sources' original receiver is if it was part of the Morph tree being copied originally; meaning it was a UI message.  In that case, we want to make sure we point MY receiver to it."

	(aDeepCopier references includesKey: receiver)
		ifTrue: [ receiver _ aDeepCopier references at: receiver ]! !

!MauiMessage methodsFor: 'copying' stamp: 'cmm 1/18/2004 14:05'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	arguments _ arguments maShallowCopy! !

MaObject subclass: #MauiOptionalParametersStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiOptionalParametersStrategy commentStamp: 'cmm 7/21/2003 21:43' prior: 0!
I implement hook methods called by Maui at various points so that your overriding classes can give you the visual behavior you desire.!

MauiOptionalParametersStrategy subclass: #MauiClickAndPickParameterStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiClickAndPickParameterStrategy commentStamp: 'cmm 12/22/2003 23:41' prior: 0!
Behaves like your old MEGA-Check "selector" dialogs.  :-)!

!MauiClickAndPickParameterStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 8/8/2004 21:26'!
parameterDropped: aMorphOrMauiMorph into: aMauiParameterHolderMorph

	aMauiParameterHolderMorph ensureNoOptionalParametersMorph! !

!MauiClickAndPickParameterStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 12/19/2004 11:17'!
selectUsing: aMauiParameterHolderMorph

	| comboBox |
	comboBox _ 	aMauiParameterHolderMorph optionalParametersMorph.
	comboBox
		position: (aMauiParameterHolderMorph localPointToGlobal: aMauiParameterHolderMorph position) + (0@aMauiParameterHolderMorph height) ;
		mauiEnsureOnScreen.
	comboBox openInWorld! !

MauiOptionalParametersStrategy subclass: #MauiCycleParametersStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiCycleParametersStrategy commentStamp: 'cmm 12/22/2003 23:42' prior: 0!
A checkbox would cycle true and false, however, other values are possible.!

!MauiCycleParametersStrategy methodsFor: 'private' stamp: 'cmm 12/25/2003 21:54'!
optionalParameterAfter: anotherOptionalValue using: aMauiParameterHolder

	aMauiParameterHolder optionalParameters isEmpty ifTrue: [ ^nil ].
	(aMauiParameterHolder optionalParameters notEmpty
		and: [ aMauiParameterHolder optionalParameters last = anotherOptionalValue ])
		ifTrue:
			[ ^aMauiParameterHolder optionalParameters first ].
	^aMauiParameterHolder optionalParameters
		after: anotherOptionalValue
		ifAbsent:
			[ aMauiParameterHolder optionalParameters isEmptyOrNil
				ifTrue: [ nil ]
				ifFalse: [ aMauiParameterHolder optionalParameters first ] ]! !

!MauiCycleParametersStrategy methodsFor: 'overriding' stamp: 'cmm 12/25/2003 21:55'!
selectUsing: aMauiParameterHolderMorph
self maMarked: 'hack'.
"I don't like the way I'm getting the current optional parameter with 'aMauiParameterHolderMorph submorphs first object', below..."
	aMauiParameterHolderMorph dropParameter:
		(aMauiParameterHolderMorph optionalParameterMorphFor:
			(self
				optionalParameterAfter: aMauiParameterHolderMorph submorphs first object
				using: aMauiParameterHolderMorph))! !

MauiOptionalParametersStrategy subclass: #MauiListSelectionStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Messages'!

!MauiListSelectionStrategy commentStamp: 'cmm 12/22/2003 23:43' prior: 0!
This one behaves like a listbox with a single, selectable item in it.!

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 1/7/2005 00:01'!
addOptions: aMauiParameterHolderMorph

	aMauiParameterHolderMorph addMorphBack: aMauiParameterHolderMorph optionalParametersMorph! !

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 1/7/2005 00:04'!
initializeUsing: aMauiParameterHolderMorph

	aMauiParameterHolderMorph layoutInset: 0@0.
	self addOptions: aMauiParameterHolderMorph! !

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 12/25/2003 12:16'!
noteNewOwner: aMauiMessageMorph for: aMauiParameterHolderMorph

	self addOptions: aMauiParameterHolderMorph! !

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 12/22/2003 23:51'!
selectUsing: aMauiParameterHolder

	"nothing to do for this guy, since he always has his selections presented."! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 12/25/2003 12:17'!
initializeUsing: aMauiParameterHolderMorph
	"called when aMauiParameterHolderMorph's optional-parameters strategy has been set or changed."! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 12/24/2003 14:51'!
noteNewOwner: aMauiMessageMorph for: aMauiParameterHolderMorph
	"optional subclass responsibility"! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 12/25/2003 19:59'!
parameterDropped: aMorphOrMauiMorph into: aMauiParameterHolderMorph
	"optional subclass responsibility"! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 7/31/2003 23:47'!
selectUsing: aMauiParameterHolder

	self subclassResponsibility! !

MaObject subclass: #MauiPreferences
	instanceVariableNames: 'values target'
	classVariableNames: 'GlobalPreferences'
	poolDictionaries: ''
	category: 'Maui-Morphs'!

!MauiPreferences class methodsFor: 'accessing' stamp: 'cmm 7/1/2003 00:34'!
global

	^GlobalPreferences! !

!MauiPreferences class methodsFor: 'initialize' stamp: 'cmm 8/8/2004 20:53'!
initialize

	GlobalPreferences _ self new.  "it's gotta be set before we can initializeGlobalValues."
	"Now update all old children to new global."
	MauiFamily allInstances do: [ : each | each resetPreferences ].
	MauiMorph allInstances do: [ : each | each resetPreferences ].
	GlobalPreferences initializeGlobalValues
! !

!MauiPreferences class methodsFor: 'create' stamp: 'cmm 8/11/2004 21:56'!
target: anObject
	"anObject should be aMauiMorph, aMauiFamily (or nil if initializing the global)."

	^ self new
		target: anObject ;
		yourself! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/11/2004 12:26'!
buildChain: anOrderedCollection for: preferenceSymbol

	(self specifies: preferenceSymbol)
		ifTrue: [ anOrderedCollection add: (target ifNil: [ self ] ifNotNil: [ target ]) ].
	self nextPreferences
		buildChain: anOrderedCollection
		for: preferenceSymbol! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 1/1/2004 16:26'!
collectionSampleSize

	^50! !

!MauiPreferences methodsFor: 'colors' stamp: 'cmm 8/8/2004 20:28'!
colorScheme

	^ values
		at: #colorScheme 
		ifAbsent: [ self nextPreferences colorScheme ]! !

!MauiPreferences methodsFor: 'colors' stamp: 'cmm 12/3/2004 10:26'!
colorScheme: aMauiColorScheme
	"The MauiColorScheme used to specify the default colors of MauiMorphs."
	self
		preferred: #colorScheme
		is: aMauiColorScheme! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/11/2004 21:29'!
connectObjects

	MauiWorld hasConnectors ifFalse: [ ^ false].
	^ values 
		at: #connectObjects
		ifAbsent: [ self nextPreferences connectObjects ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/12/2004 00:40'!
connectObjects: aBoolean
	"If true and Connectors is present, multiple views of the same object will be connected with a line."

	self
		preferred: #connectObjects
		is: aBoolean! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/8/2004 20:33'!
connector

	^ values
		at: #connector
		ifAbsent: [ self nextPreferences connector ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/3/2004 10:25'!
connector: aNCConnectorMorph
	"An actual NCConnector prototype cloned to generate the connecting lines."
	self 
		preferred: #connector 
		is: aNCConnectorMorph! !

!MauiPreferences methodsFor: 'labelling' stamp: 'cmm 8/11/2004 15:08'!
defaultLabelSelector
	"This is used to show, by default, *different* default label values other than the mauiName."

	^ values
		at: #defaultLabelSelector
		ifAbsent: [ self nextPreferences defaultLabelSelector ]! !

!MauiPreferences methodsFor: 'labelling' stamp: 'cmm 8/12/2004 00:36'!
defaultLabelSelector: selectorSymbol
	"This is used to show, by default, *different* default label values other than the mauiName."

	self
		preferred: #defaultLabelSelector
		is: selectorSymbol! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/11/2004 10:43'!
hasNextPreferences

	^ target notNil! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/11/2004 12:52'!
inheritPreference: preferenceSymbol
	"Ensure I am not overriding preferenceSymbol with my own value and inherit it from my super preferences."

	self removePreferred: preferenceSymbol! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/8/2004 20:36'!
initialize

	super initialize.
	values _ Dictionary new! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/5/2004 14:42'!
initializeColors

	self colorScheme: MauiColorScheme orangeSlate! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/11/2004 15:20'!
initializeGlobalValues

	self
		initializeColors;
		initializeUsability;
		initializeHotKeys;
		initializeResources ;
		initializePrototypes ;
		initializeLabelling! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 10/8/2004 11:33'!
initializeHotKeys

	self
		"MauiMorphs"
		keyForRemove: $x ;
		keyForContextCommands: Character escape ;
		keyForAnotherView: $v ;
		keyForMakeIcon: $k ;
		keyForToolsAccess: $t ;
		keyForFocusShift: Character tab;
		keyForOpenHierarchy: $b ;
		keyForOpenClass: $c ;
		keyForOpenPackage: $p ;
		keyForExploreObject: $i ;
		keyForExploreMorph: $m ;
		keyForHalos: $h;
		keyForFindMessage: $f ;
		keyForLabel: $l ;
		keyForGrab: $g ;
		keyForSendToBack: $- ;

		"MauiMessageMorphs"
		keyForBrowseSenders: $n ;

		keyForViewMethod: $m ;

		"String-editor"
		keyForAccept: Character cr ;
		modifierForAccept: false "no shift" ;
		modifierForFocusShift: false! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/11/2004 15:19'!
initializeLabelling

	self 
		defaultLabelSelector: #mauiName ;
		label: MauiStringMorph new! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 1/10/2005 22:37'!
initializePrototypes

	self
		stringEditor: MauiStringEditor new ;
		stringMorph: MauiStringMorph new ;
		parameterHolder: MauiParameterHolderMorph new.
	MauiWorld hasConnectors
		ifTrue:
			[ self connector:
				((Smalltalk at: #NCAAConnectorMorph) new
					toggleSmoothing;
					borderWidth: 2;
					borderColor: (self colorScheme highlightColor alpha: self colorScheme highlightColor alpha / 2) ;
					lock;
					color: (self colorScheme highlightColor alpha: self colorScheme highlightColor alpha / 2);
					yourself) ]! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/8/2004 20:27'!
initializeResources

	self resourcePath: ''! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 1/9/2005 18:48'!
initializeUsability

	self 
		useMenuBalloonHelp: true ;
		connectObjects: MauiWorld hasConnectors ;
		scalePoint: (0.65@0.65) ;
		transitionDuration: 0! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/11/2004 22:54'!
isGlobal

	^ self == MauiPreferences global! !

!MauiPreferences methodsFor: 'hot keys-string editor' stamp: 'cmm 8/8/2004 20:32'!
keyForAccept

	^ values 
		at: #keyForAccept
		ifAbsent: [ self nextPreferences keyForAccept ]! !

!MauiPreferences methodsFor: 'hot keys-string editor' stamp: 'cmm 8/12/2004 00:40'!
keyForAccept: aCharacter

	self
		preferred: #keyForAccept 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:31'!
keyForAnotherView

	^ values 
		at: #keyForAnotherView
		ifAbsent: [ self nextPreferences keyForAnotherView ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:37'!
keyForAnotherView: aCharacter

	self 
		preferred: #keyForAnotherView 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:31'!
keyForBrowseSenders

	^ values 
		at: #keyForBrowseSenders
		ifAbsent: [ self nextPreferences keyForBrowseSenders ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:37'!
keyForBrowseSenders: aCharacter

	self 
		preferred: #keyForBrowseSenders 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys-string editor' stamp: 'cmm 1/13/2004 00:07'!
keyForCancelEdit

	^Character escape! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:32'!
keyForContextCommands

	^ values 
		at: #keyForContextCommands
		ifAbsent: [ self nextPreferences keyForContextCommands ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:37'!
keyForContextCommands: aCharacter

	self
		preferred: #keyForContextCommands
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:30'!
keyForExploreMorph

	^ values 
		at: #keyForExploreMorph
		ifAbsent: [ self nextPreferences keyForExploreMorph ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:37'!
keyForExploreMorph: aCharacter

	self 
		preferred: #keyForExploreMorph 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:32'!
keyForExploreObject

	^ values 
		at: #keyForExploreObject
		ifAbsent: [ self nextPreferences keyForExploreObject ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:38'!
keyForExploreObject: aCharacter

	self
		preferred: #keyForExploreObject 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:31'!
keyForFindMessage

	^ values
		at: #keyForFindMessage
		ifAbsent: [ self nextPreferences keyForFindMessage ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:38'!
keyForFindMessage: aCharacter

	self
		preferred: #keyForFindMessage 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:30'!
keyForFocusShift

	^ values 
		at: #keyForFocusShift
		ifAbsent: [ self nextPreferences keyForFocusShift ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:38'!
keyForFocusShift: aCharacter

	self
		preferred: #keyForFocusShift 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 9/10/2004 15:23'!
keyForGrab

	^ values 
		at: #keyForGrab
		ifAbsent: [ self nextPreferences keyForGrab ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 9/10/2004 15:23'!
keyForGrab: aCharacter

	self
		preferred: #keyForGrab 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:31'!
keyForHalos

	^ values 
		at: #keyForHalos
		ifAbsent: [ self nextPreferences keyForHalos ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:38'!
keyForHalos: aCharacter

	self
		preferred: #keyForHalos 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:30'!
keyForLabel

	^ values 
		at: #keyForLabel
		ifAbsent: [ self nextPreferences keyForLabel ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:38'!
keyForLabel: aCharacter

	self
		preferred: #keyForLabel 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:31'!
keyForMakeIcon

	^ values 
		at: #keyForMakeIcon
		ifAbsent: [ self nextPreferences keyForMakeIcon ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:38'!
keyForMakeIcon: aCharacter

	self
		preferred: #keyForMakeIcon 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:32'!
keyForOpenClass

	^ values
		at: #keyForOpenClass
		ifAbsent: [ self nextPreferences keyForOpenClass ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:39'!
keyForOpenClass: aCharacter

	self
		preferred: #keyForOpenClass 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:32'!
keyForOpenHierarchy

	^ values 
		at: #keyForOpenHierarchy
		ifAbsent: [ self nextPreferences keyForOpenHierarchy ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:39'!
keyForOpenHierarchy: aCharacter

	self
		preferred: #keyForOpenHierarchy 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:32'!
keyForOpenPackage

	^ values
		at: #keyForOpenPackage
		ifAbsent: [ self nextPreferences keyForOpenPackage ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:39'!
keyForOpenPackage: aCharacter

	self
		preferred: #keyForOpenPackage 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:32'!
keyForRemove

	^ values 
		at: #keyForRemove
		ifAbsent: [ self nextPreferences keyForRemove ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:39'!
keyForRemove: aCharacter

	self
		preferred: #keyForRemove 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 10/8/2004 11:31'!
keyForSendToBack

	^ values 
		at: #keyForSendToBack
		ifAbsent: [ self nextPreferences keyForSendToBack ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 10/8/2004 11:31'!
keyForSendToBack: aCharacter

	self
		preferred: #keyForSendToBack 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:32'!
keyForToolsAccess

	^ values 
		at: #keyForToolsAccess
		ifAbsent: [ self nextPreferences keyForToolsAccess ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:39'!
keyForToolsAccess: aCharacter

	self
		preferred: #keyForToolsAccess 
		is: aCharacter! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/8/2004 20:30'!
keyForViewMethod

	^ values 
		at: #keyForViewMethod
		ifAbsent: [ self nextPreferences keyForViewMethod ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 8/12/2004 00:39'!
keyForViewMethod: aCharacter

	self
		preferred: #keyForViewMethod 
		is: aCharacter! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/8/2004 20:33'!
label
	"I am the default Morph used for message and object labels."

	^ values
		at: #label
		ifAbsent: [ self nextPreferences label ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/12/2004 00:36'!
label: aMauiStringMorph
	"I am the default Morph used for message and object labels."

	self
		preferred: #label
		is: aMauiStringMorph! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 7/31/2003 17:28'!
loadSketch: filenameString

	| sketch inputStream |
	inputStream _ FileStream readOnlyFileNamed: self resourcePath, filenameString.
	sketch _ inputStream fileInObjectAndCode.
	inputStream close.
	^sketch! !

!MauiPreferences methodsFor: 'hot keys-string editor' stamp: 'cmm 8/9/2004 21:41'!
modifierForAccept
	"No numerical values for shift modifiers that I can see right now. Ahh, we'll just use Shift because that can be more concisely described in the key-mapping in the menu (e.g., ^ Enter)."

	^ values 
		at: #modifierForAccept
		ifAbsent: [ self nextPreferences modifierForAccept ]! !

!MauiPreferences methodsFor: 'hot keys-string editor' stamp: 'cmm 8/12/2004 00:40'!
modifierForAccept: aBoolean
	"No numerical values for shift modifiers that I can see right now. Ahh, we'll just use Shift because that can be more concisely described in the key-mapping in the menu (e.g., ^ Enter)."

	self
		preferred: #modifierForAccept
		is: aBoolean! !

!MauiPreferences methodsFor: 'hot keys-string editor' stamp: 'cmm 8/9/2004 21:42'!
modifierForFocusShift
	"No numerical values for shift modifiers that I can see right now. Ahh, we'll just use Shift because that can be more concisely described in the key-mapping in the menu (e.g., ^ Enter)."

	^ values 
		at: #modifierForFocusShift
		ifAbsent: [ self nextPreferences modifierForFocusShift ]! !

!MauiPreferences methodsFor: 'hot keys-string editor' stamp: 'cmm 8/12/2004 00:40'!
modifierForFocusShift: aBoolean
	"No numerical values for shift modifiers that I can see right now. Ahh, we'll just use Shift because that can be more concisely described in the key-mapping in the menu (e.g., ^ Enter)."

	self
		preferred: #modifierForFocusShift
		is: aBoolean! !

!MauiPreferences methodsFor: 'override' stamp: 'cmm 8/11/2004 10:28'!
newOverrideFor: targetObject
	"Create a new set of preferences for targetObject that can override specific values of its nextPreferenceSource."

	^ MauiPreferences target: targetObject! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/11/2004 10:26'!
nextPreferences

	^ target
		ifNil: [ MauiSoftwareError signal: 'no preference found' ]
		ifNotNil: [ target nextPreferenceSource preferences ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/13/2004 00:13'!
parameterHolder

	^ values 
		at: #parameterHolder
		ifAbsent: [ self nextPreferences parameterHolder ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/13/2004 00:13'!
parameterHolder: aMauiParameterHolderMorph

	self 
		preferred: #parameterHolder
		is: aMauiParameterHolderMorph! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/11/2004 10:38'!
preferenceChainFor: preferenceSymbol
	"Answer an OrderedCollection containing the objects in the chain of preferences that specify a value for preferenceSymbol, where the last entry in the collection is MauiPreferences global."

	| answer |
	answer _ OrderedCollection new.
	self
		buildChain: answer
		for: preferenceSymbol.
	^ answer! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 11/18/2003 23:34'!
preferenceOrMenuBalloonMessage: aString

	^self useMenuBalloonHelp
		ifTrue: [ aString ]
		ifFalse: [ nil ]! !

!MauiPreferences methodsFor: 'preference-bearer role' stamp: 'cmm 8/11/2004 22:03'!
preferences
	"This is a confusing method to have.  Since the global preferences acts as both the 'chain-link' to the next preferences *as well as* the preferences themselves, this method is part of the role of the chain-link that contains the preference.  The other two links are MauiFamily and MauiMorph."
	^ self! !

!MauiPreferences methodsFor: 'preference-bearer role' stamp: 'cmm 8/11/2004 22:56'!
preferencesName

	^ 'MauiPreferences global'! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/5/2004 15:55'!
preferred: preferenceSelector

	^ self perform: preferenceSelector! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/12/2004 00:48'!
preferred: preferenceSymbol is: anObject

	anObject
		ifNil: [ self removePreferred: preferenceSymbol ]
		ifNotNil:
			[ values
				at: preferenceSymbol
				put: anObject ].
	self changed: #preferenceSymbol! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/8/2004 20:35'!
removePreferred: preferenceSymbol

	values
		removeKey: preferenceSymbol
		ifAbsent: [ "ok" ]! !

!MauiPreferences methodsFor: 'resources' stamp: 'cmm 8/8/2004 20:27'!
resourcePath

	^ values 
		at: #resourcePath
		ifAbsent: [ self nextPreferences resourcePath ]! !

!MauiPreferences methodsFor: 'resources' stamp: 'cmm 8/12/2004 00:40'!
resourcePath: aString

	self
		preferred: #resourcePath
		is: aString! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/14/2004 20:45'!
scalePoint

	"A point between 0.0 and 1.1 used to scale-down the size of the sketch."
	^ values 
		at: #scalePoint
		ifAbsent: [ self nextPreferences scalePoint ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/14/2004 20:45'!
scalePoint: aPoint
	"A point between 0.0 and 1.1 used to scale-down the size of the sketch."

	self
		preferred: #scalePoint
		is: aPoint! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/11/2004 22:19'!
sourceOfPreference: preferenceSymbol
	"Answers the MauiPreferences that specifies: preferenceSymbol."
	^ (self specifies: preferenceSymbol)
		ifTrue: [ self ]
		ifFalse: [ self nextPreferences sourceOfPreference: preferenceSymbol ]! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/8/2004 20:34'!
specifies: preferenceSymbol
	"Answers whether I have value for preferenceSymbol."

	^ values includesKey: preferenceSymbol! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/8/2004 20:34'!
stringEditor

	^ values 
		at: #stringEditor
		ifAbsent: [ self nextPreferences stringEditor ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/3/2004 10:25'!
stringEditor: aMauiStringEditor
	"A MauiStringEditor prototype cloned to be the string-editor for Maui morphs."
	self
		preferred: #stringEditor 
		is: aMauiStringEditor! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/8/2004 20:33'!
stringMorph

	^ values
		at: #stringMorph
		ifAbsent: [ self nextPreferences stringMorph ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/12/2004 23:33'!
stringMorph: aStringMorph

	self
		preferred: #stringMorph
		is: aStringMorph! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/11/2004 18:10'!
target

	^ target ifNil: [ self "I should be the global prefs if I had no target" ]! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/11/2004 21:56'!
target: anObject
	"anObject will be either MauiMorph or a MauiFamily."

	target _ anObject! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 12/30/2004 00:04'!
transitionDuration
	^ values 
		at: #transitionDuration
		ifAbsent: [ self nextPreferences transitionDuration ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 1/1/2005 14:46'!
transitionDuration: numberOfMilliseconds
	"Set the length of the cutsey transition effects, in milliseconds.  Try 100.  The effects run in the background so they don't affect responsiveness, but it is more work for the computer so a value of 0 is recommended for slow computers."

	self
		preferred: #transitionDuration
		is: numberOfMilliseconds! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/8/2004 20:28'!
useMenuBalloonHelp

	^ values 
		at: #useMenuBalloonHelp
		ifAbsent: [ self nextPreferences useMenuBalloonHelp ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/12/2004 00:40'!
useMenuBalloonHelp: aBoolean
	"If true, balloon-help will appear when the pointer hovers over a pop-up menu item."

	self
		preferred: #useMenuBalloonHelp
		is: aBoolean! !

!MauiPreferences methodsFor: 'copying' stamp: 'cmm 8/16/2004 17:29'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	target isMauiMorph ifTrue:
		[ target _ target veryDeepCopyWith: aDeepCopier ]! !

MaObject subclass: #MauiRegistry
	instanceVariableNames: 'mauiClasses'
	classVariableNames: 'Global'
	poolDictionaries: ''
	category: 'Maui-Customizing'!

!MauiRegistry commentStamp: 'cmm 1/5/2004 21:58' prior: 0!
I am a registry for overriding some of Maui's default behaviors, such as the default MauiMorph class used to represent a particular class of domain.  You may have a better MauiCollectionMorph or to have a calendar-representation of a MauiDateMorph.!

!MauiRegistry class methodsFor: 'as yet unclassified' stamp: 'cmm 1/9/2005 20:29'!
global

	^ Global ifNil: [ Global _ self new ]! !

!MauiRegistry methodsFor: 'initialize' stamp: 'cmm 1/5/2004 22:00'!
initialize

	mauiClasses _ Dictionary new.
	self initializeMauiClasses! !

!MauiRegistry methodsFor: 'initialize' stamp: 'cmm 1/9/2005 14:55'!
initializeMauiClasses

	self
		register: MauiMessageMorph
		forAny: MauiMessage.
	self
		register: MauiClientProcessMorph
		forAny: MaClientProcess.
	self
		register: MauiCollectionMorph
		forAny: Collection.
	(Smalltalk hasClassNamed: #MagmaCollection)
		ifTrue:
			[ self
				register: MauiCollectionMorph
				forAny: (Smalltalk at: #MagmaCollection) ].
	self
		register: MauiCollectionMorph
		forAny: MaContextResultsContext.
	self
		register: MauiPreferencesMorph
		forAny: MauiPreferences.
	self
		register: MauiContextMorph
		forAny: MaSearchContext.
	self
		register: MauiCompositeContextMorph 
		forAny: MaCompositeContext.
	self
		register: MauiDateMorph
		forAny: Date.
	self
		register: MauiNumberMorph
		forAny: Number.
	self
		register: MaProgressorMorph
		forAny: MaProgressor.
	self
		register: MauiStringMorph
		forAny: String.
	self
		register: MauiDocMorph
		forAny: MauiDoc.
	self
		register: MauiMorphMorph
		forAny: MauiMorph.
	self
		register: MauiDomainMorph
		forAny: DirectoryEntry! !

!MauiRegistry methodsFor: 'access' stamp: 'cmm 1/5/2004 22:33'!
mauiMorphClassFor: aClass

	^aClass
		ifNil: [ MauiDomainMorph ]
		ifNotNil: 
			[ mauiClasses 
				at: aClass
				ifAbsent: [ self mauiMorphClassFor: aClass superclass ] ]! !

!MauiRegistry methodsFor: 'register' stamp: 'cmm 12/8/2004 15:35'!
register: morphClass forAny: domainClass

	mauiClasses
		at: domainClass
		put: morphClass! !

MaObject subclass: #MauiStringEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

MauiStringEvaluator subclass: #MauiDateEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiDateEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 8/8/2004 21:37'!
evaluate: aString for: aMauiStringEditor

	^ Date fromString: aString! !

MauiStringEvaluator subclass: #MauiSmalltalkEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiSmalltalkEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 8/8/2004 21:38'!
evaluate: aString for: aMauiStringEditor

	| answer | 
Transcript cr; show: 'evaluating ', aString.
	answer _
		[ Compiler
			evaluate: aString
			notifying: aMauiStringEditor
			logged: false ]
		on: Error
		do: [ : exc | Transcript cr; show: exc messageText; show: ' - using as entered string.'.  exc return: (super evaluate: aString) ].
	^ answer! !

!MauiStringEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 8/5/2004 15:25'!
evaluate: aString

	^ aString! !

!MauiStringEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 8/8/2004 21:37'!
evaluate: aString for: aMauiStringEditor

	^ aString! !

MaObject subclass: #MauiUserStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

MauiUserStrategy subclass: #MauiDeveloperStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MauiDeveloperStrategy methodsFor: 'testing' stamp: 'cmm 8/10/2004 00:02'!
allowsMorphComposition
	"Answers whether a MauiDomainMorph may be dragged directly into another.  This is used during development to compose into row/column layouts."
	
	^ true! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 12:31'!
appendCollectionMenuItemsTo: aMenu for: aMauiCollectionMorph

	| elementsViewMenu |
	super
		appendCollectionMenuItemsTo: aMenu
		for: aMauiCollectionMorph.
	elementsViewMenu _ self buildElementsViewMenuFor: aMauiCollectionMorph.
	elementsViewMenu items notEmpty
		ifTrue:
			[ aMenu addLine.
			aMenu
				add: 'elements view'
				subMenu: elementsViewMenu ]! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 13:52'!
appendDomainMenuItemsTo: aMenu for: aMauiDomainMorph

	super
		appendDomainMenuItemsTo: aMenu
		for: aMauiDomainMorph! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 12:06'!
appendMessageMorphItemsTo: aMenu for: aMauiMessageMorph

	super
		appendMessageMorphItemsTo: aMenu
		for: aMauiMessageMorph.
	aMenu addLine.
	aMenu
		add: 'my receiver'
		target: aMauiMessageMorph
		selector: #addReceiverIndicator! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 12:32'!
appendParameterHolderMenuItemsTo: aMenu for: aMauiParameterHolderMorph

	super
		appendParameterHolderMenuItemsTo: aMenu
		for: aMauiParameterHolderMorph.
	aMauiParameterHolderMorph argumentName maPossibleCodeElementIdentifiers isEmpty
		ifFalse:
			[ aMenu
				add: 'try to browse parameter hierarchy'
				target: aMauiParameterHolderMorph
				selector: #browseParameterHierarchy ]! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 9/10/2004 15:18'!
appendStandardMenuItemsTo: aMenu for: aMauiMorph

	super
		appendStandardMenuItemsTo: aMenu
		for: aMauiMorph.
	aMenu
		addUpdating: #closeBoxMenuString
		target: aMauiMorph
		action: #toggleCloseBox.
	"Not in user strategy because all windows are labelled there."
	aMenu
		addUpdating: #labelledMenuString
		target: aMauiMorph
		action: #toggleLabelled.
	"Not in user strategy because don't want to clutter the menu when they have the familiar close-box."
	aMenu
		add: (aMauiMorph string: 'remove' withKeyBindingFor: #keyForRemove)
		target: aMauiMorph
		selector: #delete.
	"Not in user-strategy because multiple views could be confusing and extranneous."
	aMenu
		add: (aMauiMorph string: 'another view' withKeyBindingFor: #keyForAnotherView)
		target: aMauiMorph
		selector: #cloneUi.
	aMenu
		add: (aMauiMorph string: 'halos' withKeyBindingFor: #keyForHalos)
		target: aMauiMorph
		selector: #addHalo.
	aMenu
		add: (aMauiMorph string: 'tools' withKeyBindingFor: #keyForToolsAccess)
		target: aMauiMorph
		selector: #openToolMenu! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 10:25'!
buildElementsViewMenuFor: aMauiCollectionMorph

	| answer |
	answer _ MenuMorph new.
	aMauiCollectionMorph intersectingViews do:
		[ : each | 
		answer
			add: each
			target: aMauiCollectionMorph
			selector: #elementsView:
			argument: each ].
	^ answer! !

!MauiDeveloperStrategy methodsFor: 'keyboard' stamp: 'cmm 7/16/2004 12:31'!
handleMessageKeyboardEvent: aKeyboardEvent for: aMauiMessageMorph
	| keyPressed |
	super
		handleMessageKeyboardEvent: aKeyboardEvent
		for: aMauiMessageMorph.
	keyPressed _ aKeyboardEvent keyCharacter.
	keyPressed = (aMauiMessageMorph preferred: #keyForViewMethod) ifTrue:
		[ aMauiMessageMorph viewMethod.
		aKeyboardEvent wasHandled: true ].
	keyPressed = (aMauiMessageMorph preferred: #keyForBrowseSenders) ifTrue:
		[ aMauiMessageMorph browseSenders.
		aKeyboardEvent wasHandled: true ].
! !

!MauiDeveloperStrategy methodsFor: 'keyboard' stamp: 'cmm 7/16/2004 12:31'!
handleParameterHolderKeyboardEvent: aKeyboardEvent for: aMauiParameterHolderMorph
	| keyPressed |
	super
		handleParameterHolderKeyboardEvent: aKeyboardEvent
		for: aMauiParameterHolderMorph.
	keyPressed _ aKeyboardEvent keyCharacter.
	(keyPressed = (aMauiParameterHolderMorph preferred: #keyForOpenHierarchy)
	and: [ aKeyboardEvent commandKeyPressed ])
		ifTrue:
			[ aMauiParameterHolderMorph browseParameterHierarchy. 
			aKeyboardEvent wasHandled: true ]! !

!MauiDeveloperStrategy methodsFor: 'keyboard' stamp: 'cmm 12/18/2004 17:52'!
handleStandardKeyboardEvent: aKeyboardEvent for: aMauiMorph

	| keyPressed h |
	h _ super
		handleStandardKeyboardEvent: aKeyboardEvent
		for: aMauiMorph.
	h ifTrue: [ ^ true ].
	keyPressed _ aKeyboardEvent keyCharacter.
	keyPressed = (aMauiMorph preferred: #keyForAnotherView)
		ifTrue: 
			[ aMauiMorph cloneUi.
			h_true ].
	keyPressed = (aMauiMorph preferred: #keyForToolsAccess) ifTrue: [ aMauiMorph openToolMenu.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForOpenHierarchy) ifTrue: [ aMauiMorph browseDomainHierarchy.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForOpenClass) ifTrue: [ aMauiMorph browseDomainClass.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForOpenPackage) ifTrue: [ aMauiMorph browseDomainFull.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForHalos) ifTrue: [ aMauiMorph addHalo.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForFindMessage) ifTrue: [ aMauiMorph openDomainHud.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForExploreObject) ifTrue: [ aMauiMorph object inspect.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForExploreObject) asUppercase ifTrue: [ aMauiMorph object explore.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForExploreMorph) ifTrue: [ aMauiMorph inspect.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForExploreMorph) asUppercase ifTrue: [ aMauiMorph explore.  h_true ].
	^ h! !

!MauiDeveloperStrategy methodsFor: 'testing' stamp: 'cmm 7/15/2004 23:02'!
isDevelopmentMode

	^ true! !

!MauiDeveloperStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 14:31'!
mauiFamilyPreferenceSelectors

	^ self mauiGlobalPreferenceSelectors! !

!MauiDeveloperStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 14:31'!
mauiGlobalPreferenceSelectors

	^ #( defaultLabelSelector connector label parameterHolder stringEditor stringMorph colorScheme modifierForAccept modifierForFocusShift connectObjects useMenuBalloonHelp )! !

!MauiDeveloperStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:14'!
mauiMessagePreferenceSelectors

	^ #( label parameterHolder )! !

!MauiDeveloperStrategy methodsFor: 'preferences' stamp: 'cmm 8/15/2004 23:58'!
mauiMorphPreferenceSelectors

	^ super mauiMorphPreferenceSelectors, #(useMenuBalloonHelp stringEditor colorScheme)! !

!MauiDeveloperStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:26'!
mauiParameterHolderMorphPreferenceSelectors

	^ #( stringEditor modifierForAccept modifierForFocusShift )! !

!MauiDeveloperStrategy methodsFor: 'hooks' stamp: 'cmm 7/29/2004 17:29'!
note: aMauiDomainMorph beingReplacedBy: replacementMauiDomainMorph

	super
		note: aMauiDomainMorph
		beingReplacedBy: replacementMauiDomainMorph.
	"If we're going to something other than back to the work-in-progress view.."
	replacementMauiDomainMorph view ~= MauiDomainMorph workInProgressView
		ifTrue:
			[ aMauiDomainMorph family
				remember: aMauiDomainMorph
				as: MauiDomainMorph workInProgressView
				atLevel: aMauiDomainMorph object class ]! !

!MauiDeveloperStrategy methodsFor: 'hooks' stamp: 'cmm 7/16/2004 15:25'!
noteNewUserStrategyFor: aMauiMorph

	aMauiMorph revertToPrototype! !

!MauiDeveloperStrategy methodsFor: 'Morphic' stamp: 'cmm 7/27/2004 15:40'!
yellowDown: aMouseButtonEvent on: aMauiMorph

	aMouseButtonEvent shiftPressed
		ifTrue: [ aMauiMorph openToolMenu ]
		ifFalse:
			[ super
				yellowDown: aMouseButtonEvent
				on: aMauiMorph ]! !

MauiUserStrategy subclass: #MauiEndUserStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MauiEndUserStrategy methodsFor: 'testing' stamp: 'cmm 7/16/2004 11:06'!
likesViewsFor: aClass

	^ (super likesViewsFor: aClass) and: [ aClass ~= Object ]! !

!MauiEndUserStrategy methodsFor: 'preferences' stamp: 'cmm 8/15/2004 23:58'!
mauiMorphPreferenceSelectors

	^ super mauiMorphPreferenceSelectors, #(useMenuBalloonHelp colorScheme)! !

!MauiEndUserStrategy methodsFor: 'name conversion' stamp: 'cmm 7/15/2004 23:09'!
nameFor: aString

	^ self smalltalkToWords: aString! !

!MauiEndUserStrategy methodsFor: 'hooks' stamp: 'cmm 7/16/2004 15:24'!
noteNewUserStrategyFor: aMauiMorph

	self adjustMessageLabelsOf: aMauiMorph! !

!MauiEndUserStrategy methodsFor: 'name conversion' stamp: 'cmm 7/15/2004 22:57'!
smalltalkToWords: smalltalkString
	"smalltalkString may be a Smalltalk class name, method name, or a parameter name (aString or smalltalkString).
	
	'MauiUserStrategy' answers 'Maui User Strategy'
	'smalltalkToWords:' answers 'Smalltalk To Words:'
	'aString' answers 'A String'
	'aMaObjectSerializer' answers 'A Ma Object Serializer'
	'aMagmaSession' answers 'A Magma Session'
	'A typical overridden name:' answers 'A typical overridden name:'"

	| smalltalkStream words |
	smalltalkStream _ smalltalkString readStream.
	words _ String streamContents:
		[ : stream |
		[ smalltalkStream atEnd ]
			whileFalse:
				[ (smalltalkStream peek isUppercase
					and: [ stream isEmpty not
					and: [ stream last ~= Character space ] ]) ifTrue: [ stream space ].
				stream isEmpty
					ifTrue: [ stream nextPut: smalltalkStream next asUppercase ]
					ifFalse: [ stream nextPut: smalltalkStream next ] ] ].
	^ words! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 11:01'!
addViewsMenuTo: aMenu for: aMauiDomainMorph

	aMauiDomainMorph addViewsMenuTo: aMenu! !

!MauiUserStrategy methodsFor: 'hooks' stamp: 'cmm 7/16/2004 15:08'!
adjustLabelsOf: aMauiMessageMorph

	aMauiMessageMorph labelsDo:
		[ : eachLabelMorph |
		eachLabelMorph string: (self nameFor: eachLabelMorph string) ]! !

!MauiUserStrategy methodsFor: 'name conversion' stamp: 'cmm 7/16/2004 15:17'!
adjustMessageLabelsOf: aMauiMorph

	aMauiMorph allMorphsDo:
		[ : each | each isMauiMessageMorph ifTrue: [ self adjustLabelsOf: each ] ]! !

!MauiUserStrategy methodsFor: 'testing' stamp: 'cmm 8/10/2004 00:02'!
allowsMorphComposition
	"Answers whether a MauiDomainMorph may be dragged directly into another.  This is used during development to compose into row/column layouts."
	
	^ false! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 10:28'!
appendCollectionMenuItemsTo: aMenu for: aMauiCollectionMorph
	"No extra items by default."! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 8/2/2004 23:21'!
appendDomainMorphMenuItemsTo: aMenu for: aMauiDomainMorph

	aMenu defaultTarget: aMauiDomainMorph.
	aMenu
		add: (aMauiDomainMorph string: 'make icon' withKeyBindingFor: #keyForMakeIcon)
		target: aMauiDomainMorph
		selector: #makeIcon! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 12:04'!
appendMessageMorphItemsTo: aMenu for: aMauiMessageMorph

	aMauiMessageMorph canInvoke
		ifTrue:
			[ aMenu
				add: 'invoke'
				target: aMauiMessageMorph
				selector: #invoke ]! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 8/13/2004 00:29'!
appendParameterHolderMenuItemsTo: aMenu for: aMauiParameterHolderMorph

	aMenu
		add: 'preferences...'
		target: aMauiParameterHolderMorph
		selector: #openPreferences! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 10/8/2004 11:34'!
appendStandardMenuItemsTo: aMenu for: aMauiMorph

	aMenu
		add: (aMauiMorph string: 'grab' withKeyBindingFor: #keyForGrab)
		target: aMauiMorph
		selector: #grab ;

		add: (aMauiMorph string: 'send to back' withKeyBindingFor: #keyForSendToBack)
		target: aMauiMorph
		selector: #goBehind ;

		add: 'preferences...'
		target: aMauiMorph
		selector: #openPreferences! !

!MauiUserStrategy methodsFor: 'keyboard' stamp: 'cmm 7/16/2004 12:30'!
handleMessageKeyboardEvent: aKeyboardEvent for: aMauiMessageMorph
	"No default keys for messages."! !

!MauiUserStrategy methodsFor: 'keyboard' stamp: 'cmm 7/16/2004 12:27'!
handleParameterHolderKeyboardEvent: aKeyboardEvent for: aMauiParameterHolderMorph
	"No special command-keys by default."! !

!MauiUserStrategy methodsFor: 'keyboard' stamp: 'cmm 10/8/2004 11:36'!
handleStandardKeyboardEvent: aKeyboardEvent for: aMauiMorph

	| keyPressed h |
	h _ false.
	keyPressed _ aKeyboardEvent keyCharacter.
	keyPressed = Character arrowDown ifTrue: [ aMauiMorph position: aMauiMorph position + (0@1) ].
	keyPressed = Character arrowUp ifTrue: [ aMauiMorph position: aMauiMorph position + (0@-1) ].
	keyPressed = Character arrowRight ifTrue: [ aMauiMorph position: aMauiMorph position + (1@0) ].
	keyPressed = Character arrowLeft ifTrue: [ aMauiMorph position: aMauiMorph position + (-1@0) ].
	keyPressed = (aMauiMorph preferred: #keyForRemove) 
		ifTrue:
			[ aMauiMorph focusOnNextPlayerUsing: aKeyboardEvent.
			aMauiMorph delete.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForMakeIcon) 
		ifTrue: 
			[ aMauiMorph makeIcon openInHand.
			h_true ].
	keyPressed = (aMauiMorph preferred: #keyForFocusShift) ifTrue: [ aMauiMorph shiftFocus: aKeyboardEvent.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForContextCommands) ifTrue: [ aMauiMorph openContextMenu.  h_true ].
	keyPressed = (aMauiMorph preferred: #keyForLabel) ifTrue: [ aMauiMorph toggleLabelled ].
	keyPressed = (aMauiMorph preferred: #keyForGrab) ifTrue: [ aMauiMorph grab ].
	keyPressed = (aMauiMorph preferred: #keyForSendToBack) ifTrue: [ aMauiMorph goBehind ].
	^ h! !

!MauiUserStrategy methodsFor: 'testing' stamp: 'cmm 7/16/2004 10:23'!
isDevelopmentMode

	^ false! !

!MauiUserStrategy methodsFor: 'testing' stamp: 'cmm 7/16/2004 11:04'!
likesViewsFor: aClass

	^ aClass notNil! !

!MauiUserStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:22'!
mauiDomainMorphPreferenceSelectors

	^ #( connectObjects connector ), self mauiMorphPreferenceSelectors ! !

!MauiUserStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 14:22'!
mauiFamilyPreferenceSelectors

	^ #()! !

!MauiUserStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:10'!
mauiMessagePreferenceSelectors

	^ #()! !

!MauiUserStrategy methodsFor: 'preferences' stamp: 'cmm 8/11/2004 17:48'!
mauiMorphPreferenceSelectors

	^ #()! !

!MauiUserStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 00:25'!
mauiParameterHolderMorphPreferenceSelectors

	^ #()! !

!MauiUserStrategy methodsFor: 'name conversion' stamp: 'cmm 7/16/2004 10:22'!
nameFor: aString

	^ aString! !

!MauiUserStrategy methodsFor: 'hooks' stamp: 'cmm 7/29/2004 17:24'!
note: aMauiDomainMorph beingReplacedBy: replacementMauiDomainMorph
! !

!MauiUserStrategy methodsFor: 'Morphic' stamp: 'cmm 7/27/2004 15:45'!
yellowDown: aMouseButtonEvent on: aMauiMorph

	aMouseButtonEvent shiftPressed ifFalse: [ aMauiMorph openContextMenu ]! !

MaObject subclass: #MauiWorld
	instanceVariableNames: 'family players playersForNil playerSequence connectors messageMorphs userStrategy'
	classVariableNames: 'AllMauiWorlds'
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MauiWorld class methodsFor: 'as yet unclassified' stamp: 'cmm 1/9/2005 12:00'!
allMauiWorlds

	^ AllMauiWorlds ifNil: [ self initializeWorldsContainer ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 1/10/2005 22:34'!
cleanUp
	self initializeWorldsContainer! !

!MauiWorld class methodsFor: 'accessing' stamp: 'cmm 12/25/2003 11:59'!
current

	^self for: World! !

!MauiWorld class methodsFor: 'accessing' stamp: 'cmm 1/9/2005 14:40'!
for: aWorld

	aWorld ifNil: [ MauiSoftwareError signal: 'must have a world.' ].
	^ self allMauiWorlds
		at: aWorld
		ifAbsentPut: [ self new ]! !

!MauiWorld class methodsFor: 'environment' stamp: 'cmm 1/10/2005 22:08'!
hasConnectors

	^ Smalltalk hasClassNamed: #NCAAConnectorMorph ! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 8/11/2004 17:57'!
initializeMaui

	self initialize.
	MauiFamily initialize.
	MauiPreferences initialize.
	MauiRegistry initialize! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 1/9/2005 12:00'!
initializeWorldsContainer

	super initialize.
	AllMauiWorlds ifNotNil: [ AllMauiWorlds do: [ : each | each cleanUp ] ].
	AllMauiWorlds _ WeakIdentityKeyDictionary new.
	self setUpTransferMorphListeners.
	^ AllMauiWorlds! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/25/2004 20:23'!
listenForLeavingWorlds
	Project allProjects do:
		[ : each |
		each world
			when: #aboutToLeaveWorld
			send: #setUpTransferMorphListeners
			to: self ]! !

!MauiWorld class methodsFor: 'private' stamp: 'cmm 8/15/2004 23:21'!
maui: anObject

	| view |
	view _ 
		self current family
			newViewNamed: #beDefault
			for: anObject.
	self current
		onePlayerFor: anObject
		is: view openInHand.
	^ view! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/25/2004 20:27'!
releaseLeavingWorldListeners
	Project allProjects do:
		[ : each |
		each world removeActionsForEvent: #aboutToLeaveWorld ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 7/30/2004 00:41'!
releaseTransferMorphListeners

	World removeTransferMorphSelector: #mauiTransferMorph:event:! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/25/2004 20:45'!
setUpTransferMorphListeners

	self listenForLeavingWorlds.
	Project allProjects do:
		[ : each |
		each world addTransferMorphSelector: #mauiTransferMorph:event: ]! !

!MauiWorld class methodsFor: 'debugging' stamp: 'cmm 7/25/2004 22:42'!
signalWhereInvalid

	self current playersDo:
		[ : each |
		each world == World ifTrue: [ each signalWhereInvalid ] ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/25/2004 20:27'!
unload

	self
		releaseTransferMorphListeners ;
		releaseLeavingWorldListeners! !

!MauiWorld methodsFor: 'private' stamp: 'cmm 1/5/2005 22:07'!
cleanGonePlayers

	| cleaner |
	self maMarked: 'hack'.
	"I  can't use outOfWorld: to detect when submorphs are removed because it is called at other times when I don't expect it to be.  So, for now, I keep the symptom cleaned up here, which is less performance intensive than with playersAt: (which is when we actually draw)."

	cleaner _
		[ : each | 
		each world ifNil: [ self removePlayer: each ].
		each _ nil ].
	playersForNil copy do: cleaner.
	players copy do: [ : eachSet | eachSet do: cleaner ]! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 12/27/2004 22:17'!
cleanUp

	self playersDo: [ : each | each delete ].
	self initialize! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/6/2003 16:01'!
connect: sourceMorph to: targetMorph

	(self connectorsFor: sourceMorph)
		add: 
			(self
				newConnectorFrom: sourceMorph
				to: targetMorph)! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:50'!
connectAllFrom: aMauiMorph

	self
		disconnectAllFrom: aMauiMorph;
		initializeConnectorsFor: aMauiMorph;
		showConnectorsFor: aMauiMorph! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/10/2003 21:27'!
connectorsFor: aMauiMorph

	^connectors 
		at: aMauiMorph
		ifAbsentPut: [ OrderedCollection new ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:28'!
delineateAllFrom: aMauiMorph

	(self playersFor: aMauiMorph object) do: [ : each | each delineate ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:31'!
delineateFrom: aMauiMorph

	self delineateAllFrom: aMauiMorph.
	(aMauiMorph preferred: #connectObjects) ifTrue: [ self connectAllFrom: aMauiMorph ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:49'!
disconnectAllFrom: aMauiMorph

	| c |
	c _ connectors
		removeKey: aMauiMorph
		ifAbsent: [ #() ].
	c do: [ : each | each maFadeAwayOver: (aMauiMorph preferred: #transitionDuration) ]! !

!MauiWorld methodsFor: 'family' stamp: 'cmm 8/15/2004 22:15'!
family

	^ family! !

!MauiWorld methodsFor: 'family' stamp: 'cmm 8/15/2004 22:10'!
family: aMauiFamily
	"Set the default family of MauiMorphs this world should use."

	family _ aMauiFamily! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/1/2004 15:51'!
hasPlayers

	^self playerCount > 0! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/17/2004 18:08'!
hasPlayersFor: anObject

	^anObject
		ifNil: [ playersForNil notEmpty ]
		ifNotNil: [ (players includesKey: anObject) and: [ (self playersAt: anObject) notEmpty ] ]! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 8/15/2004 22:09'!
initialize

	family _ MauiFamily default.
	players _ WeakIdentityKeyDictionary new.
	playersForNil _ WeakSet new.  "no reason not to make it weak"
	playerSequence _ OrderedCollection new.
	connectors _ WeakIdentityKeyDictionary new.
	messageMorphs _ WeakSet new.
	self userStrategy: MauiDeveloperStrategy new! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 16:08'!
initializeConnectorsFor: aMauiMorph

	(self playersFor: aMauiMorph object) do:
		[ : each |
		(each ~~ aMauiMorph and: [ each isInWorld ])
			ifTrue: [ self connect: aMauiMorph to: each ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 8/9/2004 23:08'!
isPlayer: aMauiDomainMorph
	"aMauiDomainMorph may not be a player if it is embedded within another MauiDomainMorph."

	^ (self playersFor: aMauiDomainMorph object) includes: aMauiDomainMorph! !

!MauiWorld methodsFor: 'message morphs' stamp: 'cmm 1/7/2004 22:51'!
messageMorphsDo: aBlock

	messageMorphs do: aBlock! !

!MauiWorld methodsFor: 'user strategy' stamp: 'cmm 7/15/2004 23:36'!
nameFor: aString

	^ userStrategy ifNil: [ '' ] ifNotNil: [ userStrategy nameFor: aString ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 8/5/2004 22:09'!
newConnectorFrom: sourceMorph to: targetMorph

	^(sourceMorph preferred: #connector) copy
		connectStartTo: sourceMorph;
		connectFinishTo: targetMorph;
		yourself! !

!MauiWorld methodsFor: 'message morphs' stamp: 'cmm 1/7/2004 22:52'!
oneMessageMorphIs: aMauiMessageMorph

	messageMorphs add: aMauiMessageMorph! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/10/2005 23:22'!
onePlayerFor: anObject is: aMauiMorph

	| objectPlayers |
	"extra guard for safety, may not be necessary."
	(aMauiMorph world isNil or: [ aMauiMorph isSelfContained ]) ifTrue: [ ^ self ].
self maMarked: 'dev'.
"Try to get rid of this."
"self cleanGonePlayers."
	objectPlayers _ self playersAt: anObject.
	(objectPlayers includes: aMauiMorph) ifTrue: [ ^ aMauiMorph ].
	objectPlayers add: aMauiMorph.
	playerSequence add: aMauiMorph.
	^ aMauiMorph! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 12/31/2003 00:06'!
playerAfter: aMauiMorph

	^playerSequence
		maAfter: aMauiMorph
		ifError: [ playerSequence first ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 12/31/2003 00:06'!
playerBefore: aMauiMorph

	^playerSequence
		maBefore: aMauiMorph
		ifError: [ playerSequence last ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/2/2004 00:44'!
playerCount

	^playerSequence size! !

!MauiWorld methodsFor: 'private' stamp: 'cmm 12/19/2003 17:50'!
playersAt: anObject

	^anObject
		ifNil: [ playersForNil ]
		ifNotNil:
			[ players
				at: anObject
				ifAbsentPut: [ WeakSet new ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/1/2004 16:30'!
playersDo: aBlock

	playerSequence copy do: aBlock! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/17/2004 18:09'!
playersFor: anObject

	^anObject 
		ifNil: [ playersForNil ]
		ifNotNil: 
			[ (self hasPlayersFor: anObject)
				ifTrue: [ self playersAt: anObject ]
				ifFalse: [ #() ] ]! !

!MauiWorld methodsFor: 'message morphs' stamp: 'cmm 1/7/2004 23:50'!
removeMessageMorph: aMauiMessageMorph

	messageMorphs
		remove: aMauiMessageMorph
		ifAbsent: [ "do nothing" ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/10/2005 23:21'!
removePlayer: aMauiMorph

	self undelineateFrom: aMauiMorph.
	playerSequence remove: aMauiMorph ifAbsent: [ "rare, but possible" ].
	aMauiMorph object
		ifNil: 
			[ playersForNil 
				remove: aMauiMorph 
				ifAbsent: [ "may be a cloned resultMorph still pointing to nil" ] ]
		ifNotNil:
			[ | playersForObject |
			playersForObject _ (players at: aMauiMorph object ifAbsent: [ ^self ]) 
				remove: aMauiMorph
				ifAbsent: [ "don't complain" ];
				yourself.
			playersForObject isEmpty ifTrue: [ players removeKey: aMauiMorph object ifAbsent: [ ] ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/2/2005 16:14'!
removePlayersWithNonDefaultNotificationHandler: aMauiNotificationHandler

	self playersDo:
		[ : each |
		(each notificationHandler = aMauiNotificationHandler
		and: [ (each notificationHandler ~= MauiNotificationHandler default) ])	
			ifTrue: [ each delete ] ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/10/2003 21:31'!
showConnectorsFor: aMauiMorph

	(self connectorsFor: aMauiMorph) do: [ : each | each openInWorld ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:48'!
undelineateAllFrom: aMauiMorph

	(self playersFor: aMauiMorph object) do: [ : each | each undelineate ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:56'!
undelineateFrom: aMauiMorph

	self
		undelineateAllFrom: aMauiMorph ;
		disconnectAllFrom: aMauiMorph! !

!MauiWorld methodsFor: 'user strategy' stamp: 'cmm 7/16/2004 10:27'!
userStrategy

	^ userStrategy! !

!MauiWorld methodsFor: 'user strategy' stamp: 'cmm 7/16/2004 15:25'!
userStrategy: aMauiUserStrategy

	| didChange |
	didChange _ userStrategy class ~= aMauiUserStrategy class.
	userStrategy _ aMauiUserStrategy.
	didChange
		ifTrue:
			[ self playersDo:
				[ : each | 
				aMauiUserStrategy noteNewUserStrategyFor: each ] ]! !

MaObject subclass: #PersonName
	instanceVariableNames: 'first middle last'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Test domains'!

!PersonName class methodsFor: 'creation' stamp: 'cmm 1/27/2004 16:09'!
first: firstNameString middle: middleNameString last: lastNameString

	^self new
		first: firstNameString;
		middle: middleNameString;
		last: lastNameString;
		yourself! !

!PersonName class methodsFor: '*maui' stamp: 'cmm 1/27/2004 16:11'!
mauiBasicApi

	^#(first:middle:last:)! !

!PersonName methodsFor: 'accessing' stamp: 'cmm 1/27/2004 15:40'!
first

	^first! !

!PersonName methodsFor: 'building' stamp: 'cmm 1/27/2004 15:40'!
first: aString

	first _ aString
! !

!PersonName methodsFor: 'accessing' stamp: 'cmm 1/27/2004 15:40'!
last

	^last! !

!PersonName methodsFor: 'building' stamp: 'cmm 1/27/2004 15:40'!
last: aString

	last _ aString
! !

!PersonName methodsFor: 'printing' stamp: 'cmm 1/27/2004 15:40'!
maPrintAbbreviatedOn: aStream

	aStream
		nextPutAll: self first;
		space;
		nextPutAll: self last
! !

!PersonName methodsFor: '*maui' stamp: 'cmm 1/27/2004 16:08'!
mauiBasicApi

	^#(first middle last)! !

!PersonName methodsFor: 'accessing' stamp: 'cmm 1/27/2004 15:40'!
middle

	^middle! !

!PersonName methodsFor: 'building' stamp: 'cmm 1/27/2004 15:40'!
middle: aString

	middle _ aString
! !

MaUserError subclass: #MauiUserError
	instanceVariableNames: 'doc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Exceptions'!

!MauiUserError class methodsFor: 'create' stamp: 'cmm 12/6/2004 23:26'!
doc: aMauiScript

	^ self new
		doc: aMauiScript ;
		yourself! !

!MauiUserError class methodsFor: 'signal' stamp: 'cmm 12/6/2004 23:25'!
signalDoc: aMauiDoc
	(self doc: aMauiDoc) signal! !

!MauiUserError methodsFor: 'accessing' stamp: 'cmm 12/6/2004 23:23'!
doc
	^ doc! !

!MauiUserError methodsFor: 'accessing' stamp: 'cmm 12/6/2004 23:23'!
doc: aMauiDoc

	doc _ aMauiDoc! !

PackageInfo subclass: #MauiPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Info'!

!MauiPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 12/24/2003 13:19'!
prerequisitePackages

	^#('Ma time objects' 'Ma dynamic instance variables')! !

!Text methodsFor: '*maui' stamp: 'cmm 7/8/2004 20:45'!
mauiName

	^ self asString! !

!MailMessage class methodsFor: '*maui' stamp: 'cmm 1/20/2004 23:35'!
mauiBasicApi

	^#(from: empty)! !

!MailMessage methodsFor: '*maui' stamp: 'cmm 1/20/2004 23:47'!
mauiBasicApi

	^#(date time from to cc subject bodyText)! !

!Collection methodsFor: '*maui' stamp: 'cmm 1/26/2004 18:46'!
mauiBasicApi

	^#(size occurrencesOf:)! !

!Collection methodsFor: '*maui' stamp: 'cmm 2/20/2004 17:32'!
mauiName

	| msg |
	msg _ MaTextMessage new.
	msg
		append: (self class name first isVowel ifTrue: ['an '] ifFalse: ['a ']).
		self isEmpty ifTrue: [ msg append: 'empty ' ].
		msg append: self class name.
		self isEmpty ifFalse:
			[ | lowestCommonSuperclass |
			msg append: ' of '.
			lowestCommonSuperclass _
				self
					inject: self anyOne class
					into:
						[ : common : each |
						(each class == common or: [ each class inheritsFrom: common ])
							ifTrue: [ common ]
							ifFalse:
								[ each class maLowestCommonSuperclassWith: common ] ].
			msg 
				appendProperlyPluralized: lowestCommonSuperclass name
				for: self size ].
	^msg messageText! !

!BalloonMorph class methodsFor: '*maui-instance creation' stamp: 'cmm 1/3/2005 17:11'!
contentsMorph: contentsMorph for: targetMorph

	| vertices |
	vertices _ 
		self
			mauiVerticesFor: contentsMorph
			target: targetMorph.
	contentsMorph setToAdhereToEdge: #adjustedCenter.
	^ self new color: targetMorph balloonColor;
		 setVertices: vertices;
		 addMorph: contentsMorph;
		 setTarget: targetMorph! !

!BalloonMorph class methodsFor: '*maui-private' stamp: 'cmm 1/3/2005 17:10'!
mauiVerticesFor: contentsMorph target: targetMorph

	| vertices |
	vertices _ self getVertices: (contentsMorph bounds expandBy: 3@3).
	vertices _ self
				getBestLocation: vertices
				for: targetMorph
				corner: #bottomLeft.
	^ vertices! !

!BalloonMorph class methodsFor: '*maui-private' stamp: 'cmm 1/3/2005 17:03'!
mauiVerticesFor: contentsMorph target: targetMorph corner: cornerName

	| vertices |
	vertices _ self getVertices: (contentsMorph bounds expandBy: 3@3).
	vertices _ self
				getBestLocation: vertices
				for: targetMorph
				corner: cornerName.
	^ vertices! !

!BalloonMorph methodsFor: '*maui-Morphic workarounds' stamp: 'cmm 1/3/2005 17:15'!
mauiAdjustVertices

	self
		setVertices:
			(self class
				mauiVerticesFor: submorphs anyOne  "ugh!!"
				target: target) ;
		setTarget: target! !

!BalloonMorph methodsFor: '*maui-Morphic workarounds' stamp: 'cmm 1/3/2005 18:00'!
mauiTarget
	^ target! !

BalloonMorph subclass: #MauiBalloonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Widgets'!

!MauiBalloonMorph commentStamp: 'cmm 1/6/2005 12:28' prior: 0!
This class exists solely so I can override #delete.  It is the only reliable way, as far as I've discovered, to know when a Morph is being removed from the screen because Morphic provides no hooks for this outside of eToy stuff.  I could not get #outOfWorld: to work properly for me.!

!MauiBalloonMorph methodsFor: 'as yet unclassified' stamp: 'cmm 1/6/2005 12:29'!
privateDelete
	"Unfortunately, I see no easier way to hook when I am deleted reliably (replaceSubmorph:by: doesn't call #delete)."

	super privateDelete.
	self allMorphsDo: [ : each | each mauiNoteOutOfWorld ]! !

MaSingleton subclass: #MauiPrototype
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Domain'!

!MauiPrototype methodsFor: 'as yet unclassified' stamp: 'cmm 7/26/2004 13:42'!
isMauiPrototype
	^ true! !

!POP3Client methodsFor: '*maui' stamp: 'cmm 1/20/2004 23:03'!
mauiBasicApi

	^#(logProgressToTranscript loginUser:password: messageCount retrieveMessage: deleteMessage: quit)! !
MauiNotificationHandler initialize!
MauiFamily initialize!
MauiMessage initialize!
MauiPreferences initialize!
